2017-03-01  jeff  <jeff@jeff-HP-Pavilion-dm4-Notebook-PC>

	* Enhancing 'waiter' schedule:  Get correct 'prep' table, take several orders before serving, wait at counter after serving.

2017-02-05  jeff  <jeff@jeff-HP-Pavilion-dm4-Notebook-PC>

	* Don't allow an object to be placed on a 'solid' tile (ie, ethereal void in SI).

2017-1-13	Dominik Reichardt <dominus@users.sourceforge.net>
	* Implemented a "zoom" feature for map-editing. When in map-edit-mode, not  in
	  fullscreen and using scaler point, Exult will switch between scalevalues 1-8 via 
	  the +/- keys. It will not check whether the new game window is sane but also 
	  won't save the scalevalue to exult.cfg.
	  You can now change brightness (gamma values) with Alt +/- (used to be on +/-)

2016-12-16	Dominik Reichardt <dominus@users.sourceforge.net>
	* exult.cc: the file numbering of the --buildmap option is now in sync with the
	  U7IFIXnn and U7IREGnn (thanks Wjp). This way you can quickly match them, for 
	  example with the charts at http://exult.sourceforge.net/studio.php#ifix_iregs.

2016-11-17	Dominik Reichardt <dominus@users.sourceforge.net>
	* gamemgr/bggame.cc: added map_patches to BG to fix ugly shortcomings of Exult:
	  - In Iolo's hut all sawdust is at z=2 which wreaks havoc with multiple 
	    drawing order in the hut. The original handled this somehow. Perhaps by 
		dropping this to the floor or using the z-buffer for something else in 
		some cases.
	  - Shape 874 should have some transparency in relation to the shapes it covers.
	    It gets used for the towers in Despise and Shame to cover the stairway holes.
		Incidently without the shape it looks much better than the original.
	* gamemgr/sigame.cc: added map_patches to delete the music instruments in the 
	  Skullcrusher mountain walls and the egg that spawns Spiders in the wall 
	  (bug #1740). Spawning monsters in walls is another shortcoming of Exult.


2016-07-16	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Implemented feature #181 "Allow catching aborts".
	  Syntax changes for UCC:
	  Added "throw" command, an alias to "abort" which should be used whenever
	  it makes sense. Both forms accept an optional parameter which is passed 
	  to the handler; if no parameter is specified, Exult will send the text
	  "abort executed" for compatibility with the original games. Examples:
	  	abort;                   // same as abort "abort executed";
	  	throw;                   // same as abort;
	  	throw 1+1;
	  	abort "Error message";
	  	throw varname;           // varname must be a variable or function
	  	throw UI_get_random(18);
	  	abort [1, 2, 3];

	  To handle (catch) an abort/throw, use the following syntax:
	  	try {
	  		// code that can generate an abort/throw
	  	} catch (optvarname) {
	  		// code that handles the abort/throw
	  	}
	  	// Code that gets executed afterwards

	  optvarname is an optional variable name. If present, a variable will be
	  created with this name which will receive the abort/throw's parameter;
	  otherwise, that parameter will be discarded.

	  Note: any class variables declared and constructed in the "try" block may
	  leak if you don't delete it before the abort/throw happens. I have made no
	  effort to handle this case.

2016-06-27	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #1958 "Studio: Selecting mod of a game type doesn't work if there
	  are two same game".
	* Fixed and applied Dominus' and Malignant Manor's patch to include exultmsg
	  in exult.flx.

2016-06-22	Dominik Reichardt <dominus@users.sourceforge.net>
	* fnames.h, gumps/Notebook_gump.cc: an autonotes.txt file in a patch or mod 
	  will override the default and if one is set in the config.

2016-06-16	Malignant Manor <malignantmanor@users.sourceforge.net>
	* usecode/ucxt/src/ucxt.cc: Refactor and add fallback when using -bg or -si

2016-06-15	Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.cc: fix #1950 Paces stuck in Fawn and Rotolunia's Manor

2016-06-13	Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc: fix #1947 Frost Serpents Shout During MageBane Attack

2016-06-12	Dominik Reichardt <dominus@users.sourceforge.net>
	* drag.cc: sound for "too heavy" message - patch by Alagner
	* data/flx.in: there is some yet unidentified problem when mtgm.mid is not at 
	  index #26.

2016-05-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* readnpcs.cc: delete vs delete[] error.

2016-05-13	Phillip T. George <github@me.phillipgeorge.com>
	* Fixed #1925 SI: slain banes hide under carpet (body placement broken) 

2016-05-09	Phillip T. George <github@me.phillipgeorge.com>
	* Fixed #1887 Hang when leaving SI dream world 

2016-05-04	Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.cc: fix comparison between signed and unsigned integer. Fix unused
	  function warnings.
	* imagewin/imagewin.cc: Remove SDL 1.2 code from SDL 2 build.
	* mapedit/*, shapes/fontgen.cc: remove Windows unused parameter warnings.

2016-05-03	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Fix various unused warning specific to SDL2, !HAVE_OPENGL, and Windows

2016-05-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.h, audio/midi_drivers/XMidiSequence.cpp, gumps/Gump.cc: Fixing a
	  handful of dead assignments found by clang's static analyzer.
	* actors.cc, exult.cc, mapedit/execbox.cc: Fixing uninitialized argument
	  warnings from clang's static analyzer.
	* gamedat.cc, gamemgr/modmgr.cc: Fixing delete of static data, found with
	  clang's static analizer.
	* gumps/Face_stats.{cc,h}: Some reformatting. Made Face_stats into a proper
	  singleton-pattern class.
	* *.*: Fixing memory leaks found by clang's static analyzer. The remaining
	  "leaks" it finds are not actual leaks.

2016-04-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/midi_drivers/timidity/timidity_instrum.cpp: Eliminated one case of
	  -Wold-style-cast found by clang static analyzer.

2016-04-29	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* *.*: Eliminating all of clang's -Wunused-private-field. Removed obsolete
	  Uc_response_expression class from UCC.
	* usecode/compiler/uclex.ll: Eliminating -Wunknown-pragmas in clang (it does
	  not have -Wuseless-cast); eliminating -Wunneeded-internal-declaration from
	  clang due to flex' internal yyinput declaration.
	* imagewin/*, usecode/compiler/uclex.ll: Eliminating all of clang's
	  -Wdeprecated-register ("exactly as meaningful as whitespace" according to
	  http://www.drdobbs.com/184403859).
	* imagewin/scale_xbr.h, usecode/ucinternal.cc: Eliminating all of clang's
	  -Wabsolute-value (unsigned - unsigned is unsigned).
	* audio/midi_drivers/XMidiFile.cpp, gameclk.cc: Eliminated all of clang's
	  -Wunused-function.
	* audio/midi_drivers/XMidiFile.cpp, gameclk.cc: Eliminated all of clang's
	  -Wunused-function.
	* audio/midi_drivers/*.cpp, files/zip/zip.cc: Eliminated all of clang's
	  -Wunused-const-variables.
	* mapedit/shapelst.cc, shapes/fontgen.cc: Eliminated -Wold-style-cast which
	  were found by clang.
	* files/zip/*.h,mapedit/studio.h: Fixing clang's -Wmismatched-tags warnings.
	* shapes/data_utils.h: Fixed left-over -Wunused-parameter warnings (found by
	  clang).

2016-04-30	Phillip T. George <github@me.phillipgeorge.com>
	* Fixed #1892 SI: sacrificed Dupre back in party

2016-04-14	Dominik Reichardt <dominus@users.sourceforge.net>
	* *.*: Removed support for using Autotools to build iOS. Better use the 
	  Exult fork at https://github.com/litchie/exult-ios which provides an 
	  Xcode project file to build and run Exult on iOS devices.
	  This also means we no longer have to have special cases for the never 
	  released SDL 1.3 development branch.

2016-04-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* *.*: Adding 'source' config option to both mod cfgs and game config. Its
	  value is the path to usecode.uc that Exult Studio will use when it tries
	  to compile usecode (tools menu). This is also the path given as include
	  dir to ucc. Also made usecode print an error if the destination cannot be
	  opened (for example, due to being in a read-only location).
	  making use of dup2 (when available) for safety.
	* mapedit/execbox.cc: Eliminating all 3 -Wunused-result warnings. Also,
	  making use of dup2 (when available) for safety.
	* *.*: Eliminating all -Wsign-compare warnings not in audio code.
	* files/zip/*.{cc,h}: Starting to make a proper C++ libminizip.

2016-04-14	Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac: The check for clang_on_apple was adding -stdlib=libc++ 
	  which is only available on OS X 10.7 and newer.
	* README, docs/ReadMe.html, docs/xml/docs.xml: Documentation updated with 
	  recent changes concerning Shortcutbar, BeOS and Zaurus

2016-04-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* configure.ac, usecode/compiler/uclex.ll: Supressing -Wuseless-cast from
	  flex-generated code and enabling it with --enable-paranoid-warnings.
	* exult.cc, exultmenu.cc, usecode/compiler/uclex.ll: Eliminating all
	  -Wunused-function and -pedantic warnings.
	* *.*: Getting rid of Zaurus support.
	* *.*: Getting rid of ALPHA_LINUX_CXX flag.
	* configure.ac, hash_utils.h: Fixing unordered_{map,set} detection. Moved
	  clang-on-Apple detection to main configure.ac.
	* m4/ax_cxx_compile_stdcxx*.m4: Updating to newest version.
	* *.*: Eliminating most -Wuseless-cast warnings.

2016-04-12	Malignant Manor <malignantmanor@users.sourceforge.net>
	* keys.cc, keyactions.*, gumps/ShortcutBar_gump.cc : Add
	  target_mode_teleport key binding and comment which key bindings the
	  ShortcutBar_gump would use if rewritten.
	* cheats.cc: Don't set enabled twice.
	* defaultkeys.txt, exult.*, keyactions.*, keys.cc: Remove
	  increase_resolution, decrease_resolution, and associated key bindings.
	  They have been broken for a long time and are not likely to ever be fixed.

2016-04-12	Dominik Reichardt <dominus@users.sourceforge.net>
	* *.*: Removed lingering MACOS defines. Fingolfin removed support seven years 
	  ago in 2b2abd1.

2016-04-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* m4/ax_cxx_compile_stdcxx_11.m4: Making cross-compile work with clang.
	* *.*: Getting rid of BeOS port.
	* m4/ax_cxx_compile_stdcxx_11.m4: Fixing cross-compilation (PPC).
	* server/objserial.h: Fixing compilation on iOS. Hopefully does not cause
	  issues in MinGW...
	* mapedit/*: Eliminating -Woverloaded-virtual warnings by making explicit
	  what is actually going on.
	* mapedit/*: Eliminating some -Wold-style-cast warnings that somehow escaped
	  the purge.

2016-04-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* configure.ac, headers/common_types.h: Trying a better way of setting the
	  integreal types.
	* headers/common_types.h: Fixing compilation by partially reverting commit
	  92dd8740ce6223eea1a6aa55a3533b43f961dde7.
	* mapedit/{npclst,paledit,shapelst}.cc: Eliminating -Wreorder warnings.
	* headers/common_types.h: Prevent redefinition of some types if they already
	  exist. Also, try long long for 64-bit types first.
	* gumps/ShortcutBar_gump.cc: Checking pointers if they are null, instead of
	  greater than zero.
	* cheat_screen.cc, shapes/shapeinf.h: Eliminating (spurious) warnings from
	  -Wuninitialized by explicitly initializing the variables.
	* m4/ax_cxx_compile_stdcxx_11.m4, imagewin/imagewin.*: Fixing issues when
	  compiling C++11 with clang on an Apple OS (basically, Apple does not ship
	  a libstdc++ supporting C++11).

2016-04-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* *.*: Eliminating -Wold-style-cast and -Wcast-qual warnings everywhere but
	  in audio code. Warnings in system headers were supressed with #pragma in
	  GCC, as were warnings in Bison- and Flex-generated code. In a major hack,
	  several GTK macros were redefined to supress warnings in ES code.
	* keyactions.cc: Adding whitespace to account for C++11 literal suffixes.
	* *.*: Deprecating exult_types.h in favor of common_types.h. Fixing several
	  cases where Exult used longs instead of pointer-sized integers to convert
	  pointers to integers (or the reverse); this fails on 64-bit Windows.

2016-04-10	Malignant Manor <malignantmanor@users.sourceforge.net>
	* keyactions.cc: Fix double feeding in ActionUseFood. Add
	  ActionUseHealingItems (use_healing_items key binding) that will use
	  healing potions and bandages.
	* gumps/ShortcutBar_gump.* : Refactor code, fix some warnings, and
	  initialize some variables. Have disk button close gumps. Double clicking
	  food icon will call ActionUseHealingItems. is_party_item is no longer a
	  class function

2016-04-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/Makefile.am: Corrected Gimp plugin deletion when $(EXEEXT) is not
	  empty in automake.
	* m4/ax_cxx_compile_stdcxx_11.m4, .gitignore, Makefile.am, configure.ac,
	  hash_utils.h: Getting rid of -Wdeprecated warnings on newer compilers due
	  to deprecation of std::tr1::unordered_(map|set). This is done by enabling
	  C++11 if compiler supports it, and using straight std::unordered_(map|set)
	  instead.
	* mapedit/*: Getting rid of -Wint-to-pointer-cast warnings by constructing
	  ptrdiff_t before castng (with reinterpret_cast) to pointer.
	* effects.cc: Fixing bug found due to the -Wunused-parameter purge: retpath
	  was incorrectly ignored in one Projectile_effect constructor.
	* imagewin/ibuf16.h: Fixing bug found due to the -Wunused-parameter purge:
	  srcw was used for both width and height in fill8.
	* usecode/intrinsics.cc,usecoede/ucinternal.*: Intrinsics do not need either
	  event or intrinsic parameters, and so they have been removed. The only two
	  intrinsics that used event now just use frame->eventid instead.
	* all: Getting rid of -Wunused-parameter warnings by using a Boost-derived
	  ignore_unused_variable_warning template function.

2016-04-03	Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamewin.cc: Fix crash caused by Face_stats updating during actor read.
	  306c52981888b45b4c4e7daf34973f8fa2c69a5 regression

2016-03-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/contain.cc: Fixing bug #1935 'SI: Odd bug when you select "fight"
	  with a chest in your Inventory...' by skipping over the shape check when
	  dont_check is active. ote: This check may not happen in originals; need to
	  do some investigation.

2016-03-23	Malignant Manor <malignantmanor@users.sourceforge.net>
	* cheat_screen.cc: Allow editing of any npc's magic and mana values.
	* actors.cc, gamewin.cc, party.cc, gumps/Face_stats.*: Don't actively check
	  if Face_stats needs buttons updated. Update Face_stats when magic changes
	  to and from 0.

2016-03-22	Malignant Manor <malignantmanor@users.sourceforge.net>
	* cheat_screen.*: Allow canceling of stat changing. Show magic points and
	  mana when Avatar has 0 mp.

2016-03-21	Malignant Manor <malignantmanor@users.sourceforge.net>
	* usecode/ucinternal.cc: Revert change as it causes issues.

2016-03-20	Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.*, gumps/ShortcutBar_gump.cc: don't have ShortcutBar_gump intercept
	  clicks when in usecode or when waiting for a click.
	* ShortcutBar_gump.cc: Stop double food use in BG.
	* gamewin.cc: Use close_gump instead of remove_gump. Fix copy/paste error.
	* mapedit/u7shp.c, tools/rip.cc, tools/shp2pcx.cc, usecode/ucinternal.cc:
	  Fix leaks
	* imagewin/ibuf16.cc: Fix mismatching allocation and deallocation

2016-03-17	Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamewin.cc: Fix use_shortcutbar not changing when switching between yes
	  and translucent
	* files/databuf.h, files/U7obj.h, mapedit/studio.cc: Add std:: in front of
	  ptrdiff_t required for some compilers to compile.

2016-03-16	Malignant Manor <malignantmanor@users.sourceforge.net>
	* party.cc: Update ShortcutBar_gump when adding/removing party members.
	* data/miscoptions.shp, gumps/MiscOptions_gump.*, gamewin.*, data/flx.in,
	  data/Makefile.am, Makefile.common: AddShortcutBar_gump cfg options to the
	  menu.
	* msvcstuff/Exult.vcproj, msvc9/Exult.vcproj: update for ShortcutBar_gump

2016-03-15	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Add ShortcutBar_gump from https://github.com/litchie/exult-ios fork.

2016-03-14	Dominik Reichardt <dominus@users.sourceforge.net>
	* Various files and documentation changed from SVN to Git.

2016-02-27	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/compiler/Makefile.am: Clean deletes ucparse.hh as well.
	* content/sifixes/{Makefile.am,Makefile.mingw,src/graphics/gumps.in}: Fixing
	  makefiles for SI Fixes.
	* files/zip/{zip,unzip}.cc,tools/rip.cc: Sorting out headers.
	* files/zip/{zip,unzip}.cc,tools/{mklink,rip,wuc}.cc: Eliminating warnings.
	* files/zip/{Makefile.am,zip.cc,unzip.cc},tools/{Makefile.am,mklink.cc,
	  rip.cc,wuc.cc},{msvc9,msvcstuff}/{mklink,rip,wuc,Zip}.vcproj: Making some
	  pure C tools into C++ tools instead.

2016-02-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* game.{cc,h}, gamemgr/bggame.cc, imagewin/ibuf16.cc, imagewin/iwin8.cc:
	  Improving Guardian's lipsynch, as well as fixing palette cycling in the
	  background. Made palette cycles faster on moongate. Also, palette rotation
	  was inconsistent between 8- and 16-bit code.
	* gamemgr/bggame.cc: Guardian lipsynch using original data. This data can be
	  patched in mods: it is in mainshp.flx, entry 15.

2016-02-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamedat.cc: Fixing small memory leaks.

2016-02-07	Dominik Reichardt <dominus@users.sourceforge.net>
	* data/exultmsg*.txt: Added hardcoded French and German subtitles for the 
	  BG final cutscene and added the Spanish localization for both BG and SI.
	  Both French and German subtitles needed control characters and they both 
	  added more lines than we currently support (prefixed with #0x??? for now).

2016-02-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* browser.cc,exult.cc,files/msgfile.{cc,h},gamemap.cc, gamemgr/bggame.cc,
	  gamemgr/sigame.cc,gamewin.cc,gumps/Spellbook_gump.cc,mapedit/shapeedit.cc,
	  mapedit/shapelst.cc,mapedit/studio.cc,objs/objnames.cc,objs/objs.cc,
	  schedule.cc,shapes/items.{cc,h},shapes/shapeinf/weaponinf.cc,
	  usecode/intrinsics.cc: Slightly improving shapes/items.{cc,h}, and making
	  needed changes everywhere. Making exultmsg.txt always be read.
	* gamemgr/modmgr.cc: Allowing multiple co-existing installations of BG, FoV,
	  SI and SS.

2016-02-06	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/midi_drivers/LowLevelMidiDriver.cpp: Undoing mistake in r7530, which
	  undid some of the work of r7529.
	* content/sifixes/*: SI Fixes: Fixed spell incantation runes in spellbook
	  and spell scrolls.

2016-01-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/midi_drivers/LowLevelMidiDriver.*: Hopefully fixed bug #1743 "MT-32
	  SYSEX is wrong - sounds weird". This wasn't solely due to missing sysex,
	  as I had previously thought; some hard-coded rhythms were not uploaded by
	  Exult. DOSBox + Munt allowed me to fetch the relevant data, and confirm it
	  is the same in BG, FoV, SI and SS.
	* audio/midi_drivers/LowLevelMidiDriver.cpp: Fixed bug #1715 "MT-32: sysex
	  is not delayed properly (exc. buffer overflow)" by doing what colourless
	  did not want to do.
	* mapedit/exult_studio.glade, mapedit/shapeedit.cc: Fixed bug #1915 "Exult
	  Studio bug - Equip Rec#: on npc monster tab limited to 100" by increasing
	  limit to 255, the maximum that the file formats allow. Also limited the
	  creation of new records to this.
	* gamemgr/sigame.cc: Fixed bug #1893 "SI: final cutscene without subtitles".
	* schedule.cc, usecode/ucinternal.cc: Make Schedule::try_proximity_usecode
	  queue the usecode call with a script since this function can be arrived at
	  from within usecode. This allows removing an existing  hackish workaround
	  for BG, as well as fixing bug #1901 "SI: Flicken conversation vanishes at
	  times".

2016-01-29	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* content/bgkeyring/*: Some minor usecode cleanup.
	* usecode/compiler/Makefile.am: Workaround for compilation error due to
	  boneheaded automake 1.12 decision; fixes bug #1761 "missing ucparse.h".

2015-03-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/animate.cc, shapes/shapeinf/aniinf.cc: Fixed bug #1909 "[BG] Minoc
	  sawmill messed up".
	* content/bgkeyring/src/npcs/{gordon.uc,tory.uc}: Fixed bug #1907 "[BG+FoV+
	  BG Keyring] tory.uc & gordon.uc".

2015-01-27	Malignant Manor <malignantmanor@users.sourceforge.net>
	objs/egg.cc: Remove r7474 changes to Weather eggs due to crash on exit and
	 the fact that it didn't do a good job of fixing the bug bug #1865.
2015-01-27	Malignant Manor <malignantmanor@users.sourceforge.net>
	*gumps/AudioOptions_gump.cc: Fix crash from deleted pointer being referenced

2015-01-22	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* content/bgkeyring/src/npcs/menion.uc: Fixed bug #1904 "[BG:FV + BG Keyring
	  MOD] add & case in code not being used. file: menion.uc ".
	* shapes/font.cc: Fixed bug #1903 "Uppercase in usecode with '^' (Caret)".
	  Also fixed mismatch between paint_text_box and find_cursor with regards to
	  the caret.

2015-01-14	Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac, acinclude.m4: Better handling of SDL 1.2x and SDL2.
	  Configure will find either version when only one is installed and 
	  will default to SDL 1.2x when both are installed. Use the configure 
	  switch --with-sdl=sdl12,sdl2 to force a version. Thanks to wjp for
	  battling autoconf!

2015-01-06	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* data/{bg,si}/shape_info.txt, mapedit/{exult_studio.glade,shapeedit.cc},
	  objs/egg.*: Fixing bug #1896 "Campfires should hurt".
	* exult.cc: Useless .c_str() call.
	* content/sifixes/src/misc/inn_keys.uc: Fixed bug #1890 "SI FIXES: No
	  possibility to use the swith on room 4 in Sleeping Bull".
	* content/sifixes/src/misc/resurrect.uc, content/sifixes/src/npcs/gwenno.uc:
	  Fixed bug #1895 "SI Fixes: Disappearing Gwenno".

2015-01-06	Dominik Reichardt <dominus@users.sourceforge.net>
	* content/islefaq/*: fixed the island mod. Gave Colourless a ghost body, 
	  Nadir's schedule changed to patrol instead of pacing (we might have a 
	  bug there, he walked all over the map), fixed the position of the penguin 
	  statue, Amy's face will now properly show during the FAQ quest, and 
	  little usecode fixes.

2014-12-20	Dominik Reichardt <dominus@users.sourceforge.net>
	* shape_info.txt: Campfire (BG) and fire (SI) added to fire fields.
	* objs/egg.cc: Fields need to hurt any actor, not just the avatar/party.
	  Campfire (shape 825) frame 0 is burnt out and shouldn't cause damage. 
	  Testing with the original's item creator cheat revealed that the original 
	  seems to have confused frame 0 with frame 8.

2014-12-17	Dominik Reichardt <dominus@users.sourceforge.net>
	* cheat_screen.*: The teleport cheat screen now supports hexadecimal coords
	  and is now finished.
	
2014-12-16	Dominik Reichardt <dominus@users.sourceforge.net>
	* cheat_screen.*: The teleport cheat screen now supports geographic coords.

2014-12-13  jeff  <jeff@jeff-HP-Pavilion-dm4-Notebook-PC>

	* schedule.cc: Fix for bug 1891 - Desk schedule cleans up after itself now.

2014-12-11	Dominik Reichardt <dominus@users.sourceforge.net>
	* cheat_screen.*: Added display of geographic coordinates to the cheat screen.
	  Also begun work on the teleport cheat screen, teleport to dec coords and NPC
	  is working.

2014-11-20	Dominik Reichardt <dominus@users.sourceforge.net>
	* data/exultmsg.txt, shapes/items.h: added the subtitle texts of SI's end scene.
	  No idea how to actually display those when speech is disabled.

2014-11-17	Dominik Reichardt <dominus@users.sourceforge.net>
	* schedule.cc: temporarily fixed bug 1891 - the desk schedule was adding too 
	  many desk items to the NPCs inventory and never cleaned up, which was causing 
	  problems. For now only add 1 item - but maybe desk schedule needs to be 
	  redone similar to lab or waiter schedule (not adding items to the inventory 
	  but creating out of thin air).

2014-08-30	Dominik Reichardt <dominus@users.sourceforge.net>
	* audio/midi_drivers/forked_player.h: disabled forked midi since "using forked 
	  is a very bad idea" (wjp) and people were having crashes due to it. Thanks 
	  to i30817 for the patch. Someone else may remove it completely.
	* audio/midi_drivers/MidiDriver.cpp: moved FMOpl Midi driver to the top of the 
	  list as it should always work right away. Thanks to i30817 for the patch.

2014-07-29	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Makefile.mingw: Remove code from accidental commit.

2014-07-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/compiler/ucexpr.cc: Fixed regression in usecode compiler from bug
	  #1879 "Keyring: healing and resurrecting broken".

2014-06-13	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/egg.cc: Fixing bug #1865 "(Anti magic/sparkle) Weather takes too long
	  to change": weather eggs now reset weather when they are deleted, which
	  matches the original's behavior.
	  Fixing bug #1848 "SS: Broken traps in Abandoned Outpost". Behavior seems
	  to match original, but I have no idea if this breaks other things or not.
	* configure.ac: Removed a couple of options in paranoid-warnings.

2014-05-10	Dominik Reichardt <dominus@users.sourceforge.net>
	* audio/midi_drivers/CoreMidiDriver.cpp: added stdout message when CoreMidi 
	  destination is not available and default is used.
	* updated documentation and FAQ
		
2014-04-29	Dominik Reichardt <dominus@users.sourceforge.net>
	* audio/midi_drivers/CoreMidiDriver.cpp: On OS X if you have more than 
	  one MIDI device (real as in more than one Roland device or software as in MUNT)
	  you can now tell Exult which one to use via setting audio/midi/coremidi_device
	  in exult.cfg. Stdout prints the device IDs and names when you use the CoreMidi
	  midi driver. Thanks to Qbix of DOSBox and Digitall of ScummVM for most of
	  the code.

2014-03-24	Dominik Reichardt <dominus@users.sourceforge.net>
	* gumps/AudioOptions_gump.cc: changing audio settings during playback of 
	  non-looping music tracks flagged these as looping - fixed by i30817

2014-03-23	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Fix timing issue that could cause the Guardian's intro speech not to play.

2014-03-11	Malignant Manor <malignantmanor@users.sourceforge.net>
	* actorio.cc: Fix might timer not being started when reloading a saved game.

2014-03-02	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Audio/Midi.cc, gamewin.*, gumps/AudioOptions_gump.cc: Stop music when
	  music conversion changes. Don't stop music when the midi driver changes
	  and oggs are playing. Don't try to play bg tracks if the settings aren't
	  capable of playing them properly.

2014-02-05	Dominik Reichardt <dominus@users.sourceforge.net>
	* usecode/ucinternal.cc: fixed regression from rev.7458 which crashed at the 
	  SI lightning storms - thanks wjp for finding the fix
	
2014-01-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* combat.cc: If there are no awake enemies nearby, AI will now gladly mop up
	  any sleeping foes around.
	* objs/egg.cc: Fixed bug #1874 "Fireball/Explosion trap triggers to late,
	  fires too long" by using weapon range as trap range and extending how far
	  offscreen traps can be and still fire.
	* objs/contain.cc,usecode/ucinternal.cc: Fixed bug #1863 "Delete intrinsic
	  needs to be able to find stuff in locked containers" by allowing locked
	  containers to have their contents searched and counted. This allows Elynor
	  to find and delete the contents of the sealed box. Also, reverted the hack
	  from revision 7438.

2014-01-28	Malignant Manor <malignantmanor@users.sourceforge.net>
	* audio/AudioMixer.cc: Fix uninitialized audio buffer in SDL 2.

2014-01-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/chunks.cc: Added ugly hack to fix relative ordering of Y shapes and
	  Y depressions in SI Discipline shrine.
	* gamewin.cc: Added ugly hack to make Y depressions not clickable, so that
	  they can't be dragged and so that they do not prevent you from dragging a
	  Y shape.
	* usecode/ucinternal.cc: Added ugly hack to allow disarming the trap at the
	  temple of discipline. These 3 hacks "fix" bug #1855 "SI: Discipline Shrine
	  Quartz Y-shape trap cancel broken".
	
2013-12-18	Dominik Reichardt <dominus@users.sourceforge.net>
	* audio/Midi.*: added a check for true mt32, fakemt32 and mt32emu.
	  Thanks to wjp for his help
	* gamewin.cc: with this check made sure the background sfx tracks 
	  are only played by those. Fixes bug #1872
	
2013-12-11	Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac, data/makefile.am, usecode/ucxt/data/makefile.am:
	  while cross compiling you can add a native built expack and head2data to the
	  path or point to them vie EXPACK and HEAD2DATA environment variables. This
	  should make cross compiling for iOS and other targets less annoying.

2013-11-21	Dominik Reichardt <dominus@users.sourceforge.net>
	* documentation, FAQ updated. Added Crowley's ifix/ireg reference chart to 
	  the Studio documentation.
	
2013-11-01	Dominik Reichardt <dominus@users.sourceforge.net>
	* usecode/ucinternal.cc: reenable the automatic Time Lord speech after
	  destryoing the generators. This was somehow broken 12 years ago. Thanks
	  to Marzo for finding this kludge.
	
2013-10-23	Dominik Reichardt <dominus@users.sourceforge.net>
	* effects.cc: anti magic storm egg was not recognized. Thus anti magic 
	  rain in the generators and the generators wasn't working correctly.

2013-10-21	Malignant Manor <malignantmanor@users.sourceforge.net>
	* usecode/ucinternal.cc: restrict container content deletion to BG
	  (un)sealed box. Fixes bug #1862. r7436 regression. The UI_remove_item
	  doesn't delete contents in SI. The (un)sealed box restriction may not be
	  needed for BG but I can't test all cases.

2013-10-10	Malignant Manor <malignantmanor@users.sourceforge.net>
	* combat.cc: Fix r6914 regression that caused party members to attack each
	  other after friendly fire occurred
	* usecode/ucinternal.cc: UI_remove_item now removes the contents if it
	  deletes a container. This stops the scroll from being in your inventory
	  when you deliver the package to Elynor.
	* schedule.cc: Fix crash caused by find_desk_items in desk schedule

2013-10-03	Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.cc: Don't build the patrol code that starts at the nearest egg
	  since it will break some npcs like the automaton (npc 160) in Freedom.
	* Makefile.mingw: Don't build OpenGL scaler if using SDL2 (not yet updated)

2013-09-29    <jeff@mini.nerble.net>
	* Don't have an NPC on the Desk_schedule pick up parrots.

2013-09-02	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* exult.cc: Fixed SetIcon transparency for SDL2

2013-09-01	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* exult.cc, gamemgr/bggame.cc, gamemgr/sigame.cc, gumps/Gump_manager.cc, imagewin/imagewin.cc: Some fixes to allow SDL2 iphone compilation -- get a bunch of undefined references with the SDL2 library for some reason.

2013-09-01	Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.cc: Fix ES drag and drop with SDL2 (only tested Win32)
	* Makefile.mingw: Added SDL2 define so SDL2 can compile
	* sdl-compat.h: Added SDL_putenv (at least temporarily). I don't even know
	  if the variables we use still work.
	* gamemgr/bggame.cc, gamemgr/sigame.cc, gumps\Gump_manager.cc:
	  Fix converting to non-pointer type 'int' from NULL warning

2013-08-31	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* exult.cc: SDL2 SetIcon looks correct now.  However the workaround is NOT optimal.  Seems like there's no way to get a paletted surface working right in SDL2... but I'm probably just missing it.

2013-08-31	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* exult.cc: SDL2 SetIcon fix (hopefully) for Windows.  Icon still looks as ugly as sin in Linux.

2013-08-30	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* imagewin/imagewin.cc: Applied Malignant Manor's fix for SDL2 window resizes.  Added NULL-check instead of using test variable.
	* gamemgr/bggame.cc, gamemgr/sigame.cc: Fixed text input for initial BG and SI game screen for SDL2
	* gumps/Gump_manager.cc: Fixed text input for save screens and such for SDL2
	* drag.cc: Fixed crash when dragging items for SDL2
	* audio/midi_drivers/LowLevelMidiDriver.cpp, audio/midi_drivers/LowLevelMidiDriver.h: Added a quit_thread flag -- really only used for SDL2

2013-08-28	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* exult.cc: Fixed SetIcon (mostly...) for SDL2 for non-OSX platforms
	* sdl-compat.h: Added SDL2 define for SDL_UpdateRect; Added SDL2_INITIAL_FILL for background color
	* imagewin/scale_point.cc: Removed many ifdefs for UpdateRect SDL2
	* imagewin/imagewin.cc: Fixed errors with creating windows, textures, and surfaces for SDL2 in some cases; Changed initial SDL2 color fill to SDL2_INITIAL_FILL

2013-08-27	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* sdl-compat.h, imagewin/imagewin.cc, imagewin/imagewin.h: Some SDL2 fixes ... no longer crashes EVERY time.  If you disable scaling entirely, it will actually show SOME output.

2013-08-26	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* sdl-compat.h, imagewin/imagewin.h, imagewin/imagewin.cc, gamemgr/bggame.cc, gamemgr/sigame.cc, imagewin/scale_gl.cc, imagewin/scale_point.cc, exult.cc, audio/midi_drivers/LowLevelMidiDriver.cpp, game.cc, gumps/Gump_manager.cc, gumps/Notebook_gump.cc, drag.cc, gamewin.cc, mouse.cc, keys.cc, txtscroll.cc: Working on SDL2 code -- compiles but does not work! (does not affect existing pre-SDL2, or should not anyway)

2013-08-25	Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamemgr/sigame.cc: Add missing SDL 1.3 code change to SI_Game::new_game

2013-08-25	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* audio/midi_drivers/XMidiFile.cpp: Fixed issue where iOS would not compile when doing armv7

2013-08-24	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* Info-ios.plist.in: Added for iOS Info.plist file
	* Makefile.am: Modified to include Info-ios.plist and new target iosbundle
	* configure.ac: Updated to include Info-ios.plist

2013-08-24	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* configure.ac: Updated for newer locations of XCode installs (for iOS)
	* sdl-compat.h: Updated to handle SDL_GetKeyState for SDL 1.3 (for iOS) 
	* drag.cc: Added sdl-compat.h to prevent SDL 1.3 failure on SDL_GetKeyState

2013-07-28 Marzo Sette Torres Junior <marzojr@yahoo.com>
	* content/sifixes/src/items/bucket_cure.uc: Fixed bug #1856 "SI Fixes:
	  Discipline water / Gwenno".
	* objs/egg.cc: Fixed bug #1848 "SS: Broken traps in Abandoned Outpost".
	* content/sifixes/src/cutscenes/fawn_trial.uc: Use symbolic constant.
	* usecode/compiler/basic_block.h: Handle all opcode cases.
	* usecode/compiler/{test1.uc,ucdefs.h}: Updating test usecode.
	* usecode/ucxt/src/ucfunc.cc: Output local statics with an 'l' prefix.
	* usecode/compiler/ucparse.yy: Allow implicit pushing of 'item' for original
	  usecode function calls.
	* schedule.cc: Fixed bug #1847 "SI: Ghosts in cave talk as Chaos Hierophant"
	  using Dominus' workaround.

2013-05-15 Dominik Reichardt <dominus@users.sourceforge.net>
	* keyactions.cc: different messages for toggling fullscreen mode

2013-05-13	Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc: Fix charmed_more_difficult breaking double clicking on npcs
	  (r7343 regression)

2013-04-12 Dominik Reichardt <dominus@users.sourceforge.net>
	* schedule.cc: fixed looping change of patrol schedule to patrol in SI, setting 
	  it to loiter instead if preset schedule is patrol or if there are no presets.
	* gamewin.cc: only allow background sfx tracks for oggs and MT32Emu. The tracks
	  do not play nicely for normal midi devices. Should probably be allowed for
	  MT32 and FakeMT32 conversions as well.

2013-04-03 Dominik Reichardt <dominus@users.sourceforge.net>
	* usecode/ucinternal.cc: reverted fix for "error case of opcode CALLMS" of 
	  rev. 7363 to fix keyring in BG Keyring mod.
	
2013-02-24  Malignant Manor <malignantmanor@users.sourceforge.net>
	* Fix bug where any npcs would attack the Avatar when attack_avatar was
	  called and there are no guards in the area. Also don't have npcs with the
	  guard shape automatically attack in attack_avatar if in a dungeon.

2013-02-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/compiler/ucparse.yy: Eliminated needless sprintfs.

2013-02-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/*: Changed CMPG and CMPL opcodes to CMPGT and CMPLT. Fixed usecode
	  stack buffer overrun (with potentially disastrous results) implicit in the
	  CALLE/CALLE32/CALLO opcodes. This bug also caused the CALLO opcode to fail
	  for functions with parameters. Eliminated spurious output when "adding" a
	  negative number of items to the stack. Fixed bug in UCXT that caused the
	  output of -fs to not print many things in the event of a stack underflow
	  (as happens on function 0x329 in BG/FoV, function 0x91F in SI and function
	  0x939 in SS). Improved handling of CALLE/CALLE32/CALLO opcodes in UCXT.
	* docs/usecode_bugs.txt: Documented SS function 0x939 bug and its fix.
	* content/sifixes/*: Fixed bug in function 0x939.

2013-02-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/shapelst.cc: Looking for shapes within two pixels of the clicked
	  position in ES to allow selection of empty shapes.
	Rev 7363
	* Makefile.*, docs/*, msvc9/*, msvcstuff/*, tools/{Makefile.am, ucdump.c, 
	  wud.cc}, usecode/(bg|si)intrinsics.h, win32/exult_tools_installer.iss:
	  Removing wud and ucdump tools in their entirety as it is overkill to have
	  3 independent usecode disassemblers.
	* tools/wuc.c, tools/uctools.h: Added WUC support for all opcodes (until we
	  either have a better usecode assembler or a decompiler that generates UCC-
	  compilable output). Renamed output of a few opcodes (see changes to UCXT,
	  below). WUC can't generate a symbol table or class vtables, so classes are
	  unlikely to work anyway.
	* usecode/ucinternal.cc, usecode/ucsymtbl.*, usecode/compiler/*: Check for
	  symbol table presence was moved to static member of Usecode_symbol_table
	  class. Removed several essentially blank lines. Fixed error case of opcode
	  CALLMS. Added better 'call indirect with parameters' opcode (as 0xd4) and
	  deprecated old opcode 0xd3. Made opcodes into an enum, which includes all
	  opcodes.
	* usecode/ucxt/*: Made UCXT disassembly output fully compatible with WUC; in
	  general, this was done by chamnging the output to match WUC, but in some
	  cases, the reverse happpend and in some cases both UCXT and WUC names were
	  changed to be similar to UCC opcode names. Added support for symbol tables
	  and virtually all opcodes from Exult/UCC; this is still experimental since
	  external functions declared but not defined in the loaded usecode file (as
	  happens in UCC-compiled usecode files) cause assertion failures for now.
	  Opcode 0x56 (UC_CALLM) works partially as it needs information which can't
	  be easily obtained, while opcode 0xd4 (the deprecated 'call indirect with
	  parameters' opcode) is not handled at all. Deprecated opcodes.txt in its
	  entirety as it was out of synch and harder to extend than u7opcodes.data.
	  'var rr;' no longer printed, as it is not used anymore. Fixed several of
	  the 'FIXME's. Fixed bug introduced in Rev 7328 when fixing bug #1205910
	  "UCXT: Parameter order reversed in function definitions".
	* usecode/ucxt/makefile.unix, ucxt/data/opcodes.txt: Removing unused files.
	Rev 7365
	* usecode/ucxt/data/u7opcodes.data: Incorrect data for callind disassembly.
	* usecode/compiler/ucfun.cc: Functions with a single basic block were being
	  incorrectly optimized if they ended with a return statement.
	* usecode/compiler/basic_block.h: Using UsecodeOps enum.
	* content/sifixes/src/header/si/si_npcs.uc: Extraneous space in comment URL.
	Rev 7366
	* all: Moved opcodes.h to usecode directory. Usecode_internal::run now uses
	  the enum values from opcodes.h on switch statement.

2013-02-01	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/midi_drivers/MidiDriver/*, conf/Configuration.*: Eliminating extra
	  string copies.
	* audio/midi_drivers/FluidSynthMidiDriver.cpp: No need for c_str().

2013-01-31	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gumps/Newfile_gump.cc, usecode/ucdisasm.cc: Fixing clang warnings.
	* files/utils.h: Performance: using const string reference instead.
	* tools/wuc.c, ucxt/src/ucfunc.cc, ucxt/data/u7opcodes.data: Making UCXT -fa
	  output compatible with WUC.
	Rev 7360
	* content/bgkeyring/src/items/magic_carpet.uc: Magic carpet could be rolled
	  while landing.

2013-02-01 Dominik Reichardt <dominus@users.sourceforge.net>	
	* configure.ac, hash_utils.h: Fixed detection of hashmaps
 	  and hashsets for OS X PPC builds.
	* audio/midi_drivers/timidity.*: rename LITTLE_ENDIAN -> 
	  TIMIDITY_LITTLE_ENDIAN to avoid portability issues.
	  
2013-01-31	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* configure.ac, hash_utils.h, Makefile.mingw: Improved detection of hashmaps
	  and hashsets: in order of preference, configure will now look for the TR1
	  hash maps/sets (preferred on GCC 4.3+), then for "ext/hash_(map|set)", and
	  finally "hash_(map|set); if none are found, DONT_HAVE_HASH_(MAP|SET) will
	  be defined so compilation does not fail. MinGW builds will now make use of
	  tr1 unordered maps/sets. xBR scalers are no longer markes as experimental
	  in MinGW.
	Rev 7353
	* audio/AudioChannel.cc: Eliminating warnings.
	Rev 7354
	* all: Eliminating warnings (mainly from Win32 builds).

2013-01-30 Dominik Reichardt <dominus@users.sourceforge.net>	
	* audio/midi_drivers/CoreAudioMidiDriver.*: better error handling by Marzo,
	  fixed USE_DEPRECATED_COREAUDIO_API define to make Exult run on PPC OS X
	  again, fixed copyright headers.
	* audio/midi_drivers/CoreMidiDriver.*: fixed copyright headers.
	  
2013-01-29 Dominik Reichardt <dominus@users.sourceforge.net>	
	* configure.ac, audio/midi_drivers/CoreAudioMidiDriver.*: switched to AUGraph, 
	  synchronized with ScummVM's CoreAudio MIDI driver. Added two frameworks 
	  needed for that.
	  
2013-01-28 Dominik Reichardt <dominus@users.sourceforge.net>	
	* audio/midi_drivers/CoreAudioMidiDriver.*: ripped out code that went into 
	  the CoreMidiDriver a long time ago.
	  
2013-01-27	Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.*: charmed_more_difficult was updated for new charmed alignment.
	  charmed_more_difficult will now only put charmed party members into combat
	  when not in combat mode.

2013-01-26	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Clearing frame_time when avatar and NPCs aren't performing an
	  action (since actions force a delay at the end to prevent skipping steps).
	  When clearing casting frames, add them as dirty before changing mode so
	  they will be cleared from the screen.
	* effects.cc: Fixed Death Vortex and Energy Mist. Fixed missile drops.
	* exult.cc: SetIcon is unused on MacOSX. Deprecated literal conversion to
	  char * in Windows and Mac OSX. Variable last_fps is debug-only.
	* conf/Configuration.cc: Spacing.
	* files/zip/*.c, audio/midi_drivers/FMOplMidiDriver.cpp: Clang noise.
	* imagewin/manip.h: Uninitialized variable being assigned to itself.
	* imagewin/scale_xbr.h: Fixed forward declaration.
	* tools/wuc.c: Missing initializers.
	* usecode/ucdisasm.cc: 32-bits is 8 hex digits.
	* usecode/ucinternal.cc: Usecode_Trace and Usecode_TraceReturn are used only
	  in debug.
	* usecode/ucxt/*/*: Portability: typeof is GNU extension.
	Rev 7341
	* Makefile.common: Duplicate "-o $(@)" in libsmooth_stream.
	* gamewin.cc: Added some sanity checking to shut up spuriours warnings from
	  compiler in ireg object loading.
	* objs/egg.cc: Eliminating useless code.
	* shapes/pngio.cc: Eliminating clobbering warning.
	* all others: Removing unused-but-set variables.

2013-01-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/midi_drivers/FluidSynthMidiDriver.*: Eliminated warnings. Added the
	  ability to specify multiple soundfonts for FluidSynth in exult.cfg which
	  will make use of FuildSynth's soundfont stack. Soundfonts are specified in
	  the fluidsynth_soundfontN keys (N = 0 to 9) which are loaded in numerical
	  order (0 first), plus the old fluidsynth_soundfont key, which loads after
	  all others.
	Rev 7338
	* files/listfiles.cc: Fixed memory leak on Amiga and MorphOS. Would be good
	  to be able to test...
	Rev 7339
	* files/snprintf.cc: Fixed spacing.
	* imagewin/savepcx.cc: Removing no longer needed using directives.
	* imagewin/*.h: Synchronized comments with code.
	* mapedit/*: Removed a handful of warnings. Fixed GtkTreeIter memory leaks.
	  Close all windows, unload all data, free all memory and switch out of the
	  groups tab when switching games or mods. These changes fix bug #3136375
	  "Exult Studio crash, Groups tab doesn't update on game change".

2013-01-24	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* keys.cc: Missing is_movement initializer for ActionScrollLeft. Warnings.
	Rev 7332
	* all: Eliminating more warnings.
	* imagewin/savepcx.cc: malloc/free to new[]/delete[].
	* audio/midi_drivers/mt32emu/freeverb.h: Updated handling of denormals.
	Rev 7333
	* all: Eliminating more warnings.
	* audio/midi_drivers/fmopl.cpp: malloc/free to new[]/delete[].
	* audio/midi_drivers/timidity/timidity.cpp: Reformatted for more consistent
	  spacing.
	Rev 7334
	* audio/midi_drivers/mt32emu/*: Last MT32Emu warnings I will eliminate until
	  bug #3149070 "MT-32: sysex is not delayed properly (exc. buffer overflow)"
	  is fixed.
	Rev 7335
	* gamedat.cc: Fixed regression from rev #7332 causing corruption on the save
	  screen.
	Rev 7336
	* usecode/ucinternal.cc: Also print usecode function number in debug tracing
	  if the function has an associated name.

2013-01-24	Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/Gump_manager.cc: Fix main_actor_can_act check that could be bypassed
	  if double click closes gumps was disabled.
	* exult.cc, gumps/Gump_button.h, gumps/misc_buttons.h: Allow left clicking
	  on a check mark even when the Avatar cannot move. This fixes bug
	  #3598889 "HP < 1 will not allow you to close gumps with the check mark".

2013-01-23	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: A few improvements to charm alignment, which is now generally
	  updated when alignment is and the NPC is not charmed. Inverted rev #7300
	  so that only goblins in goblin ville are always on the lookout for foes.
	  This matches the originals, in which only combat and patrol schedules will
	  seek foes and fixes bug #3601595 "Bee's in Bee Cave Hostile before picking
	  up honey".
	Rev 7323
	* gamewin.cc: Fixed bug #3601596 "Music in Bee Cave conflict".
	Rev 7324
	* actions.*: Improved pickup/put down action to show the standing frame at
	  the end. Added new action to change the shape, frame and quality of a game
	  object.
	* paths.*: Added pathfinder to approach an object or actor that takes into
	  consideration the size of the destination.
	* actors.*: Added optional override for schedule location. This is mainly
	  useful for street maintenance schedule, so the NPC continues from where he
	  left off.
	* schedule.*, shapes/items.h, usecode/usefuns.h: Added 3 static methods to
	  Schedule class: one to procure an item (tries inventory first, then tries
	  to find a match nearby, then creates it as a last resort); one to create
	  a pick-up action sequence; and one to scan for the closest object in the
	  given object vector. Added light sources to street maintenance schedule,
	  so candles will be lit/put out/replaced as needed. Street maintenance will
	  now return the NPC to his/her pre-street maintenance position (for patrol
	  schedule mainly). Pace schedule no longer checks for street maintenance.
	  Patrol schedule now starts from the nearest path egg as a workaround to
	  fix the automaton at Freedom when saving/reloading (until saving the state
	  of schedules is implemented). Patrol schedule reanalyzed and updated; only
	  missing are 'kneel at tombstone' (which dropped flowers at tombs in BG but
	  not in SI, as there are no tombs), and 'wait for semaphore' and 'release
	  semaphore' activities, as they are all unused in the original (see their
	  comments for more on them). Most notably, patrol should work identically
	  to the original games except for 'repeat forever' (which works around a
	  few quality bugs in BG's Isle of the Avatar pirate fort) and 'horiz. pace'
	  which did not work in the original. Fixed a list corruption bug with the
	  patrol hammer. Implemented hard-coded ugliness in SS maze for usecode path
	  eggs in patrol schedule.
	Rev 7325
	* gamemgr/modmgr.*: Eliminating warnings.
	* Makefile.{am,common}, usecode/ucxt/src/*: Making UCXT use the GameManager
	  class if loading from config file.
	Rev 7328
	* usecode/ucxt/data/u7opcodes.data: SETR opcode should also set the return
	  flag.
	* usecode/ucxt/src/ucfunc.cc: Adding output of the void, shape# and object#
	  qualifiers in function declarations. Labels are now unindented, with all
	  of the code in functions being idented at 1 tab. Fixed bug #1205926 "UCXT:
	  Functions with no params are decompiled as having one". Fixed bug #1205910
	  "UCXT: Parameter order reversed in function definitions".
	* all: Performance: using ++it instead of it++ for iterators.
	Rev 7329
	* keys.cc, keyactions.cc: Made "usefood" more useful and shown by default.
	  Key actions of type Action::dont_show will now show under normal keys if
	  they have a supplied optional comment; this fixes bug #3601627 'help gump
	  doesn't show "useitem" commands'.
	* data/bg/defaultkeys.txt: Using improved "usefood" for feeding.
	* data/si/defaultkeys.txt: Removing redundant "usefood" Ctrl+F keybinding.

2013-01-22	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gumps/Spellbook_gump.*: Keyboard controls for spellbook: page up/down will
	  change current page, arrow keys will move the bookmark, home/end will move
	  to first/last page, enter moves to the bookmark.
	* gumps/*.h: Removing some warnings.

2013-01-21	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* content/bgkeyring/*: Healing services were not charging any money.
	Rev 7319
	* all: World-wrapping for finding directions.
	Rev 7320
	* combat.cc: Fixed error introduced in rev 7296, allowing people to keep on
	  attacking turned-invisible foes.

2013-01-20	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* content/makefile_builder.sh: Updated to work without doing a 'clean'.
	* content/{bgkeyring,sifixes}/{README,Readme.txt}: Massive update, clean-up
	  and reformatting.
	Rev 7312
	* combat.cc: Combat music should start if the avatar is targetting an NPC.
	Rev 7313
	* actors.cc: Doing a raw intelligence check causes some animals to be able
	  to open doors; so I am basing the sentince test only on monster intellect,
	  which is 10 for 'default' monster information.
	Rev 7314
	* all: Research into the originals shows that only neutral NPCs and guards
	  call guards -- good NPCs ignore theft, murder and being attacked, evil and
	  chaotic are out for your blood anyway. Based on this, I revamped the call
	  guards/attack avatar bit so only neutral NPCs and guards call guards and
	  NPCs of all alignments help NPCs of the same alignment, while ignoring any
	  friendly fire. Disabled actors no longer call for help -- instead, if any
	  sympathetic witnesses are nearby, they will call for help and assist.
	Rev 7315
	* gamewin.cc: Fixed bug #3601519 "Breaking glass displays results in guards
	  attacking" by having guards try to arrest for theft on all cases.
	Rev 7316
	* all: Alignments are an enum of Actor class, not Npc_actor.
	* gamewin.cc: Crickets are now random, instead of adding large random delays
	  to background music change. Defined private enum for BGM states.
	Rev 7317
	* actors.cc: Partially reverted rev #7304 as it breaks BG intro.
	* monsters.cc: Don't ask for tile before we know we have one (reduces stdout
	  noise).

2013-01-19	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* readnpcs.cc: Fixed bug that caused monster actors to go away instead of
	  resuming their schedule on reload.
	* schedule.*: Created an 'arrest avatar' schedule for guards summoned to
	  arrest a thieving avatar.
	* gamewin.cc: Danger music will override all but combat music. Creating 1-3
	  guards to arrest avatar instead of 1, and all of them use the new schedule
	  to arrest the avatar. Danger music is forced to play when guards approach,
	  as happens on the original. Arrest schedule is considered to be combat for
	  determining if the NPC is hostile. Guards are of chaotic alignment as they
	  are in the original.
	* actors.cc: Arrest schedule does not seek foes. Local guards call for more
	  guards. All together, this fixes bug #3599723 "guards that were called by
	  npcs stop attacking on reload".
	Rev 7309
	* actors.cc, schedule.*: Implemented graze schedule, fixing bug #3601321
	  "Graze schedule not working properly".

2013-01-19	Malignant Manor <malignantmanor@users.sourceforge.net>
	* shape_info.txt: Fix typos that caused books to run the wrong usecode. This
	  fixes bug #3601322 Exploding books in Castle of White dragon don't explode

2013-01-19	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* schedule.cc: Fixing bug #3601456 "NPCs teleport out of bed when woken up".
	  Reduced random delay for Walk_to_schedule as it caused NPCs to stand still
	  for far too long in many cases.
	* actors.*: On schedule restore, party_id hasn't been set for party members
	  yet, so use Actor::is_in_party instead. Also, allow moving to schedule if
	  NPC is sufficiently far away from schedule center on restore. This could
	  cause (say) NPCs to sleep on the wrong bed.
	* gamewin.cc: Fixed bug #3601457 "asleep and paralyzed npcs should not call
	  guards".
	Rev 7304
	* effects.cc: Fixed incorrect checking of prjectile hits, which caused a bow
	  to miss at point blank range sometimes (and likely in other occasions).
	Rev 7305
	* all: Alignment and charm now works like the original: the charmed creature
	  gets the alignment of the person that charmed him (or chaotic if an object
	  did it). Usecode gets/sets charmed alignment if the NPC is not charmed, or
	  the real alignment otherwise. Setting charm flag from usecode sets charmed
	  alignment to good, as in the originals. The charmed alignment is saved and
	  restored. Actor::fight_back should use effective alignment for its tests.
	  Several locations that got the real alignment use the effective alignment
	  now. Chat screen displays alignment (real and effective).
	Rev 7306
	* usecode/intrinsics.cc: Fixed error in previous commit.
	
2013-01-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Audio.cc, audio/AudioMixer.*, objs/animate.*: Fixed bug #3601377
	  'No "gulping" sound when eating food' by having Objct_sfx have clients and
	  remember the last position of the object (or its outer container's). Also,
	  Object_sfx will play until either the position is out of range or until it
	  has played the SFX once, and delete itself afterwards, fixing a leak on a
	  sound effect played with the avatar as the SFX's source.
	* all: Eliminated some warnings.
	Rev 7292
	* objs/animate.cc,usecode/intrinsics.cc: Fixed bug #3601382 "Open book sound
	  happens when closing book" by forcing sounds played from usecode to begin
	  playing right away. Eliminated some warnings.
	Rev 7293
	* exult.cc: Fixed bug #3601383 "Avatar stuck in casting spell pose after
	  casting", a regression introduced in rev #7271. Eliminating warnings.
	Rev 7294
	* objs/objs.cc, objs/iregobjs.cc: Remove object clients before removing them
	  from the map or owner (missing from rev #7291).
	Rev 7295
	* shapes/shapevga.cc: Incorrect flag type in Actor_flags_functor.
	Rev 7296
	* all: Changed alingments to use the names from the original games, as seen
	  in the 'inspect NPC' screen. This means: friendly->good, hostile->evil,
	  unknown_align->chaotic. Added some convenience functions for actors.
	  Eliminated more warnings.
	* schedule.cc:  Changed to correct alignment checking for foes. Only NPCs
	  that can speak will actually say the schedule barks.
	Rev 7297
	* combat.cc: Battle music only changes if there are anyone in the avatar's
	  oponent list; this prevents battle music when attacking a chest.
	Rev 7298
	* schedule.cc:  Talk schedule will not talk to invisible avatar unless the
	  NPC can see invisible. Proximity usecode happens more often for the hound
	  schedule, which will cause the NPC to face the avatar if the NPC is within
	  3 tiles. Avatar will no longer lay down on the ground if double-clicking
	  an occupied bed.
	Rev 7299
	* actor.cc: Checked wjp's CHECKME, and decided to use alignment to decide if
	  the NPC should fight back or not, instead of only party-vs-nonparty. Check
	  is done in Actor::fight_back, and covers the cases mentioned in the (now
	  deleted) comments, as well as a few other possibilities of friendly fire.
	Rev 7300
	* actor.cc: Eliminated both of the !rand()%N lines to make hostile NPCs more
	  more hostile, and consolidated the two checks as they are now redundant.
	* schedule.cc: Increased range of seek_foes, but requiring line-of-sight.
	  These two combined fix most of the issues in bug #2694957 "Non-hostile
	  Hostiles", with a few more fixes to come.
	Rev 7301
	* gamewin.cc: Changed conditions on who can be a witness so (1) the BG royal
	  mint guards can call you up for stealing and (2) mod NPCs can do the same.
	  Evil and chaotic NPCs no longer care if you steal. If an NPC is in hound
	  schedule, he will always be a witness to your crimes. A witness will be
	  changed to the hound schedule, and will keep an eye on the avatar.
	Rev 7302
	* all: Several barks were implemented, for goblins and non-goblins.
	* content/*, data/*, mapedit/*, shapes/shapeinf.h: De-hard-coded what shapes
	  are goblins, including ES. Description of format for actor_flags sections
	  of shape_info.txt files is now correct (was wrong before).
	* actors.cc: Added an ugly hack to handle the neutral goblins in the goblin
	  village by shifting their effective alignment within the boundaries of the
	  village; see the comment in Actor::get_effective_alignment for additional
	  information. This should fix the remaining cases of bug #2694957 "Non-
	  hostile Hostiles".
	* gamewin.cc: Invisible thieving avatar will not be caught (but NPCs will
	  have appropriate barks).

2013-01-17	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Fix crash when a party member dies due to a trap

2013-01-16	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/animate.cc: Using an object's outermost container to determine range
	  for SFX attenuation instead of the object's own position. This fixes bug
	  #3600801 "Unlocking doors and chests missing click sound effect".
	Rev 7278
	* ./content/bgkeyring/src/items/orb_of_the_moons.uc: Fixed bug #3600802
	  "Orb of the Moons - teleport only avatar".
	Rev 7279
	* gamewin.cc, audio/Audio.*, audio/conv.*: Added song number conversion from
	  BG IDs to SI IDs, similar to what was in place for SFX. Fixed bug #3600800
	  "Snow weather effect missing sound effect" and bug #3600838 "Dungeon music
	  not playing upon entering". Also added weather track for rain (song 4).
	Rev 7280
	* mapedit/paledit.cc: Fixed assertion woes, as well as making empty palettes
	  show as all black instead of random colors.
	Rev 7282
	* objs/egg.cc: rand()%1 is always zero; changed to rand()%2.
	Rev 7283
	* files/utils.h, tools/wud.cc: WUD is no longer the unportable mess it was.
	  Eliminated warnings.
	Rev 7284
	* all: Eliminating warnings.
	Rev 7285
	* usecode/intrinsics.cc: Intrinsic path_run_usecode drags party members in
	  BG also (confirmed in originals).
	Rev 7286
	* content/bgkeyring/*: Fixing spellcasting AI by disabling it for the time
	  being. Updating Keyring readme.
	* docs/exult_intrinsics.txt: Updated with changes from quite a ways back.
	Rev 7288
	* combat.cc, gamewin.cc: Fixing bug #2782683 "Background music #10 never
	  played".
	Rev 7289
	* effects.*, usecode/intrinsics.cc: Fixed bug #3186737 "SI: Lightning
	  craziness after body switch. (1.5.0svn)" by only allowing one usecode
	  lightning effect at a time and by forcing usecode lightning to display
	  even while in doors (matches original).

2013-01-12 Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac and all makefile.am files: fixed compiling with current 
	  autotools and removed many autotools warnings.

2013-01-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamewin.cc: Fixing bug exposed by revision 7267 (bug #3600300 "as_npc()
	  causes issues (warning fix regression)") before which the the avatar was
	  being incorrectly cast from Main_actor to unrelated class Npc_actor.

2013-01-10	Malignant Manor <malignantmanor@users.sourceforge.net>
	* all: Eliminate some Cppcheck errors and noise

2013-01-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* all: Collecting all hard-coded usecode functions in separate header until
	  they are properly de-hard-coded. Eliminated warnings. Consolidated  32-bit
	  usecode opcodes with their 16-bit counterparts when they were otherwise
	  identical except for size of data read. Improved string reading functions.
	Rev 7271:
	* all: Made party members less prone to teleporting while trying to sit on
	  barges. This is done by having party members persistently repathfinding if
	  the path is blocked, and by ignoring NPCs that aren't sitting, lying down,
	  etc. when determining if it is possible to reach the seat. Also, some more
	  warnings eliminated. Further, actors no longer move aside when they are on
	  the move. Moreover, party members will also stand at rest after a while,
	  as the avatar does, matching the original games. Finally, the avatar will
	  have bad feelings when saving too often.

2013-01-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actor.*, schedule.cc: Renamed Actor::unready_weapon to Actor::empty_hands,
	  which will now empty both hands. The function tries to place on the belt
	  and backpack slots, trying to add to containers if present, or forcing the
	  slot to accept the item if not. This fixes weapons disappearing on sleep
	  bug. Also, party members will not hide their weapons on sleep.
	* paths.*: Yet more fixes to grabbing.

2013-01-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* schedule.*, usecode/intrinsics.cc: Fixed bug #3599714 "Attacked npcs make
	  their bed before defending themselves". Also fixed bug where NPCs were not
	  too concerned about who they share their beds with -- they could lie down
	  with the avatar. Incidentally, this incidentaly fixes the bug reported in
	  the comments of the aforementioned bug report (avatar making a bed that an
	  NPC took right after the avatar woke up). Improved bed occupancy detection
	  routine allows children to be detected too.
	Rev 7263:
	* actors.cc, schedule.cc: Actor::unready_weapon causes actor to redraw if a
	  weapon has been unreadied. Forcibly remove the weapon from hand if not a
	  party NPC and belt slot is being used. Places where Actor::unready_weapon
	  were called together with Game_object::add_dirty see the latter removed.
	Rev 7265:
	* objs/objnames.cc: Incorrect branch caused undefined behavior.
	Rev 7266:
	* shapes/*: Eliminating warnings.
	Rev 7267:
	* gamewin.cc: Avatar now properly restores into combat if the game was saved
	  during combat. Correct mouse shape is set in all cases.
	* gamewin.*, mouse.*: Eliminating warnings.

2013-01-06	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actions.cc: Fixed Fawn guards sometimes not being able to open doors.
	* actions.*, actors.cc: Prevent schedule changes from stopping intrinsics
	  path_run_usecode and si_path_run_usecode. This fixes avatar not animating
	  to roll bedroll if sleep is cancelled, and maybe a few other things.
	* gamewin.cc: Eliminate double check for avatar paralysis. Sleep schedule no
	  longer prevents avatar from moving (sleep flag does that).
	* paths.cc: More changes to Fast_pathfinder_client::is_grabable, as previous
	  version prevented, for example, the gavel at Spark's from being used.
	* schedule.*: Refactored code common to patrol and pace schedules. NPCs will
	  now make their beds when getting out of sleep schedule. Children are now
	  better positioned in beds.
	* schedule.*, usecode/intrinsics.cc: Fixed bugs #3599106 "beds not working
	  properly again" and #3330452 "Sleeping on the first or higher floor not
	  working correctly" (and comments). Also, double-clicking on beds can now
	  be 'cancelled' by moving away while moving towards the bed, as happens in
	  the originals.
	* actions.*, schedule.*, tqueue.*, usecode/ucsched.*: Const-correctness.
	Rev 7258:
	* schedule.cc: Set sleep flag on avatar too for nap_time intrinsic.
	Rev 7259:
	* paths.cc: Fixed object manipulation regression due to incorrect condition
	  on rev 7257.

2013-01-05	Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.cc: Add back quality check for dough and clear okay_to_take flag
	  since okay_to_take doesn't get saved. This should fix dough not being used
	  after cache out or reload.

2013-01-05	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed dying fish turning into bread then fish by only using the
	  'frame 0 then script to set correct frame' trick if first frame is empty.
	* effects.cc: Fixing bug #3599105 "Cannons don't fire correctly".
	* gamewin.cc: Use c_tilesize/2 instead of hard-coded 4.
	* objs/chunks.cc: Eliminated irrelevant comparison translation.
	Rev 7255:
	* usecode/ucsched.cc: Fixed bug #3598888 "fade out doesn't always fade back
	  in" which was caused by usecode function 0x6fb in FoV killing the script
	  that caused the screen to fade back in. This function will now be delayed
	  until the screen is faded in again.

2012-12-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.*, gamewin.cc, npctime.cc, objs/egg.cc, usecode/intrinsics.cc:
	  Party members no longer heal to full if knocked out when they cache out.
	  UI_clear_item_flag no longer awakens unconscious NPCs (matches original in
	  e.g., BG usecode 0x6bc). Fire fields no longer awaken knocked out NPCs.
	  Mana no longer regenerates quickly for knocked out NPCs. Trying new dead
	  body positioning method. Fixed last commit to not randomly remove the
	  avatar's target.

2012-12-30	Malignant Manor <malignantmanor@users.sourceforge.net>
	Rev 7246:
	* actors.cc, combat.cc: Have the Avatar stop attacking unconscious actors
	Rev 7248:
	* defaultkeys.txt: Fix description of walk keys
	Rev 7249:
	* gamewin.cc: Save/load combat state
	Rev 7250:
	* Fix changelog

2012-12-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exult.cc, keyactions.*, keys.*: Walking and running keys no longer count
	  for the purposes of skipping faces, maps and such, as they could prevent
	  someone from ever seeing the face. Also, enforcing const-ness in KeyBinder
	  class and on key actions.
	Rev 7245:
	* actors.*, gamewin.cc, npctime.cc: Fixed bug #3598886 "HP < 1 should regen
	  faster than per hour".
	Rev 7251
	* data/Makefile.am: Making the expack-generated header files exult_bg_flx.h,
	  data/exult_flx.h, data/exult_iphone_flx.h and data/exult_si_flx.h depend
	  on their respective flex files.


2012-12-29	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapeid.h, shapes/vgafile.*, usecode/conversation.cc: Fixed bug #3001914:
	  "Cutted texts in voiceovers with Speech disabled" [sic] for the guardian
	  in BG. Also, fill whole game area with background color from large faces
	  so SI guardian and serpents cover the whole screen.
	* usecode/conversation.h: Spacing.
	Rev 7241:
	* usecode/conversation.cc: Center BG guardian vertically too.
	* actors.cc: Fixed bug #3186728 "SI: Incorrect property flags? (1.5.0svn)"
	  by applying okay-to-take flag *after* the NPC's stuff is moved to the
	  dead body.
	* gamemap.cc: Make sure okay-to-take flag is read for quantity shapes.
	Rev 7242:
	* actors.cc, gamewin.cc, shapes/items.h: Guards now bark messages when
	  coming to arrest you. People calling guards only yell if they can talk.
	  If there are no guards in the area, people will call for help instead
	  of calling guards. Guards are no longer called in dungeons, and people
	  will not yell for them in such places. This should fix bug #3186715
	  "SI: Automatons in MoF call guards (1.5.0svn)".
	Rev 7243:
	* objs/objs.cc: Added some (disabled by default) tracing facilities to debug
	  render order. One day...

2012-12-29	Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc: Only heal more than 1 hp through mend_hourly if the npc's
	  schedule is sleep.
	  Fix freezing check. Temp of 50 should do damage
	  Allow starving party members to regain health over time if below 0 hp.
	* npctime.cc: Only wake up npcs over time if they have 1 or more hp. (was 0)
	  Do hunger damage check every minute. Hunger does 1 damage instead of 0-2.
	* actors.cc, npctime.cc, Stats_gump.cc: Fix hunger check. Food <= 9 is bad

2012-12-29	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamewin.*: Fixed incorrect calling of ES if mapedit was still on when
	  Exult is closed (caused by rev #7236).

2012-12-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gumps/Gump_manager.cc: Fixing previous fix to not delete gumps when you
	  want to move them.
	* combat.cc: Fixed bug #3594342 "Attacking through walls and doors" by using
	  a center-to-center LOF check.
	* actor.cc: The above fix made apparent a bug that allows party members to
	  cause each other o step through walls and doors by moving aside. Since I
	  haven't isolated the circumstances that cause this, and since it is only
	  likely to happen while in combat, I disabled moving aside while in combat
	  as a workaround (the rationale being that you are too busy fighting to
	  play nice).
	Rev 7230:
	* combat.cc: Reverted changes from rev 7229 to fix bug #3598684 "problems
	  attacking medium and large actors (7229 regression)".
	* paths.cc: Speed improvements for Fast_pathfinder_client::is_grabable.
	  Fast_pathfinder_client::is_straight_path will no longer prematurely quit
	  before the end of the path.
	* rect.h: Truly fixed Fixed bug #3594342 "Attacking through walls and doors"
	  (and who knows how many other bugs).
	Rev 7231:
	* npcnear.cc: Disabling old proximity usecode method. The rabbit hack is not
	  needed anymore since patrol schedule does what it should, so it has gone.
	* schedule.*: Only loiter, tend shop, dance, hound, sew and bake schedules
	  seem to call proximity usecode in the original. This fixes bug #3598581
	  "Barks in Serpents' Isle".
	Rev 7233:
	* schedule.cc: Completing dance schedule (fixes bug #3435764 "Dance Schedule
	  broken". Tweaked odds of proximity barks for dance schedule.
	Rev 7234:
	* paths.*, schedule.cc, pathfinder/PathFinder.h: New Fast_pathfinder_client
	  that checks it the proper way. Fixes issues with ships and beds reported
	  on IRC.
	Rev 7236:
	* gamewin.cc: Eliminating segfault when loading a game if map edit mode was
	  active (due to fixed object deletion).
	* actors.cc: Fixed bugs #3127755 "dead NPC bodies become obstacles" and
	  #3594344 "dead bodies hang in wall - become obstacles", which were caused
	  by the dying NPC blocking the placement of his own body.

2012-12-27	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* all: Removed ungodly amount of uneeded data copies when passing tiles and
	  rectangles around by using const references when possible.
	* effects.cc: Particledrop base class needs virtual destructor.
	* paths.cc: Fixed bug #3597397 "can move objects through the door" by using
	  maximum delta-z of 1 in Fast_pathfinder_client::get_step_cost. SI crystal
	  balls are fixed the "proper" way by trying to get within a radius equal to
	  the object's smallest 2d dimension plus 1 from the object.
	* pathfinder/path.cc: Improved path tracing slightly by having it also print
	  z coordinates.
	* paths.cc: Fixed a few incorrect results for grabbing objects through walls
	  re-introduced in commit #7224.
	* paths.cc: Fixed incorrect blocked objects from commits #7224-#7225.
	* gamewin.h, drag.cc, gumps/Gump_manager.cc: Fixed segfault on dragging a
	  gump and deleting it at the same time (e.g., right click closes gumps).

2012-12-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/*: Fixed longstanding bug in usecode symbol table. Also fixed bug
	  #3011723 "Keyring Mod - targeted NPC spells" by adding a second opcode for
	  indirect function calls with parameters.

2012-12-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* configure.ac: Added an option (--enable-pedantic-warnings) to build with
	  pedantic warnings, which is independent of other warning options. Removed
	  some stray left-overs from GIMP plugin code, and fixed version numbers.
	  Some identation changes.
	* usecode/useval.cc: Fixed bugs #3597062 "Buying reagents from Wis-Sur is
	  broken" and #3597307 "Training in SI broken - result 0 combat points",
	  both due to hard-coding a modulus operator in a generic division/modulus
	  operator.
	* exult.cc: Fixed bug #3597039 "segfault on main menu quit with only Speech 
	  enabled audio".
	* shapeinf/aniinf.cc: Removing dead code.
	* game.cc, gamedat.cc, gamemap.cc, readnpcs.cc, gamemgr/bggame.cc,
	  shapes/miscinf.cc, usecode/ucinternal.cc: Using const reference exceptions.
	  Rethrowing using empty throw to avoid unnecessary copies.
	* windrag.h, files/U7obj.h, shapes/shapeinf.*: More 'correct' assignment
	  operators (ward against self-assignment, non-const return).
	* imagewin/scale_xbr.h: Made template parameters more explicit.

2012-12-17 Dominik Reichardt <dominus@users.sourceforge.net>
	* gamemgr/bggame.cc: Only show the BG intro subtitles when audio and speech 
	  are disabled.
	
2012-12-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/ucinternal.cc: Fixed bug #3596110 '"Your hands are too full" even
	  when carrying no inventory'.
	* objs/contain.*, objs/objs.h: Use bool instead of int for add_quantity.
	* mapedit/shapeedit.cc: Fixed bug #3172487 "Exult Studio crash from removing
	  frame name property". Fixed incorrect pointer initialization. Also fixed
	  incorrect initialization of fields for all vector data if all entries are
	  invalid (e.g., present in static data but deleted in patch) and ensured
	  that treeview rows are only created if the element in question is not an
	  invalid one.
	* tools/expack.cc: Expack now extracts to files with 5-digit numbers, as per
	  #3163084 "Expack cannot repack extracted files using a wildcard"; however,
	  this does not mean wildcards will work in non-POSIX shells. Fixed segfault
	  when extracting from a flex file due to double delete.
	* gamewin.cc: Default back to '(default)' if could not open custom keys or
	  autonotes files. Made alignment and spacing consistent.
	* all: (rev 7211) Made alignment and spacing consistent.
	* all: (rev 7212) Applied patch #3591998 "Fixed compiler warnings".
	* all: (rev 7213) eliminated a few more warnings.
	
2012-12-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Midi.cc: Fixing segfault when you change the Midi device type and
	  disable midi in one go.
	
2012-12-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exult.cc: Reverting revision 7197 as it can sometimes cause the mouse to
	  lock on the center of the screen. A better workaround for touchpad issues
	  for now is to disable full-screen fast mouse.
	* conf/Configuration.cc: Checking for absolute paths after translating any
	  system paths.
	* files/utils.cc: Consolidating some duplicate code. Spaces to tabs. System
	  paths can now be recursively defined, so putting "<HOME>" as a path in
	  exult.cfg will correctly translate if used in the definition of other
	  system paths (if correctly escaping < and > as &lt; and &gt; for XML).
	  Added a few security features for recursive system paths, such as a cap
	  to the recursion depth.

2012-12-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* keyactions.cc: Toggling fullscreen displays a timed popup asking if you
	  want to keep the change or not. If yes, config is saved; if not, then full
	  screen is toggled back.

2012-12-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exultmenu.cc: Fixing now relevant double-free in menu.
	* gamewin.cc: Clear the time queue before deleting unused NPCs (just in case).
	* tqueue.*, objs/animate.*: Fixed leak when loading game while an object is
	  playing SFX through Object_sfx; using time queue for it as it has the only
	  reference to the object.
	* gumps/AudioOptions_gump.cc: Memory leak on two buttons when enabling or
	  disabling audio.
	* gumps/VideoOptions_gump.cc: Double delete: set static variables to zero
	  after freeing them.
	* usecode/conversation.cc: Fixed bug #3001914: "Cutted texts in voiceovers
	  with Speech disabled" [sic].
	* exult.cc, imagewin/imagewin.cc: Missing space in video debug output. Fixed
	  "fill" and "fit" fill modes (and aspect correction) when scale is 1.
	* imagewin/imagewin.cc: Fixed resolution changed oddities from the previous
	  commit while still keeping the fix for scale 1.
	* usecode/ucinternal.cc, usecode/useval.*: Fixed bug #3001289: "Strange
	  things in NPC dialogues", also fixing a couple of bugs in SI usecode.
	* usecode/useval.*: Fixing dumb mistake: std::less is operator<, not operator-.
	* actors.cc: Changed NPCs to leave dead bodies only if they have actual body
	  information (and aren't flagged by monster data otherwise) instead of
	  leaving a default dead body. Fixes the Beatrix part of bug #3186722: "SI:
	  Body issues in Shamino's Castle".
	* usecode/ucinternal.cc: remove_party_items should return 1 only if it has
	  really removed any items (fixes Cantra's body in bug #3186722: "SI: Body
	  issues in Shamino's Castle").
	* exult.cc: Working around an SDL 1.2 issue with touchpads in full-screen
	  programs under X11.
	* drag.cc: Temporary objects should not stop being temporary because you
	  split a stack in two.
	* objs/contain.*, objs/obj.h, usecode/ucinternal.*: Implemented previously
	  unknown flags in UI_add_party_items and in UI_add_cont_items, as per bug
	  #3132098: "UI_add_party_items unk is temporary bool".

2012-12-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Changelog: Previous two entries (what was wrong with me?).
	* configure.ac: Enabling NxBR scalers by default, as they seem stable enough.
	* schedule.cc, actions.*: Eliminating warnings.
	* files/Flex.h, files/IFF.h, files/Table.h: Cosmetic: explicitly adding in
	  the virtual destructors, just in case.
	* exult.cc, exultmenu.cc, gamemap.cc, files/U7fileman.h: Enhancing Valgrind's
	  signal-to-noise ratio, eliminating some warnings.
	* shapes/vgafile.*: Avoid unnecessary data copying by using references.
	Part 2: Leaks galore
	* exultmenu.cc, menulist.*: Fixing memory leaks in menu.
	* game.cc, shapes/miscinf.cc: Implemented Shapeinfo_lookup::reset. Game::~Game
	  now frees all files and miscellaneous information (fixes lots of errors and
	  memory leaks). Fixed two dumb leaks (passing strdup'ed text to std::string
	  constructor).
	* gamemap.*: Game_map::clear could be reached before Game_map::init in some
	  cases, which led to some deletes of uninitialized stuff.
	* gamewin.cc: save_names array could be deleted uninitialized.
	* shapes/vgafile.*, shapeid.cc: Shape imports are now cleared for gumps and
	  main shapes. Fixed leaks in Shape_frame (construct new, call either read
	  or get_rle_shape).
	* shapes/font.cc: Multiple loads caused memory leaks.
	* shapes/items.cc: Alternating games caused memory leaks due to overwriting
	  text pointers without freeing them first.
	* All others: Straight up alloc-never-free leaks.
	Part 3: Yet more leaks.
	* actors.*, objs/objclient.*: Object_client needs a virtual destructor.
	  Added some stuff to increase Valgrind's signal-to-noise ratio. Added a way
	  to kill a schedule without notifying its clients it has gone away, which
	  is called only when the map is being destroyed (which likely means that
	  the clients are invalid).
	* exult.cc: More increases to Valgrind's signal-to-noise ratio.
	* gamemap.cc, shapeid.cc, audio/*, gamemgr/bggame.cc, usecode/ucinternal.cc:
	  Straight up leaks.
	* party.cc, objs/objs.cc: Code cleanup.
	* schedule.h, audio/midi_drivers/mt32emu/part.h, objs/animate.h,
	  objs/mappatch.h: Several classes in need of virtual destructors.
	* singles.h: Game_singletons needs no destructor, virtual or otherwise.
	* gamewin.cc: Unused NPCs need to be manually deletedor they leak.
	* objs/objlist.h: Nearly 12-year-old massive leak when map got deleted (for
	  example, to load a new game).
	* objs/egg.cc, shapes/shapeinf/monstinf.cc: Allowing egg-spawned objects of
	  NPC or monster classes to actually spawn as NPCs or monsters. Also, fixed
	  default monster info for shapes that don't have it.

2012-12-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* combat.cc: Fixed incorrect animation of slimes after they attacked.
	* actors.*, combat.cc, monster.cc: De-hard-coded slime and sea-serpent
	  shapes. Fixed incorrect sea serpent attack animation (with improvements
	  over the original game).
	* actors.cc, schedule.cc: Improvements to sitting down on barges. Facing of
	  NPCs is preserved on more cases. Move aside now ignores facing when it
	  determines if actor is sitting down, kneeling or lying down.
	* gamewin.cc: Change party members to standing on teleport (barges could be
	  activated by sitting on a barge, teleporting to another and activating
	  the new barge).

2012-12-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* schedule.cc: Walk-to-schedule caused instances of the sit-on-air bug because
	  it would teleport the NPC if off-screen and leave him/her sitting/lying down.
	* actors.cc: Fixed another case of potential sit-on-air source.
	* exult.cc: Fixed buildmap guard band issue.

2012-11-19 Dominik Reichardt <dominus@users.sourceforge.net>
	* exult.cc: added command line option to reset the video settings (patch by 
	  Malignant Manor).
	* win32/exult_installer.iss: "reset video settings" shortcut to the Exult 
	  Start Menu group on Windows (again thanks to Malignant Manor).
	  
2012-11-16	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* imagewin/scale_xbr.*: Performance improvements for NxBR scalers.

2012-11-11 Dominik Reichardt <dominus@users.sourceforge.net>
	* varios files: added data/bg|si/autonotes.txt to game flx bundles and the 
	  misc option to toggle it.
	
2012-11-11 Dominik Reichardt <dominus@users.sourceforge.net>
	* gumps/Notebook_gump.cc: when cheating show location of notes in the notebook.
	  
2012-10-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* tools/gnome_shp_thumbnailer.cc: Eliminated deprecation warning.
	* content/bgkeyring/*: Finally fixed forging of blacksword, courtesy of
	  Malignant Manor.
	* imagewin/scale_xbr: Added option (by editing the .h file) to use other
	  variants of the algorithm (but still defaulting to Zenju's version, as it
	  looks best). Changed color metric to a Manhattan metric over RGB space for
	  a small speed boost without visual loss.
	* paths.cc: Fixed opening crates through wall in Monitor store.
	* All others: Fixed sitting on air/sleeping on ground bugs. Fixed a few
	  schedule-related segfaults due to using objects after they have been
	  deleted by more throughly stopping NPCs when offscreen (may have some
	  side-effects, needs testing).

2012-11-08 Dominik Reichardt <dominus@users.sourceforge.net>
	* cheat_screen.cc: changed cheat screen keyboard commands so you can easily use 
	  them on non-US keyboards.
	  
2012-11-06	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Fix bug #3581649 by stopping Actor::ready_best_shield from trying to equip
	  the lhand object (weapon).

2012-11-05  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* actors.cc: Prevent schedules from being executed for off-screen actors.

2012-11-04  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* imagewin/ibuf8.cc: Fix out of bounds memory access in 'static' screens

2012-10-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/ucdisasm.cc: Eliminated warning.
	* shapes/shapeinf.h: Typo in comment.
	* All others: Added 2xBR, 3xBR and 4xBR scalers to Exult. They are considered
	  experimental, and require --enable-nxbr to be passed to ./configure to use.
	  Performance is likely atrocious for the time being.

2012-10-27 Dominik Reichardt <dominus@users.sourceforge.net>
	* gumps/Slider_gump.cc: fixed bug #2801339, clicks outside of the slider gump 
	  but on the x-axis of the slider were registered as clicks on the slider.
	* exult.cc: when scale_method in exult.cfg wasn't a valid scaler Exult would crash.
	  Thanks to sh4rm4 on #exult for this fix.
	* exult.cc, gamewin.*, gumps/GameplayOptions_gump.cc: added single rightclick 
	  pathfind option. Default is still a double rightclick. Thanks to wjp for 
	  debugging this.

2012-10-25  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* actors.cc: Fix hang when swapping positions on chunk boundary
	* files/zip/*: Fix build with recent zlib

2012-10-10 Dominik Reichardt <dominus@users.sourceforge.net>
	* objs/egg.cc: fixed bug #3433026, in a fire field only clear asleep flag 
	  when the NPC is actually sleeping. Otherwise we get a cloned passive 
	  standing NPC. This is due to Usecode_script::terminate(this); in actors.cc
	  which might need further looking into.
	  
2012-09-07	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Revert previous change and implement it another way

2012-08-25	Malignant Manor <malignantmanor@users.sourceforge.net>
	* Add 0x160 mask to find_nearby. This will only return objects that are not
		okay to take. Make baking schedule use this mask instead of a quality
		setting since quality isn't saved on quality flags objects.

2012-08-18 Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac, makefile.am: added configure "--with-macosx-code-signature=identity"
	  for using an ID to codesign the Mac OS X bundle. The default identity is
	  "Developer ID Application".
	  
2012-07-06	Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc: Have party members fight back if Avatar is disabled,
		not in combat mode, and a party member is hit. The original only
		switched to combat mode when the Avatar got hit.
		Fix use of || instead of && that has any actor schedule seek foes
	* gumps/Spellbook_gump.cc: fix character size
	* usecode/ucinternal.cc: fix array size

2012-06-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* all: Updating Gnome shp thumbnailer to work on Gnome 3.

2012-06-12	 Malignant Manor <malignantmanor@users.sourceforge.net>
	* mapedit/shapeedit.cc: Fix spot frame editing for helmet
	  Fix alt frames editing for ammo, rings, and torso

2012-05-31 Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac, imagewin/imagewin.cc, imagewin/scale_hq*.*: Added
	  configure option --enable-all-hq-scalers, --enable-hq2x, --enable-hq3x,
	  --enable-hq4x. This makes it easier to leave out HQ scalers for quicker
	  compiles, when you need to test things. By default all HQ scalers are 
	  enabled.

2012-05-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actor.cc: Fixed bug #3530273: cannot switch bodies with Petra.
	* content/sifixes/src/header/si/si_externals.uc: Out of synch comment.
	
2012-05-04	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/chunks.cc: Changed ints->bools.
	* objs/objs.cc: Fixed memory leak caused by non-deletion of terrain game
	  objects on cache-out.
	* objs/objlist.h: Removed theoretical object list corruption bug.

2012-04-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Keyring: Merged in the rollable carpet mod.
	* SI Fixes: Ankh-less ship sails since there is little reason for the locals
	  to add one of the symbols of Beast British's tyrannical commands.

2011-12-03	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* all: Fixing several edge cases in world wrapping.

2011-12-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exult_intrinsics.txt: Updated with new intrinsics create_barge_object and
	  and in_usecode_path. Also documented optional parameters to the following
	  intrinsics: path_run_usecode, move_object, recall_virtue_stone and
	  teleport_to_saved_pos.
	* usecode/intrinsics.cc, usecode/bgintrinsics.h, usecode/siintrinsics.h,
	  ucinternal.h: Added create_barge_object and in_usecode_path intrinsics.
	  Added a new and optional parameter to path_run_usecode that can toggle SI
	  mode (defaults to true in SI, false otherwise).
	* objs/barge.cc: Force a barge to reset its center as well as to gather its
	  objects when it is being moved into the game world. Also, force a reset of
	  the barge's center when moving it. Fixed long-standing bug (at least 10
	  years old) that allowed a flying carpet to land on water.
	* imagewin/imagewin.cc: Initialization order (removing warning).
	* mapedit/shapeedit.cc: Fixed insertion bugs on vector data, as well as
	  allocation with new/dealocation with gtk_tree_iter_free.
	* objs/chunks.cc: Invalid world-wrapping caused assertions to fail at the
	  edges of the world.
	* all others: Replaced pre-processor hackery for Game_Object::find_nearby*
	  with templates and added a few more overloads.

2011-12-01 Dominik Reichardt <dominus@users.sourceforge.net>
	* gamewin.*, gumps/misc_options.*: applied patch by i30817 (forum) for
	  dropping stacks of items without confirmation of amount (CTRL drop) 
	  and option to make this the default way to drop stacks.
	* documentation and FAQ updated
	
2011-11-08 Dominik Reichardt <dominus@users.sourceforge.net>
	* imagewin/scale_hq4x.cc & .h and various other files: added hq4x scaler.
	* imagewin/scale_hq2x.cc & .h, scale_hq3x.cc: streamlined scale_hqnx.h include
	
2011-10-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed uninitialized variable restored_schedule. Fixed two cases
	  of '!rand()%XX'.
	* effects.cc: Uninitialized 'start' variables in Snowstorm_effect and in
	  Sparkle_effect could cause these weather effects to fail.
	* keyactions.cc: 'skip' was used initialized, and in a useless manner. This
	  caused actor/paperdoll gumps to use a wrong sequence.
	* schedule.cc: Made sure to set removed objects to zero.
	* usecode/intrinsics.cc: Intrinsics using Game_window::teleport_party were
	  assuming an extra optional parameter; now they explicitly check for the
	  presence of said parameter.
	* usecode/useval.h: In some cases, an Usecode array with no elements could
	  get passed to Usecode_internal::get_item, resulting in an invalid value.

2011-09-28 Dominik Reichardt <dominus@users.sourceforge.net>
	* shapes/pngio.cc: 'jmpbuf' has been deprecated for a long time and libpng >=1.5 will
	  will give an error instead of a warning. 'png_jmpbuf' has been availlable before 
	  libpng 1.2 so it should be ok to use without an explicit check.
	
2011-09-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.cc: remove unused variable in setup_video

2011-09-15 Dominik Reichardt <dominus@users.sourceforge.net>
	* exult.cc: fix fullscreen toggle problem in setup_video function
	  when using the TOGGLE_FULLSCREEN parameter

2011-03-16 Dominik Reichardt <dominus@users.sourceforge.net>
	* audio/midi_drivers/CoreAudioMidiDriver.cpp: accepted patch #3214169 which
	  adds soundfont loading to OS X' CoreAudio driver. Full path to soundfont needs
	  to be in <audio><midi><coreaudio_soundfont>
	* Redme docs changed accordingly
	
2011-03-02 Malignant Manor <malignantmanor@users.sourceforge.net>
	* combat.cc: Fix regression in 6824 that could cause a crash
		because ready_best_shield was being called without checking
		several conditions. (Bug 3196072)

2011-02-25 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actorio.cc, actors.cc, party.cc: Force party members and Avatar
		alignment to friendly.
	* combat.cc: Simplify find_opponents due to the above change. Fix
		regression in 6548 that caused party members to attack
		unconscious npcs.
	* actors.cc: Avatar can be charmed again in normal charmed
		difficulty but effective alignment doesn't change.
		(behaves like the original)

2011-02-09 Dominik Reichardt <dominus@users.sourceforge.net>
	* macosx/diskback.png: added a background image for the OS X snapshot disk image
	* macosx/DS_Store: above backgrund added and a new layout of the snapshot disk image
	* Makefile.am: some disk image tweaking
	
2011-02-08 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamewin.*, schedule.cc, shapes/items.h: Add unused npc messages.
		Fix wrong message number for SI alt intro.
	* data/exultmsg.txt: Fix typo in alt SI intro

2011-02-07 Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.*: Don't have eat schedule use messages or add more
		than one piece of food since the original doesn't and remove
		unused create plate stuff. Add check to stop possible crash.

2011-02-06 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc, combat.cc, shapes/items.h: Fix starving message.
		Add some message constants.

2011-02-06 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc, combat.cc: Make sure non-party members equip a shield
		if they have one and aren't using a two handed weapon.

2011-02-06 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc: Fix ready_best_weapon not equipping dragon breath
		and some spells because they are backpack or rhand ready type.
		Added more shield equipping checks.

2011-02-04 Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.cc: Don't have shape 846 (naga) use different dancing
		frames unless the game is SI.
	* objs/objs.cc: Fix missing spell scroll de-hard-coding in SI.
		(Also used in other games even though it seems unnecessary)

2011-02-02 Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.cc: Add missing eat schedule saying in non-SI games.
	* actors.cc: Allow freezing (0x9e - 0xc5) and magebane
		(0x9b - 0x9d) messages in all games. They get added to
		%%section msgs of textmsg.txt. See docs/siitems.txt for more
		information about the messages Subtract 0x400 from siitems
		to get the correct textmsg number.

2011-02-01 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/GameplayOptions_gump.cc: Make face stats work properly in
		the Exult menu. Bug 3169747

2011-01-31 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamedat.cc: Don't return newlines in get_game_identity and
		get_game_identity_zip.

2011-01-29 Malignant Manor <malignantmanor@users.sourceforge.net>
	* combat.cc: Fix regression in 5915 that caused an endless loop.
		Bug 3131920

2011-01-27 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamedat.cc, gumps/Newfile_gump.cc: Dev games now use
		exult??dev.sav instead of exult??si.sav for saved game names.

2011-01-25 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/GameplayOptions_gump.cc, gumps/MiscOptions_gump.*,
		gumps/VideoOptions_gump.*: Make code more consistent with
		AudioOptions_gump. Remove some unused code.

2011-01-25 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/AudioOptions_gump.*: Add sample rate and speaker type
		buttons. Music tracks now restart if changing audio options
		caused it to stop. Remove unused using std::cerr and std::endl
	* menulist.cc: Add alt-q as quit for Exult menu. For Macs,
		cmd-x has also been added.
	* data/audiooptions.shp: Made 15 pixels taller

2011-01-23 Dominik Reichardt <dominus@users.sourceforge.net>
	* docs/xml/*.xml: Updated documentations
	* docs/images/docs*.png: updated documentation screenshots with 
		newer options and added transparency.
	
2011-01-21 Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.*: Add "config/video/share_video_settings". "yes"
		means that fullscreen and window share the same video
		settings (else "no"). Default is yes.
		Removed unused MENU_APPLY.
	* gumps/VideoOptions_gump.*: Only set video options in the config
		after yes/no gump. Add button for share_video_settings.

2011-01-19 Malignant Manor <malignantmanor@users.sourceforge.net>
	* keys.cc: Fix regression in 6701 where the last created key
		description was using every key except it. Prevent buffer
		overflow from having a lot of last created keys.

2011-01-19 Dominik Reichardt <dominus@users.sourceforge.net>
	* docs/xml/*.xml, *.xsl: Updated documentations and FAQ, changes
		section moved to the bottom.
	* docs/xml: Removed README and added HowTo instead to avoid a
		conflict with the generated documentation.
	* docs/xml/makefile: use gsed instead of sed

2011-01-18 Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.cc: Make sure to initialize in_exult_menu variable

2011-01-18 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamewin.h: is_in_exult_menu and set_in_exult_menu used
		for menu options when in the Exult menu
	* exultmenu.cc, gumps/Gamemenu_gump.*: use the new functions
	* gumps/AudioOptions_gump.*: Don't save custom sfx package if it
		doesn't change. Fixes bug id 3152567. 
		Don't allow changing sfx package in Exult menu. Sfx can still
		be enabled or disabled.

2011-01-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/GameplayOptions_gump.cc: Make paperdolls the bottom
		option so that there isn't a gap if it isn't a choice.

2011-01-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/VideoOptions_gump.cc: Fix crash on toggle

2011-01-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/VideoOptions_gump.cc: Fix accidental commit and left out
		conversion

2011-01-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	gumps/VideoOptions_gump.*: Fix canceling an apply saving the wrong
		values and not toggling fullscreen when needed.
	exult.cc: have set_resolution use new config values

2011-01-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.cc, gumps/VideoOptions_gump.*: Separate video settings for
		full screen and window. Revert changes that were meant to be
		used with newvideooptionsgump.shp.
	* Makefile.common, data/*, msvc*/: Remove newvideooptionsgum.shp

2011-01-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/MiscOptionsGump.cc: Changed position and description
		of two options

2011-01-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/Gamemenu_gump.cc: Allow more menus in Exult menu
	* gamewin.h: can_scroll_with_mouse() and set_mouse_with_scroll()
	* gumps/MiscOptionsGump.*: Add 3 options.
	* gumps/GameplayOptions_gump.cc: Don't show paperdolls when it is
		not an option.
	* all gumps except Gamemenu_gump.*: Only write to cfg once in
		save_settings()

2011-01-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	* Renamed CombatOptionsGump.* to MiscOptionsGump.*
	* Updated project files for this and newvideooptions.shp

2011-01-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.cc: Move cfg options so they don't get needlessly read
		during map build. Move config->write_back() to before
		initializing the Game_window. Use USE_OLD_VIDEO_OPTIONS_GUMP
	* gumps/VideoOptions_gump.cc : Move forced define of
		USE_OLD_VIDEO_OPTIONS_GUMP to header.

2011-01-15 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamewin.cc: only write to cfg once in Game_window::Game_window

2011-01-15 Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.cc, gamewin.*: Add new cfg option to disable scrolling
		the game view with the scrollwheel (when in cheat mode).
		"config/gameplay/scroll_with_mouse" "yes" to allow scrolling.
		"no" to disable it. Default is "no".

2011-01-15 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/VideoOptions_gump.cc: Straiten out row values. More
		code changes for separate fullscreen and window settings
	* data/*: new video options gump shape added

2011-01-15 Malignant Manor <malignantmanor@users.sourceforge.net>
	* exult.*, keyactions.cc, gumps/VideoOptions_gump.*: New function
		"setup_video" to consolidate menu settable video configuration
		reading and writing and implementing it into existing code.
		Start code changes for separate fullscreen and window settings.

2011-01-10 Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.cc: Increase search range for clothes in sew sched.
	* audio/audio.cc: Fix midi sfx not playing.
	* gumps/AudioOptions_gump.cc: Fix midi_sfx conversion after
		revision 6703 changed conversion numbers.
	* configure.ac: Stressing that midi_sfx will likely sound terrible

2011-01-10 Malignant Manor <malignantmanor@users.sourceforge.net>
	* configure.ac: Add --enable-midi-sfx configure option
	* version.cc: ENABLE_MIDISFX shows as a Compile-time option
	* gumps/AudioOptions_gump.cc: If MT32 was in config make it
		Fake MT32 for CoreAudio (default OSX).

2011-01-09 Malignant Manor <malignantmanor@users.sourceforge.net>
	* fnames.h, audio/midi.cc: Use u7intro.tim sysex info for
		BG intro. (MT-32)

2011-01-09 Malignant Manor <malignantmanor@users.sourceforge.net>
	* audio\midi_drivers\XMidiFile.h, gumps\AudioOptions_gump.cc:
		CoreAudio (default for OSX) no longer has MT-32 as an option.

2011-01-08 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/AudioOptions_gump.cc: Fix midi_sfx crash and mishandling
		when no digital sfx are found. Changed the sizes of some
		buttons that were too small for the text.

2011-01-07 Malignant Manor <malignantmanor@users.sourceforge.net>
	* usecode\compiler\ucstmt.cc: Fix if statement that had a ';'
		typo after it that caused it to always be executed
	* compiler warnings:
		keys.cc: Fix const char* comparision with string
		tools/u7voice2syx.cc: Changed char * to const char *

2011-01-07 Malignant Manor <malignantmanor@users.sourceforge.net>
	* istring.h, imagewin/manip.h: Applied modified patch 3152619
		that allows Clang (LLVM) to compile.

2011-01-07 Malignant Manor <malignantmanor@users.sourceforge.net>
	* audio\midi_drivers\XMidiFile.*: Uncommented VolumeCurve, chorus,
		and reverb. Chorus and reverb still don't seem to work.

2011-01-06 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc: Fixed crash caused by having a NULL pointer as the
		object of as_actor(). Fixes bug 3150216 (introduced 6615)

2011-01-04 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actorio.cc, actors.*: Fixed broken schedule location write.
		Schedule z coord is now saved. Fixed npcs changing schedules
		when the schedule hasn't changed. Existing saved games need
		to be saved again after a time change for this to work on
		reload. New games should work right away.

2011-01-03 Malignant Manor <malignantmanor@users.sourceforge.net>
	* imagewin/imagewin.cc: Fix 8 bit video checks in static_init
	* actors.cc: Made the Avatar immune to charm in normal charm
		difficulty. The original allowed the Avatar to be charmed. It
		only showed the highlight and status icon. It wasn't harmful.

2010-12-29 Malignant Manor <malignantmanor@users.sourceforge.net>
	* objs/objs.cc: Fix triple crossbow bolt quantity frames offset
		being wrong making it seem to disappear. Bug 3053282

2010-12-29 Malignant Manor <malignantmanor@users.sourceforge.net>
	* /objs/eggs.cc: Fix SS stairs so they autoreset. Bug 3115182
	* /mapedit/studio.cc: Fix typo that messed up -p command line.

2010-12-28 Malignant Manor <malignantmanor@users.sourceforge.net>
	* /mapedit/exult_studio.glade: Fix swapped neutral and friendly
		alignment display in monster eggs and monster info.

2010-12-27 Malignant Manor <malignantmanor@users.sourceforge.net>
	*/objs/jawbone.cc: Revert same tooth restriction since Marzo
		plans to do something different.

2010-12-26 Malignant Manor <malignantmanor@users.sourceforge.net>
	* mapedit/npcedit.cc, mapedit/npclst.cc, mapedit/studio.h:
		Make npcs update properly in the npc browser when apply is
		clicked or a newly created npc is placed in game.

2010-12-25 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gamemgr/bggame.cc, gamemgr/sigame.cc, gumps/Gump_manager.cc,
		gumps/Spellbookgump.cc: Allow spell scrolls, jawbone, and
		teeth in all games.

2010-12-25 Malignant Manor <malignantmanor@users.sourceforge.net>
	* objs/jawbone.cc: Don't allow two teeth with the same frame and
	shape to be placed in the same jawbone container.
	* monsters.cc: Use get_num_frames() to get max number of frames
		for random food drops
	* gamewin.cc: Commented out seemingly useless jawbone.h include

2010-12-23 Malignant Manor <malignantmanor@users.sourceforge.net>
	* cheat.cc: Fix bug that prevented -p command line from
		connecting with Exult Studio properly.
	* gumps/Face_stats.cc: Remove Dev game loading restriction
	* cheat_screen.cc, gumps/GameplayOptions_gump.cc, shapeid.cc:
		Allow SI style paper dolls in Dev games.

2010-12-23 Malignant Manor <malignantmanor@users.sourceforge.net>
	* game.cc: Disabled into and ending for new games not based
		on U7 data
	* keyactions.cc: Only allow one cstat gump to show

2010-12-23 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc: Made party member only not call fight_back() if
		dead and the attacker is a party member. Made fight_back()
		have the party fight back if in combat mode and one of the
		party members takes damage.
	* gamewin.cc: Made paused_combat_select put the attacking party
		member into combat mode if not already.

2010-12-22 Malignant Manor <malignantmanor@users.sourceforge.net>
	* browser.cc, keyaction.*, keys.*: Add shape_browser_help
		key binding that displays the shape browser keys. Shape
		browser menu now shows the keys when you press 'K'.

2010-12-21 Malignant Manor <malignantmanor@users.sourceforge.net>
	* gumps/Spellbook_gump.cc: Spellbooks can now be edited in map
		edit mode. Exult Studio doesn't detect any changes in it so
		Save all is unreliable with it. Choose File->Save...->Map
	* schedule.cc: Make sure plate used in Eat isn't deleted if it
		wasn't created.

2010-12-21 Malignant Manor <malignantmanor@users.sourceforge.net>
	* mapedit/npcedit.cc, mapedit/studio.*: Add check for saving
		npc editing when apply is clicked.

2010-12-21 Malignant Manor <malignantmanor@users.sourceforge.net>
	*actors.cc, schedule.*: Add eat schedule. (eat was using sit)
		It doesn't work yet if there is no plate nearby.

2010-12-21 Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.*: Made Eat_at_inn clear food when ending. Fix bug
		where leftover food in oven would be set to a random frame.
		Set the maximum display count for clothes to 3. Remove
		schedule ending exceptions.

2010-12-20 Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac: fixed X11 includes on FeeBSD, and warning of ==
	
2010-12-20 Malignant Manor <malignantmanor@users.sourceforge.net>
	* Made npc behavior less erratic when changing to the same
		schedule and location. It doesn't help until after the
		1st hour change in every reloaded or new game. Actors.*
	* Remove parameter message for nonexistent parameter. exult.cc

2010-12-19 Malignant Manor <malignantmanor@users.sourceforge.net>
	* Portable option in Win32 can be accessed from command line
		for Exult and Exult Studio. -p is the parameter for both.
		cheat.cc, exult.cc, files.utils.cc, mapedit/exult_studio.cc,
		mapedit/studio.cc

2010-12-19 Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac: enable_exult_studio_support will add -lX11 to SYSLIBS. Fixes some
	  final linking problems in some Linux distributions
	
2010-12-19 Malignant Manor <malignantmanor@users.sourceforge.net>
	* Alternate configuration files work for Exult and Exult Studio.
		cheat.cc, exult.cc, mapedit/studio.cc
	* gamewin.cc: use get_effective_alignment() for is_hostile_nearby()

2010-12-19 Malignant Manor <malignantmanor@users.sourceforge.net>
	* charmDifficulty hard setting changes
	* keys.*: Separate keys allowed when Avatar is charmed
	* exult.cc: Allow paused_combat_select to work again when the Avatar
	is charmed (for uncharmed party members)
	* gamewin.cc: Charmed party members stay in combat mode

2010-12-18 Malignant Manor <malignantmanor@users.sourceforge.net>
	* charmDifficulty: Stop actor movement when charmed. Exult.cc,
		gamewin.*, keys.cc:
	* actors.cc: Combat is toggled if a party member gets charmed.

2010-12-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* add can_act_charmed and made checks use it
	* keyactions.cc: fix inventory skip bug introduced in 6571

2010-12-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* charmDifficulty: Space pauses excluded for charmed party members
	* Fixed space pauses failed read caused by last revision

2010-12-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* Added charm difficulty to combat options gump.
		gumps/CombatOptions_gump.*
	* Indenting: gamemgr/sigame.cc

2010-12-17 Malignant Manor <malignantmanor@users.sourceforge.net>
	* Added an option to make charmed more difficult.
		actors.cc, combat.cc, combat_opts.h, gamewin.cc,
		keyactions.cc, gumps/Face_stats.cc: It currently blocks
		inventory access to charmed party members and you cannot
		talk to charmed npcs through doubleclick event.

		'config/gameplay/combat/charmDifficulty' option is hard or
		normal with hard having these restrictions. Default is normal

2010-12-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	*combat.cc: fix (hopefully) find_opponent bugs not fixed
		properly in 6557 and 6558.

2010-12-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	*gumps/CombatStats_gump.cc, gumps/Paperdoll_gump.cc, gumps/Stats_gump.cc: Added Oink!
	text when failed copy protection flag is set

2010-12-16 Malignant Manor <malignantmanor@users.sourceforge.net>
	*actors.cc, gamewin.*, objs/objs.cc, usecode/ucinternal.cc: The missing Black Gate
		failed copy protection function call (random speak) has been added. Oink! is now
		used for all item say and all click descriptions except non-Avatar npc names when
		the copy protection flag is set. Discrepancies are posted in feature # 611028.

2010-12-15 Malignant Manor <malignantmanor@users.sourceforge.net>
	*cheat.cc: heal_party now cures charmed, paralysis, and cursed flags. It also resets
		temperature but does not remove the freezing flag.

2010-12-14 Malignant Manor <malignantmanor@users.sourceforge.net>
	*combat.cc: Added check to make sure that party members do not target themselves unless
		in tournament mode. Bugs 3053811 and 2797068 should be fixed now.

2010-12-14 Malignant Manor <malignantmanor@users.sourceforge.net>
	*combat.cc: Added checks for charmed party members in Combat_schedule::find_opponents.

2010-12-13 Malignant Manor <malignantmanor@users.sourceforge.net>
	*combat.cc: Added check in Combat_schedule::find_opponents to make party members be
		attacked while sleeping if there are no other viable targets. Fixes bug # 2961387.

2010-12-13 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: Added missing check for stove in find_leftovers.
	*schedule.*: added comments
	*svn:ignore: added exconfig.dll to the trunk's ignore list

2010-12-12 Malignant Manor <malignantmanor@users.sourceforge.net>
	*conf/Configuration.cc: Prevent wrong error messages about moving and copying the
		configuration file in Windows if home is the Exult folder.

2010-12-12 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: A check was added for the ending of some schedules. Every hour the ending
		is called and this check will prevent some erratic behavior.

2010-12-12 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: Improved Automaton baking in Silver Seed.
		display_wares cost changed in SI (needed for Automaton).

2010-12-12 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: The Moonshade Baker now displays goods. Removed accidental temporary flag.
		gamemgr\sigame.cc: Map patches were added to remove	the bread, dough, and flour in
		Moonshade that are on the wrong tables. Dev games are now excluded from	all the SI
		map patches.

2010-12-11 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: Reverted baking to_table cost. Added missing else statement in to_table.

2010-12-11 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: I fixed a crash in the baking schedule state find_leftovers caused by the
		oven getting cached out.

2010-12-11 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: In baking schedule, clear_display and remove_food now use the new baked
		quality. I changed size() check to empty() for use_potion.

2010-12-11 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.*: The baking schedule should now clean up when needed. Flour, dough, and baked
		goods from left over from old saved games will not be cleaned up since this relies on
		quality number. Quality 50 is for dough	and quality 51 is for items that have been
		placed in the oven.

2010-12-11 Malignant Manor <malignantmanor@users.sourceforge.net>
	*schedule.cc: Reverting 6515 changes since the temporary schedule items will likely crash
		during chunk cache out (Avatar death is a good example).

2010-12-10 Malignant Manor <malignantmanor@users.sourceforge.net>
	* Actors.cc: Npcs do not heal hourly if poisoned. If in the party, they also don't heal if
		starving or freezing. Overheating in SI is not checked since overheating is handled by
		usecode function 0x6AF.
	* keyactions.cc: I fixed fullscreen toggle for OpenGL.
	* defaultkeys.txt: Alt-V (Cmd-V) is now an alternate key to create last shape due to newer
		Apple Macintosh keyboards lacking the insert key.

2010-12-10 Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.*: Added checks in Talk_schedule::now_what so the npcs doesn't item_say if the
		Avatar is unreachable. Changed costs in baking schedule to help prevent failures.
		Changed baking schedule so that the display table is cleared of food before getting full.
		It needs some further pathfinding added to each food item cleared since it currently only
		walks to the table.
		
2010-12-09 Malignant Manor <malignantmanor@users.sourceforge.net>
	* actors.cc, gamewin.*, objs/eggs.cc, usecode/intrinsics.cc: Added a check
		to make sure party members don't teleport with teleport_party if paralyzed, or asleep.
		Added an optional parameter for teleport_party, teleport_to_saved_pos, move_object,
		and recall_virtue_stone to override the check. Teleport cheats don't use the check.
		Changed Actor::follow so that paralyzed or asleep actors don't follow. This fixes bug #2799398.
	* added  cmanip.exe, mockup.exe, smooth.exe, and u7voice2syx.exe to the trunk's svn:ignore

2010-12-09 Malignant Manor <malignantmanor@users.sourceforge.net>
	* schedule.cc: Make more schedule created items temporary
	* added Exult.exe to the trunk's svn:ignore

2010-12-09 Dominik Reichardt <dominus@users.sourceforge.net>
	* paths.cc: fixed talking through locked doors. If NPCs can't pathfind to you, no conversation (thanks to Malignant Manor)
	* actors.cc, gumps/Face_stats.cc: applied highlight patch #3132882 to match the order with the original (also thanks to Malignant Manor)
	
2010-12-06 Dominik Reichardt <dominus@users.sourceforge.net>
	* data/si/autonotes.txt, content/sifixes/src/header/si/si_gflags.uc: corrections 
	  about some flags set when talking to Harnna

2010-11-21  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* objs/spellbook.cc: fix mana cost check (thanks malignantmanor; #3001287)
	* actors.cc: don't make dying party members call guards
	  (thanks malignantmanor; #3011711)

2010-11-20 Dominik Reichardt <dominus@users.sourceforge.net>
	* configure.ac, Makefile.common, msvc9/msvc_kludges.h, msvcstuff/msvc_kludges.h, 
	  win32/*.rc: changed version number to 1.5.0svn - the idea is to have even version 
	  numbers for final releases.
	* cheat.cc, usecode/intrinsics.cc: location cross on normal and cheat map is yellow again

2010-11-11  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* desktop/exult.desktop: apply changes from gentoo's exult package

2010-10-31  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* objs/eggs.cc, gameclk.cc: match night time with original (bug #3099477)

2010-10-30  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* objs/eggs.cc: fix nocturnal egg 12h/24h confusion. (Thanks to Malignant
	Manor on the forum)

2010-10-20  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* scale_*.cc: add missing guard bands. This should fix artifacts along the
	  bottom edge of the screen.

2010-10-18  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* scale_bilinear.cc, scale_2x.cc: add missing guard bands. This should fix
	  the bilinearplus crashes.

2010-10-13 Dominik Reichardt <dominus@users.sourceforge.net>
	* updated Documentation and FAQ and many other files to reflect an upcoming release of version 1.4.9RC1
	* NEWS: updated with what we've done the last six years
	* AUTHORS: added a couple of authors and changed some email addresses according to our "About Us" page
	* docs/release.txt: updated a bit
	 
2010-10-13  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* actors.cc: revert change from r6329 that made monsters attack only
	  rarely. Also added a FIXME, since the expressions involved don't do what
	  they seem to do.

2010-10-11  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* gamerend.cc: fix regression from r6352 that ignored light sources
	* gameclk.cc: fix regression from r5763 that delayed dungeon light changes

2010-10-05  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* ibuf8.cc, ibuf16.cc: take pitch into account in fill_static
	* bggame.cc, sigame.cc: remove mentions of Exult from intro
	* palette.cc: fix uninitialized variable

2010-10-05 Dominik Reichardt <dominus@users.sourceforge.net>
	* data/bg/ and data/si: disabled Alt+KP+ and Alt+KP- key combination to switch 
	 resolution, it doesn't play nice with the new render code.

2010-10-05	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* keyactions.cc: Show message when mapedit keys are used and Exult is built
	  without ES support.

2010-10-01  Ryan Nunn <colourles@users.sourceforge.net>
	* Changed things so it is possible to open some of the options gumps from the
	  Exult menu (requires data from the games to work, but thats ok). Removed 
	  the old setup main menu screen and replaced it with the in game gumps.

2010-09-04  Ryan Nunn <colourles@users.sourceforge.net>
	* menulist.cc : Trying to stop mouse lag
	* mouse.cc : Stopping warping from occuring unless fastmouse is enable 
	  (otherwise mouse can get trapped when windowed)
	* shapes/fontgen.cc : Added a Win32 GDI font renderer. My experience is its
	  better at producing small pixel fonts compared to FreeType (because it 
	  can legally use Font hinting all the time)
	* gamemgr/bggame.cc : Added missing zooms into BG Intro
	* imagewin/imagewin.h : Added a method to get access to draw_surface

2010-08-30  Ryan Nunn <colourles@users.sourceforge.net>
	* imagewin/imagewin.cc : Explicitly set pixel format of the 'inter_surface'.
	  Might fix Dominik's colour issues if the SDL default does not match the 
	  display surfaces

2010-08-15 Dominik Reichardt <dominus@users.sourceforge.net>
	* data/bg/ and data/si: added autonotes.txt for each game. For now these mostly
	  list global flags found and known for the games with some description of the 
	  set flag.
	  The idea is to replace these descriptions with witty text and have them appear
	  in the notebook (press'n'). I've written some stuff for BG already but not 
	  near enough.

2010-08-29  Ryan Nunn <colourles@users.sourceforge.net>
	* Added ability to right click on option buttons in gumps. Right clicking 
	  will select to previous option in the list.
	* Layout of video Options Gump been reworked slightly so it make more 
	  sense. Changed things to Windowed mode lets you choose from a larger list
	  of display sizes that include resolutions that are likely to be wanted.
	* Video Options gump now has an 'APPLY' button instead of 'CANCEL' and 'OK'.
	  Pressing apply will obviously apply the changes. You must apply changes 
	  before pressing the check mark to close the gump.
	* Video Options gump now brings up a new 'Countdown_gump' after applying 
	  settings to confirm that the settings work. If the users fails to press
	  YES before the countdown has expired, the settings are reverted.
	* Video Options gump will alert the user if the selected settings will cause 
	  the rendering size to be smaller than 320x200 (and consequently cause 
	  trouble with exults user interface).
	* Can now do some limited arbitrary scaling. Its designed to fit the 'game
	  area' to whatever display resolution you've selected and also apply 
	  pixel aspect ratio correction. Two extra config settings have been added
	  to control the arbitrary scaling options:
	  * "config/video/fill_scaler" : The scaler to use, either Point or Bilinear
	  * "config/video/fill_mode" : The method to use to position the game area 
	    on the display surface. The can be one of the 5 values:
	    * Fill : Game screen is stretched to fill the entire display surface. 
	      No borders will be added in this mode. The game screen will be 
	      downsampled if it is bigger than the display surface in this mode.
	    * Fit : Game is scaled to fill the display surface maintaining square 
	      pixels. Black borders will be added to maintain aspect if needed. The
	      game screen will be downsampled if it is bigger than the display 
	      surface in this mode.
	    * "Aspect Correct Fit" : Same as fit, but pixels are additionally 
	      scaled using a 1:1.2 ratio. This corrects the aspect mismatch 
	      between the nonsquare pixels used by the original game and the 
	      square pixels of modern screen resolutions.
	    * Centre : Game is centred on the display surface without additional 
	      scaling. Black borders will be added if game screen is smaller than
	      display surface. Clipping will occur if the game screen is larger 
	      than the display surface.
	    * "Aspect Correct Centre" : Same as Centre except height is scaled by
	      1.2x to correct pixel aspect mismatch.
	  These settings can be changed in the Video Options Gump. If the Game Area
	  setting is set to Auto then the game area is calculated based on the 
	  selected fill mode with no additional scaling applied. 

2010-08-15 Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation and fixed the templates again
	
2010-08-24  Ryan Nunn <colourles@users.sourceforge.net>
	* Added methods to remove nodes from the configuration tree to allow me to 
	  remove deprecated config settings from code
	* Inverted display resolution setting inregards to scaling. You now set the
	  actual post-scaled resolution, instead of the pre-scaled resolution as 
	  before. The display resolution config setting has been changed from 
	  "config/video/[width|height]" to "config/video/display/[width|height]". 
	  Exult will automatically set the new values (old values *scale factor) 
	  and remove the old one from the config.   
	* The game resolution can now be set in the Video Options Gump. As the game
	  resolution can now be changed in game, it now defaults to 320x200 for 
	  compatibility reasons with the original games. 
	* The list of display resolutions in the Video Options Gump is now 
	  determied by asking SDL what resolutions are available.
	* The colour of the border of the centred the game screen can now be set
	  using the config settings "config/video/game/border/[red|green|blue]"
	* Fixed bug with 565 colour.
	* Added config option to force output bpp "config/video/force_bpp". Valid
	  values are 0 (for any), 8, 16 or 32. Note if set to 8 most scalers will
	  not work and will display as the fallback point scaler.

2010-08-23  Ryan Nunn <colourles@users.sourceforge.net>
    * too many files to list : Hacking things up to allow the game to render at
      a different resolution to what its displayed at. This will allow fixing 
      the games resolution to 320x200 while displaying at any resolution. 
      Currently the game screen is centered only if it doesn't match the 
      display resolultion. Will eventually allow streching. To change the game
      rendering resolution change the new config settings 
      "config/video/game/width" and "config/video/game/height". I consider this
      code to be somewhat experimental.

2010-08-23 Dominik Reichardt <dominus@users.sourceforge.net>
	* Info.plist.in: Only allow OS X 10.6 to run the x86_64 arch of the exult binary
	
2010-08-18  Ryan Nunn <colourles@users.sourceforge.net>
	* audio/Midi.cc, audio/midi_drivers/* : Changed the way how MT32 Sysex data
	  and timbre loading is handled to improve startup time. Things are now 
	  setup to preload the required timbers and patches used by songs as they 
	  are loaded, rather than loading then entire timbre bank as done 
	  previously. Added two config settings to control timbre precaching, 
	  "config/audio/midi/precacheTimbers/onStartup" (default no) and 
	  "config/audio/midi/precacheTimbers/onPlay" (default yes). It should be 
	  unnecessary to change those two settings.	
	* other files : Fixing up various compiler warnings

2010-08-18  Ryan Nunn <colourles@users.sourceforge.net>
	* imagewin/imagewin.cc, imagewin/manip.h : Reenabling colour swapped 
	  optimized 555 and 565 scalers. Found the issues and fixed them.

2010-08-18  Ryan Nunn <colourles@users.sourceforge.net>
	* imagewin/imagewin.* : Attempting to work around problems experienced by 
	  Dominik. Checks for Windowed surface format support is now done at 
	  startup. Changed things so if SDL_VideoModeOK() checks fail, Exult still
	  still attempts to create the surface anyway. Disabled colour swapped 555 
	  and 565 optimized scalers.

2010-08-17  Ryan Nunn <colourles@users.sourceforge.net>
	* exult.cc, imagewin/* : Cleaning up scaler handling code, fixing bugs,
	  generally making things more flexible for future changes.
	* shapes/baseinf.h : Fixing a compiler warning

2010-08-17 Dominik Reichardt <dominus@users.sourceforge.net>
	* imagewin/imagewin.cc : commented out the SDL_VideoModeOK check before 
	  switching to fullscreen. This hopefully allows everyone to toggle 
	  fullscreen again. Please let us know.
	
2010-08-15 Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation and FAQ
	
2010-08-13  Ryan Nunn <colourles@users.sourceforge.net>
	* audio/RawAudioSample.cc : Fixing crashes on PPC Macs

2010-07-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamewin.cc, exult.cc, keys.cc: fixed bug #3011719  avatar can do stuff
	  while passed out. The player will be unable to do almost anything (similar
	  to the originals) if the avatar is asleep, unconscious, paralyzed or dead.
	  As a rule, cheat and mapedit actions are still allowed in these cases, and
	  hackmove allows dragging even in these conditions. Also, purely interface
	  actions will also work -- like esc, scrolling the map with the mouse wheel
	  and so on.
	* configure.ac: AC_PATH_XTRA is actually causing linking problems in Ubuntu
	  Karmic, so it has been removed (again).
	* Others: Eliminated a few warnings.

2010-07-26	Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* configure.ac: Don't expand AC_PATH_XTRA in a conditional. This broke
      configure on all platforms other than linux.

2010-07-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* configure.ac: Added AC_PATH_XTRA macro to fix compilation problems in some
	  Debian and Debian-based distros. Properly quoting text.
	* audio/*: Fixing bug #3016448 -- load_timbres() was being called when it
	  should not, and caused music to stop.

2010-04-19	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Midi.cc: Fixed regression that caused timbres to not be uploaded
	  when changing audio options. Also, ensure correct timbres are loaded when
	  a song is started.
	* audio/Audio.cc: SFX cache is completelly flushed now when changing the
	  SFX packages, so that all SFX from the new package will be used effective
	  immediately (instead of requiring Exult to be restarted).

2010-04-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Patches applied:
	  #2843338 Use official min/max functions instead of proprietary ones
	  #2975693 fix for bug, Walking speed doesn't change to reflect fps

2010-04-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Bugs fixed:
	  #1500917 --disable-mt32emu doesn't disable building mt32emu
	  #2986215 SI: graphics glitch on "you must start a new game first."
	* configure.ac, audio/midi_drivers/Makefile.am: Bugfix for #1500917.
	* configure.ac, Makefile.am, content/*/*: The Exult mods can now be enabled
	  and built by passing the '--enable-mods' to ./configure; the mods are
	  installed to the default 'forgeofvirtue' and 'silverseed' mods dirs.
	  There are also MinGW makefiles for each of the mods as well. All of the
	  mod makefiles are generated by the content/makefile_builder.sh script;
	  since this script is probably non-portable, the generated output makefiles
	  have been included in the SVN dir for the time being.
	* Makefile.am: Do not link with libmt32emu.la if it is not built.
	* shapeid.cc, shapes/data_utils.h: Fixed crash on Mac OS X bundles if there
	  was no exult_bg.flx or exult_si.flx in external data directory.
	* configure.ac: Cleaning up tests for libogg, libvorbis, libvorbisfile,
	  libglade and libgnomeui. Changed AC_ARG_* to use AS_HELP_STRING. Fixed the
	  default case for --enable-long-long-warnings. Static builds in Mac OS X
	  now work by passing the following arguments to ./configure:
	    --enable-static-libraries
	    --with-macosx-static-lib-path=path/to/static/libs
	* Merged Colourless' No-SDL Mixer back to trunk.

2010-03-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/npcedit.cc: Fixed another instance of assuming longs are 32-bit.
	* keyactions.cc: Fixed bug with 'try all keys' action.

2010-03-16	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Exult Studio: Eliminated a few warnings in Prompt window. Some buttons are
	  now the appropriate stock buttons. Commented out gtk_selection_owner_set
	  calls, which were preventing drag-drop from working more than once in ES
	  in X.

2010-03-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs:
	  #2966927 pointers.shp can be dragged into Exult Npc, ES menu
	* Makefile.mingw: Fixed segfault during midi playback when throwing
	  exceptions if GCC used SJLJ exception model. Binaries from these compilers
	  will have an additional dependency on MINGWM10.DLL.
	* windrag.cc: shapes/u7drag.h: Make U7_TARGET_NPCID into an unique ID. Fixed
	  erroneous use of U7_TARGET_NPCID_NAME versus U7_TARGET_NPCID.
	* files/utils.h, server/objserial.*: Longs (and pointers) are *not* always
	  32-bit; make ES actually work on 64-bit Linux.
	* server/server.cc, server/Makefile.am, mapedit/contedit.cc: Make show gump
	  button in ES work for non-actor containers again.

2010-03-14	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Midi.cc: Fixed dangerous dangling cstr pointers.
	  Imported Colourless' bugfix to trunk: fixing assumption that all paths
	  will start with <STATIC>/.
	* audio/midi_drivers/MT32EmuMidiDriver.cpp: Implemented a more robust ROM
	  and MT32 data file function for MT32Emu.
	  Fixed invalid bundle search in MacOSX.
	* files/utils.cc: Fixed bug that prevented a data dir specified at Exult.cfg
	  from being used.
	  Fixed bug in which Exult would bail out in MacOS X app bundles when
	  searching for the external data dir even when it shouldn't.
	* gumps/AudioOptions_gump.*: Mapped button ids into an enum and renumbered
	  their order. It is easier to add new buttons now and still have the gump
	  work correctly; this also fixes a recent bug toggling audio on/off.
	

2010-03-13	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* All: Improvements to the bundle checks: Exult will now try to see if the
	  bundled file exists and try to use it only in this case.

2010-03-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapes/data_utils.h: Fixed compilation warnings in MacOS X.
	* imagewin/*: Added 16-bit and 32-bit versions of Point, Interlaced and
	  Scale2x scalers. The old 8-bit scalers are still available, but Exult
	  will use them only if it can't use the 16-bit and 32-bit versions.

2010-03-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* files/utils.h: Default save location in Mac OS X changed (again) to be
	  ~/Library/Application Support/Exult (issue #1377892).
	* De-hard-coding, round 3: All information about which gump a given shape
	  should display is now given by the 'container.dat' file; a default file
	  with the original game data is embedded in Exult_xx.flx. This includes
	  moving BG NPC gumps from paperdoll data; Exult/ES will do this for older
	  versions of paperdol_info.txt on load. The embedded 'container.dat', as
	  well as those written by ES, will be version 2 and include (non-editable,
	  for now ignored) font information for gumps.
	  Expanded frame powers to depend also on quality, and renamed into frame
	  flags. The reagent ring (SI) and trapped chests are examples of the new
	  frame flags in action.
	  Fields (fire/poison/sleep) are no longer hard-coded.
	  Any object can now be marked as being a 'jawbone' or a 'mirror'. Jawbones
	  will work *exactly* the same way as the SI jawbone does.
	  ES can edit this new shape information, and has many new additional built
	  in groups for shapes.vga.
	  Body data now follows the :shape/[data] structure, having had a version
	  bump, with a backward-compatible reader.
	* shapes/*: Reorganized tree structure: new directory 'shapeinf' contains
	  all of the data classes now, except for the baseinf.h base class.
	  Reorganized code, with heavy template use, for reading/writing of shape
	  info; the code is now in data_utils.h.
	* gamemap.cc: Using shape classes instead of hard-coded shape values. Also,
	  Game_map::create_ireg_object will correctly handle dead bodies and virtue
	  stone-like objects.
	* combat.cc: NPCs that can't die also won't flee.
	* General: eliminated some warnings. ES will reject any character not in the
	  128 ASCII character range for menu titles, as the menu font does not have
	  any such characters.

2010-03-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs:
	  #2967402 OSX: ES is defaulting to wrong path for EXULT_DATADIR
	  #2967138 ES defaults to the app folder for saving png and shp in Win
		ES expects the patch dir to be writable -- even if Exult does not -- and
		defaults to this for all file browsing operations (except for creation
		of new games).
	* Implemented feature requests:
	  #2967398 Show which sfx pack is used in stdout
	  #2967397 Gump for selecting SFX pack
	* shapeid.cc, fnames.h, shapes/shapevga.cc: Fixed a few omissions affecting
	  MacOS X app bundles.

2010-03-10 Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation and FAQ with the changed default path values and other things.

2010-03-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Applied patches:
	  #2965885 Export a palette and import it to GIMP without an editing
	* all: Changed default path values again; Dominus has been documenting them.
	  Made MacOS X look both in bundle and in external <DATA> tags for data.
	  Improved detection code for waves: if wave packs are found, appropriate to
	  the game, they are added to exult.cfg and used. Exult will now always
	  search for blackgate, forgeofvirtue, serpentisle and silverseed, even if
	  there are other games defined in exult.cfg.
	* Fixed bugs:
	  #2967402 OSX: ES is defaulting to wrong path for EXULT_DATADIR

2010-03-09 Dominik Reichardt <dominus@users.sourceforge.net>
	* makfile.common, audio/midid_drivers/*: added CoreMIDI driver for using a real MT32 on OS X
	* README, /docs/*:updated Documentation with CoreMIDI information

2010-03-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* autogen.sh: Changed == (which is a bashism) into = for test.
	* shapes/glshape.*: Fixed MacOS X PPC compilation error.
	* gamemgr/*: Games in exult.cfg without a <path> or a <static_path> tags now
	  default to $prefix/share/exult/gamename in *nix and MacOS X (where $prefix
	  is /usr/share or /usr/local/share, depending on ./configure options).

2010-03-08 Dominik Reichardt <dominus@users.sourceforge.net>
	* README, /docs/*: updated Documentation, fixed the xml makefile to do proper cases
	* /data/credits.txt: fixed typo in Jakob Schonberg's name
	* README.MacOSX: additional information for compiling and running Exult Studio on OS X
	
2010-03-07 Dominik Reichardt <dominus@users.sourceforge.net>
	* makefile.am: added an option to make dmg-image of the app-bundle and some other files
	* /macosx/DS_Store: added Desktop Services Store file to layout the dmg-image

2010-03-06	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs:
	  #2841677 Cannot close two gumps in succession

2010-03-06 Dominik Reichardt <dominus@users.sourceforge.net>
	* makefile.am: tuned the app bundle a bit, including some of the standard files
	* Info.plist.in: updated copyrights date

2010-03-06	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapes/font.cc: '^' character in conversations/plaques/books/etc. will
	  convert the next character to uppercase. This is needed in the training
	  dialog of Sentri, for example.

2010-03-05	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* MacOS X: App bundles now use CoreFoundation API to detect resource path
	  instead of it being hard-coded into the application.
	* Fixed bugs:
	  #2962438 The BG and SI credits use the wrong palette
	  #2961649 Party flickers when walking and infravision or invisible

2010-03-04 Ryan Nunn <colourles@users.sourceforge.net>
	* msvcstuff/msvc_kludges.h: Updating to reflect current code
	* version.cc: Added Windows Vista and Windows 7 to the list of detected windows versions

2010-03-03 Dominik Reichardt <dominus@users.sourceforge.net>
	* exult.cc: look for data folder in .app bundle as well on Mac OS X (and changed the copyright date)
	
2010-02-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs:
	  #2958487 HQx3 is only scaled to 2x when set in Exult menu
	  #2813106 ES won'tt save frame powers when they don't previously exist
	* ES: Eliminated a few warnings, including Gtk+ stderr runtime warnings.
	  Added missing handlers and missing export. Fixed a few minimum values of
	  spin buttons.

2010-02-24	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs:
	  #2179006 Sleeping on the Floor (BG/SI)
	  #2798862 Unconcious enemies stand up for a second before dieing
	  #2796857 SI(?): Sleeping in beds not working correctly
	* General: Eliminated a few warnings.

2010-02-23	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs:
	  #2912644 Black rain
		Rain drops/snow flakes/magic sparkle now use shape 0 from sprites.vga.
		Rain drops are frames 3 to 7 (7 being a "splash" frame of sorts which
		looks very nice), snow flakes are frames 13 to 20 and magic sparkle are
		frames 21 to 27.
	  #2798881 guards in goblin valley
	  #2838851 Notebook gump crashes Exult when text is dragged offscreen
	  #2838850 Notebook text is duplicated to the sides of the gump
	  #2805775 Formation is still forced to yes for testing
	  #2957048 Exult.cfg contains absolute paths on Win32
		Exult won't write path settings now: writing the default value is simply
		wasteful as Exult calculates each such default path *once* each run.
	* Applied patch:
	  #2957036 Fix a sfx and fix blacksmith to show tongs and hammer
	* shapes/glshape.cc: Screenshots were causing crashes with OpenGL; fixed.
	* gamerend.cc, gamewin.cc: Wrong xforms were being used in some cases since 
	  evision 6119; fixed.
	* utils.cc: Remove trailing slashes on all OSes when path is added.

2010-02-22	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs:
	  #2819210 newfilegump.cc (4 buttons one pixel too far to the right)
	  #2838846 Text background button sticks out 20 pixels
	* gamemgr/modmgr.cc: Removed some redundant variables. Patch dir now behaves
	  identically to mods dir as far as default paths go.

2010-02-22 Dominik Reichardt <dominus@users.sourceforge.net>
	* win32/exult_studio_installer.iss: set to SVN and setting working folder for Exult Studio start menu item

2010-02-22	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed absolute path issue in Windows.
	* Setting a relative <mods> path did not work as expected; fixed.

2010-02-20	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #2844723.

2010-02-20	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exult.cc, Makefile.*, conf/*, files/*, gamemgr/*, mapedit/*: In Windows,
	  Exult and ES will now use/save configuration files, savegames, gamedat,
	  patches, screenshots and stdout.txt/stderr.txt in LOCAL_APPDATA\Exult.
	  This has the added benefit of no longer requiring ES to be installed to
	  the same path as Exult. Existing configuration files (including Exult.cfg)
	  will be copied from the current path to the new location and ignored from
	  then on; savegames, mod data and everything else will not. This should
	  make Exult play nice with Vista and W7, but I need testers.
	  NOTE: If you want to keep Exult as "portable" in Win32 as it was, you can
	  compile it with -DPORTABLE_EXULT_WIN32 and set all relevant paths directly
	  in Exult.cfg to prevent Exult from looking elsewhere. This is turned off
	  by default in current SVN.
	* palette.cc, imagewin/*, shapes/*, usecode/*: Added back width and height
	  parameters to the OpenGL screen grabbers because of ES in MinGW.

2010-02-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* OpenGL fixes: Invisibility draws sprites translucently, outlines are now
	  drawn correctly (poison, damage, etc), screenshots and save screenshots
	  work, crystal balls work.
	* Slight cleanup of earlier commit; failed attempt at OpenGL fade in/out.

2010-02-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapes/pngio.*: Added function to save 32-bit RGBA png file.
	* mapedit/u7shp.c: Do not prompt for palette if running non-interactively.
	* All else: Added a Gnome thumbnailer for SHP files. It can probably be
	  modified to work on Thunar/Xfce too, but I have no idea about KDE.
	  No comments on Windows, though. It is off by default.

2010-02-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* ucc: Some additional escape character sequences have been added, as well
	  as some code to warn about unknown sequences. Also, ucc was not closing
	  files it opened, which in some cases causes problem compiling usecode if
	  there are too many includes (e.g., on Windows).

2010-01-08	Tristan Tarrant <nadir@users.sourceforge.net>
	* Disable smooth scrolling in default install

2010-01-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed Exult Menu to be consistent with Tristan's commit. It is also more
	  dynamic now, adjusting to the screen size.
	* Eliminated various #ifdef for Zaurus given that they were specifically
	  added for the different-sized Exult-menu.

2010-01-08	Tristan Tarrant <nadir@users.sourceforge.net>
	* First commit of 2010 and it isn't by Marzo !!!
	* Main screen is now at 320x200 to be consistent with the default
	  game resolution

2009-11-05	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed double-delete bug in midi driver backend for MT32 midi conversion.

2009-09-13 Dominik Reichardt <dominus@users.sourceforge.net>
	* Fixed numbering in Documentation and FAQ
	* docs/xml/makefile: added simple duplicating rule for README and FAQ
	
2009-08-16	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs #2834246, #2833614 and #2830990.
	* Fixed Gameplay options gump to refer to the new translucent colors.
	* Palette transitions did not load patch palettes (fixes bug #2816773).
	* Fixed bug #2813103.

2009-07-21	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Changing version string to "svn" instead of "cvs" (bug #2822452).
	* SDL video driver on Mac OS X is set to x11 if Exult Studio support is on.
	* Fixed bug #2816756.
	* Added default avatar_data.txt for new games created with ES.

2009-07-16	Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation,FAQ and README.MacOSX
	
2009-07-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* A few compilation fixes/improvements for Mac OS X (courtesy of Dominus).

2009-07-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/exult_studio.glade: Fixed a couple mislabeled flags in the NPC
	  editing window.
	* audio/midi_drivers/ALSAMidiDriver.cpp: Fixed invalid conversion.
	* data/Makefile.am: Remove error with 'make install'.

2009-06-26	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exult.cc: --buildmap can now be used for maps other than map 0 through the
	  "--mapnum <N>" parameter Disallowed --game if the game had been specified
	  otherwise (--bg, --si, --fov, --ss).
	* shapeid.*, docs/u7tech.txt, fnames.h, palettes.cc, win32/*, data/*: There
	  were actually 17, not 11, xform tables used in the original games; Exult
	  now implements the other 6. OpenGL/fallback blends are now specified in
	  a file called "blends.dat" (which is bundled in exult_XX.flx for BG/SI).
	  XForms are now patcheable (as is this new blends file). There is still a
	  fallback hard-coded blend set just in case. A blends.dat file is included
	  for new games.
	* shapes/vgafile.*: Fixed memory leaks.
	* segfile.*, msvc9/*, msvcstuff/*, Makefile.{common,am}: A segfile was a
	  stripped-down version of a flex reader used only once; it has have been
	  removed.
	* All others: Cleanup/proper verification if read file object is valid.

2009-05-20	Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation, FAQ and ReadME.OSX.
	
2009-05-19	Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation with mods and patch instructions.
	* docs/xml/html.xsl and php.xsl now support coloured tags for manual exult.cfg settings
	  
2009-05-19	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Implemented feature request #2793602 in a way that (hopefully) won't be
	  the source of any trouble.
	* Fixed bugs #2793317 and #2793229.
	* Several destructors that should be virtual but weren't are now. Fixed many
	  memory leaks, delete/delete[] and delete/free mixups. Removed unneeded
	  checks before deleting objects. Removed several unused variables. Turned
	  a few 'const std:string' parameters into 'const std::string&'. Fixed a
	  buffer overflow.

2009-05-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/shapelst.cc: Set frame spin upper-bound *before* setting value;
	  this fixes a selection bug in frame display mode. Also, leave page_size of
	  that same spin as zero to prevent another selection bug in frame display.
	* keys.*, keyactions.*, data/si/defaultkeys.txt: Added new call_usecode
	  action, which accepts usecode function name (if available) or number and
	  an event id. This new action is now used for the 'feeding' action ('F') in
	  SI using function 0x615. This function seems to exists only with Silver
	  Seed installed, so the old feeding action has been remapped to 'Ctrl-F'.
	  Also, Implemented feature request #279328.

2009-05-18	Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation with a lot of changes since Exult 1.2. Work in progress, 
	  not yet finished or proof read, Audio section needs to be looked at by people 
	  who know what they are talking about. Mods not yet explained. Only for SVN, 
	  not for our website.

2009-05-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixes to experience value computation.
	* Fixed Skara Brae/New Magincia moongate destinations in Keyring mod.

2009-05-05	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Improved MinGW compilation instructions to cover GTK_BASEPATH environment
	  variable.

2009-05-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #2785315.

2009-04-30 Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated FAQ a bit

2009-04-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Implemented feature request #2784001: ES will now prompt to create a new
	  game if no games are installed or if the specified game is not found.

2009-04-28 Dominik Reichardt <dominus@users.sourceforge.net>
	* Updated Documentation a bit
	
2009-04-26	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #2781239.
	* Fixed bug #2781432.
	* Eliminating several GCC 4.3.3 warnings.

2009-04-22	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed more OpenGL bugs; BG and SI intro and endgames play in full now. The
	  Exult menu now works correctly, as do mods and setup menus. Added faster
	  routines to get bounding power of 2 size for OpenGL textures.
	* Fixed a few miscolored pixels in Exult menu logo.
	* Fixed subtitle bug in SI intro -- they would not display if audio was
	  disabled but voice was enabled.
	* Cleaned up BG & SI intro and endgame OpenGL code. Made consistent use of
	  #ifdef HAVE_OPENGL, instead of checking #if HAVE_OPENGL. OpenGL now only
	  clears shapes that have palette rotation when rotating the palette.

2009-04-20	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed several bugs in OpenGL: Cheat menu, shape browser, game menus now
	  work correctly; main (Exult) menu still wonky. BG intro, except for the
	  guardian cutscene, works correctly; SI intro, and BG and SI endgames do
	  not yet work.
	* Fixed mistaken if assignment that prevented changing scalers to anything
	  other than pixel, interlaced, OpenGL and Hq3x scalers.
	* Removed several GCC 4.3.x compilation warnings, including some paranoid
	  ones. Removed several unused variables, and optimized the memory layout
	  of a few classes.

2009-04-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Applied variation of patch #2272014.
	* Fixed bug #1598910 and #2764270. The latter was done by tying scalers and 
	  scales more tighly; except for point, interlaced and OpenGL scalers, each
	  scaler uses only its "native" scale, ignoring (and overwriting) the value
	  in exult.cfg.
	* Some lerping code is now executed only if lerping is enabled.
	* Fixed a few bugs in OpenGL code, eliminating several crashes. OpenGL now
	  will correctly set lighting, though this may come at a performance hit.
	  The Exult menu and game menus/intros sort of work now, but the cheat
	  screen and shape browser are still broken. The MinGW makefile now has an
	  option to enable OpenGL, and configure.ac now includes checks for header
	  presence.
	* Slightly changed warning options in configure.ac, and make paranoid
	  warnings work again.
	* Fixed bug #2773133.

2009-04-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #2770944.
	* Removed a few warnings.

2009-04-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed crash in SI endgame (and possibly intro).

2009-04-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* content/bgkeyring/*/*: LB's crown grants infravision now.
	* content/*/README: Corrected link to site.
	* All else: Fixe bug #2710720. Also prevent similar flicker that happens
	  with invisibility.
	  While fixing bug #2710720, found out the meaning of 3 intrinsics
	  from the original games:
	    - 0x82 (BG)/0x9C (SI): set_light: marks a light source as being equipped
	      or unequipped. Among other things, this prevents a minor flicker with
	      the helm of light when it was being unequipped. It also means that
	      light sources need to call this intrinsic to display correctly as
	      Exult no longer does the work.
	    - 0x84 (BG)/0x9E (SI): set_time_palette: Resets palette to the correct
	      one based on time of day/weather/lighting.
	    - 0x9F (SI): ambient_light: Toggles (based on flag) an infinite version
	      of the cause_light intrinsic. Has been made available for BG too.
	    Based on the intrinsic distribution, intrinsic 0x83 (BG) or 0x9D (SI)
	    must relate to palettes/lighting, but what does it do?
	  Also updated the intrinsic documentation.
	* Updated ucxt slightly.

2009-04-06	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Prevent exclusive gloves from going to the gloves spot due to paperdoll
	  data.

2009-03-31	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* Added the Windows Mobile 6.0 Professional SDK (ARMV4I) platform to
	  MSV9 and tested.

2009-03-29	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* Made it so MSVC9 could compile Exult (just tested for Pocket PC 2003
	  (ARMV4) and Windows Mobile 5.0 Pocket PC SDK (ARMV4I) Releases

2009-03-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs #2717401, #2717420 and possibly many others not reported yet.

2009-03-27	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #2694945.
	* Fixed bug #2716264.
	* Fixed incorrect tag written by ES when setting title/codepage.

2009-03-14	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed bug #2687078.
	* objs/eggs.cc: Check mapeditor flag first.
	* objs/objs.cc, shapes/shapeinf.cc: Moved barge seat rotation code to the
	  overall rotation function.
	* shapeid.h: Implemented simple cache for shape information, wasting memory
	  for performance.
	* files/U7obj.h: Fixing memory leak.
	* shapes/*.h: Fixed memory leaks.
	* Fixed several warnings, including a mistaken assignment in an if and many
	  missing return values in non-void functions.

2009-03-13	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* General: Unified ready types and paperdolls for BG and SI. BG and SI Ready
	  types are converted on load to Exult's (and back when saving), and the
	  only differences between BG and SI ready types/paperdolls being the shape
	  and paperdoll data. Expecting many bugs...
	  Added optional secondary and tertiary ready spots for shapes, to de-hard-
	  code alternate spots and BG cloaks.
	  Added frame powers for shapes, de-hard-coding swamp boots. Such equipment-
	  granted powers, as well as equipment-granted immunities are now cached.
	  Fixed bug #2682606; moreover, shapes of NPCs that cause earthquakes have
	  been de-hard-coded.
	  Types of barge parts, and barge classes, have been de-hard-coded.
	* actors.cc: Fixed bug #2682648. More slots call usecode when initializing
	  from a savegame.
	* drag.cc: Fixed bug #2683129.
	* imagewin/*: Reorganized scaler code, and split them into their own files,
	  by similarity. This should help with the OpenBSD memory issues reported
	  in bug #1681788.
	* objs/jawbone.cc: Removed unnecessary check.
	* schedule.cc: Fixed bug in patrol schedule.
	* shapes/shape_inf.cc: Fixed bug in copy function and unitialized variables
	  in constructors.
	* shapes/shapevga.cc, shapewrite.cc: The classes Functor_data_reader and
	  Functor_data_writer required too much information they didn't use; this
	  information is now required by the functors they use.
	* Fixed bug on monsters and quake-on-walk. Fixed incorrect initial values
	  of ready types. Some Doxygenification.
	* Fixed compilation bug due to missing include.
	* Added unoptimized debug mode with heavy GDB symbols.

2009-03-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed recently-introduced bug in npc_nearby intrinsic.

2009-03-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* palette.cc: Prevent accessing palettes that failed to load.

2009-03-01	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actorio.cc: Monsters that can't die are forced to have full hp when
	  the game is loaded.

2009-02-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/*: Unswapped UI_set_oppressor and UI_set_opponent in BG and SI
	  intrinsic tables. Confirmed with some custom usecode and the cheat screen
	  in the original games. Fixed UI_play_music to accept > 356 NPCs.
	  UI_npc_nearby only accepts NPCs, and doesn't report them if they are
	  dead, asleep or paralyzed; UI_npc_nearby2 doesn't seem to be affected by
	  those flags, though. Removed special case for Freedom in UI_move_object,
	  as it no longer seems to be neccessary. In UI_clone, have the cloned
	  NPC be friendly, not the original monster *and* the clone. Added safety
	  clause in UI_set_oppressor preventing the NPC from being his own oppresor;
	  also, the unswap above makes unneccessary for this intrinsic to set a
	  target now. UI_get_timer now returns a random value for uninitialized
	  timers. UI_is_readied and UI_get_readied both use the same spot conversion
	  for BG, and the same spot conversion for SI. Fixed invalid return for
	  UI_get_npc_id when given anything but an NPC.
	* docs/exult_intrinsics.txt: Massive update with format changes.
	* Actors.cc: When an NPC is defeated, others NPCs attacking him will switch
	  to new targets. Also, when setting a new target for a NPC, the NPC's
	  oppressor, if any, is reset if he is not actually attacking the NPC.
	* content/*/*: Unswapped the above intrinsics. Removed UCC compilation
	  warnings about missing 'void' in function declarations.
	* schedule.cc: Increased maximum distance at which party members will sit
	  still if the avatar is not moving (fixes Stefano in Freedom).
	* ready.h, mapedit/*: Moved ready.h to shapes/ready.h, and added several
	  new constants used in usecode. These constants are now used in Exult
	  Studio. Fixed some errors in the shape class conversion in ES.
	* actorio.cc: Monsters that can't die are forced to have at least 1hp when
	  the game is loaded (fixes bug #2641856).
	* Make NPCs more aggressive about fighting back, and added more cases where
	  invisible NPCs join the fight (fixes bug #2641154).
	* Fixed serpent bond bug in SI Fixes.

2009-02-26	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #2638479.
	* Allowing NPCs in sleep schedule to do stuff again.

2009-02-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fix for multithreaded build (make -j <n>).
	* Fixed recently introduced compilation issue in GCC 4.0.

2009-02-24	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed recent ES performance hit when toggling frames display.
	* Fixed condition check for shape right-click in ES.
	* Fixed hash_utils.h once and for all, and added proper check in configure.ac.

2009-02-23	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed several bugs from the tracker: #1559936, #1851478, #2121276, #2127362,
	  #2127508, #2122907, #2454975
	* Modified a few constants to be less dependant on the tile size being 8px.
	* Foes struck by magebane will seek a new weapon after being hit if they
	  lost their spells.
	* Prevent stats from being set outside the [0, 60] range by the cheat screen;
	  HPs are the sole exception, being settable in the [-50, 60] range.
	* Added FoV and SS to the list of games that do not change the screen size
	  when started from the commandline.
	* Applied part of patch #2348451, and a modified patch #2371363.
	* Eliminated more GCC 4.3.x compilation warnings.
	* Fixed goblin spawns in Fawn Tower. Contrary to popular opinion, it has
	  nothing at all to do with pikemen in the area or finishing off the goblins
	  in the area: monster eggs in SI simply do not seem to hatch in SI if the
	  egg's Z-coordinate differs by more than 4 units from the avatar's when the
	  egg is cached in. Also, extended jukebox egg behavior to other sound eggs.

2009-02-22	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* UCC: Added optional 'void' keyword to specify an usecode function without
	  returns (and warnings for missing that keyword). Improved handling of UCC
	  structs, and allowed them as function arguments and returns; fixed bug
	  with class member struct variables. Made #include directive include a file
	  only once, like PHP's #include_once.
	  Added 'nested' option to 'converse' blocks to force UCC to push/pop the
	  answers on start/end of the converse block; used as follows:
	  	converse : nested (options) { case-list }
	* Keyring: Added 'void' keyword to eliminate warnings.

2009-02-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/contain.cc: Prevent avatar from being dragged into containers.
	* UCC: Function calls can now be class expressions too, and be used in the
	  right hand side of a class assignment.
	* All others: Use filename definitions instead of literals.
	* Keyring: Fixed problem meditating in shrine of spirituality.

2008-11-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed problem with playing Ogg in a non-IFF endgame.dat. Fixed SI intro/
	  endgame using hardcoded paths instead of those passed to constructor.

2008-11-03	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/compiler/ucparse.yy: Fixing compilation errors.

2008-11-01	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/*: A few fixes to UCXT data files. New built-in constants for UCC.
	  Also, partially failed attempt at getting

2008-10-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamemgr/*: Using file names from fnames.h. Define in SI the resources used
	  by the shapes browser.
	* files/U7file.h: Documentation error.

2008-10-04	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gumps/Jawbone_gump.cc: Remove incorrect and unnecessary check.
	* all else: Fixed resources loaded from XML file. Made Game::get_resource
	  return 'const str_int_pair&' instead of 'str_int_pair'.

2008-10-03	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed segmentation fault on loading fonts.

2008-10-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* General: Doxygenified lots of code. Some reformatting. Implemented changes
	  due to changed file API in 'files' dir. Lots more files can be patched
	  now, including difference patching. Removed some unused functions and
	  variables.
	* files/*: Split some classes into their own files. Decoupled reading from
	  a format from reading from a file. Improved support for patches (whether
	  from files or from memory) in basic file format reading classes. Updated
	  copyright notices. Removed function used only by Expack from base flex
	  class. Removed unused instances of PENTAGRAM conditional compilation.
	  Reduced the number of exceptions thrown to make multiple source patches
	  more forgiving of missing files. More throrough use of C++ streams instead
	  of C IO functions, including removal of FileDataSource class.
	  'Flex', 'IFF', 'Flat' and 'Table' classes are now sourceless base classes
	  responsible for reading a format from an unspeficied source, while the
	  derived (typedef) classes 'FlexFile', 'IFFFile', 'FlatFile', 'TableFile',
	  'FlexBuffer', 'IFFBuffer', 'FlatBuffer' and 'TableBuffer' read from a
	  file or from a memory buffer according to the base class; in general, it
	  is better to use FileManager::get_file_object, U7object, U7multiobject or
	  even ExultDataSource than it is to use the *File and *Buffer classes
	  directly as they try to detect the format of the filoe in question.
	* browser.cc, cheat_screen.cc, gamemgr/*: Also store patch palettes for BG/SI
	  in the game resource list. Use palettes from patch if they are present.
	* shapes/fontvga.*: Fonts.vga now properly accepts differential patches.
	  Removed limit of 11 fonts; fonts 11 and above have horizontal and vertical
	  leads set to zero.
	* audio/*: Allowing OGGs for voice. Allowing new games to use digital music,
	  with files named 'XXmus.ogg' ('XX' a 2-digit number) placed in 'music'
	  subdir of 'static' or 'patch' dirs.

2008-09-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapes/shapewrite.cc: Actor flags were incorrectly saved.
	* shapeid.cc: Pass editing flag when loading shape info.
	* mapedit/studio.*: Fixed crashes when string conversion receives a null
	  pointer for conversion.
	* game.*, files/U7file.h: Removed unused function , fixed incorrect comment.
	* data/*/*, win32/*: Added paperdol.vga for new games.

2008-09-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/shapeedit.cc, shapes/shapeinf.*: Reverted previous commits as they
	  caused too many problems.

2008-09-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamemgr/modmgr.cc, shapes/shapevga.cc: Fixed problems when creating new
	  games from within ES.
	* mapedit/shapeedit.cc, shapes/shapeinf.h: Changing offsets didn't flag a
	  shape as modified. Fixed recently-introduced bug where shape info was
	  never marked as modified; also improved detection of shape modification.

2008-09-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.*: Prevent damage to dead NPCs (makes armageddon work better).
	  Prevent Penumbra and Skara Brae ghosts from awakening in a more consistent
	  manner.
	* npctime.cc: Fixed waking up of NPCs by proximity.
	* keyactions.cc, objs/spellbook.cc, usecode/*: set_intercept can now store
	  a tile as well as an object.
	* mapedit/*, gamemgr/*: Added way to set an encoding option for text of mods
	  and games to ease translation mods.
	* General: Eliminating almost all GCC 4.x compilation warnings.
	* usecode/compiler/ucparse.yy: Indirect intrinsic calls can be done using
	  '(@num)(params)' or 'obj->(@num)(params)'.

2008-09-04	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* tools/ipack.cc: Fixed Shape_spec constructors, mix-up of strdup/delete.
	* objs/spellbook.cc: Fixed spell costs in SI.
	* actors.*, schedule.cc: Have sleep schedule set/clear sleep flag (fixes
	  Gorlab with automatons in party).
	* cheat_screen.cc: Prevent more than 8 party members.

2008-09-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Audio.*, gamemgr/bggame.cc: Synchronized static with static sound in
	  BG intro. Made skipping speech stop speech.
	* usecode/*: Reverted demonstrably wrong itemref behavior. Added usecode
	  array stealing to create_script instead of making a copy.
	* audio/*, drag.cc: A few SFX fixes for BG/SI.
	* effects.cc: Prevent missiles from hitting the attacker if it is equal to
	  the target (fixed death bolt/mind blast loops when avatar is target).
	  Added hack to call the missile's usecode (with target = 0) even in that
	  case (makes mind blast behave like the original when targetting avatar).
	* actors.cc: Fixed powers of nondamaging spells.

2008-09-01	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.*: Prevent weapons with no base damage from causing any damage.
	  Keep spellbook in hand if NPC can still cast selected spell. Save custom
	  shape to be used as casting frames (mainly for new games).
	* combat.cc: Prevent fellow party members from acquiring avatar's target if
	  the latter is not in combat (allows easier hitting of Draygan (SI) with
	  a sleep arrow before party members block the shot). Fixed the use of
	  bookmarked spells in combat. Prevent missile weapons (and spellbok) from
	  attacking inanimate targets more than once.
	* data/*/*, shapes/*, mapedit/*, objs/chunks.cc: Mountain tops have been
	  made into an enum instead of a flag, and now handle snow mountain tops
	  too, as the flags that were being used were nothing but a coincidence.
	* objs/spellbook.*, usecode/ucmachine.h, ucinternal.h: Added functions to
	  remove a single spell and to check if a spellbook has a given spell.
	  Specify default casting frame shape. Use intercept_item to preselect
	  target for spells cast in combat with spellbook in hand (but saving and
	  restoring previously set intercept_item).
	* usecode/ucsched.*: Added a way to prevent scripted barks from being
	  shown. This happens (e.g., with the avatar after the teleport storm but
	  before the fight between Thoxa and Karnax) due to clear_item_say
	  intrinsic.
	* usecode/*: click_on_item intrinsic no longer need the avatar special case
	  for event == weapon as the spellbook now uses intercept_item. Added two
	  new intrinsics: has_spell and remove_spell. Fixed a few planet's positions
	  in set_orrery. begin_casting_mode now accepts an optional parameter that
	  specifies the shape to use for casting frames (default is 859). The push
	  itemref opcode now pushes the (negative of) an NPCs' number for NPCs;
	  this is needed, e.g., for death bolt (BG) and mind blast (SI).

2008-08-30  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* audio/midi_drivers/timidity/: copy sanity checks from SDL_sound

2008-08-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixing a few world-wrapping-related bugs (including #2046951).

2008-08-28  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* audio/midi_drivers/timidity/timidity_resample.cpp:
	  fix invalid memory access (fix copied from SDL_sound)

2008-08-14	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* data/si/shape_info.txt: Eliminating duplicate data.
	* audio/conv.cc: Added indices for the array elements.
	* All others: games/mods now store the cfg name as well as the path prefix
	  tag. The latter is now mostly decoupled from the former (the exception:
	  for new games, it is "DEVEL_" plus the uppercase of the cfg name), being
	  based on the game's identity instead.

2008-08-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixing yesterday's multiracial fix for the cases where SS is installed
	  under 'serpentisle' in Exult.cfg (like is most likely is for the vast
	  majority of cases) of FoV under 'blackgate' (likewise).
	  Several 'string'->'const string&' in functions.

2008-08-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Making multiracial avatars work again in BG if only SI with the expansion
	  is installed. Also, added the system paths "<ULTIMA7_STATIC>" and
	  "<SERPENT_STATIC>" that always point to the static directory of the games
	  (preferring the expansions).

2008-08-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug #2036349.

2008-08-01	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Made armageddon spell behave like originals. Made Armageddon immunity into
	  settable trait in ES.
	* Fixed Petra's portrait when body switched.

2008-07-26	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* New NPCs created with ES now have their 'walk' flag turned on by default.

2008-07-24	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed some apparent lock-ups due to palettes not being updated.
	* Improved talk dialog in SI when double-clicking someone already within
	  talking distance.
	* Fixed uninitialized variable.

2008-07-23	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Minor bugfixes to Keyring and SI Fixes mods.
	* UCC: Fixed usecode class inheritance. Fixed test1.uc so that it compiles.
	* gamemgr/*: Mod manager bug which showed entries for some games that were
	  not present.
	* palette.cc: Prevent palettes from being applied if the game is faded out.
	* objs/jawbone.cc: Missing return in function.
	* usecode/ucxt/src/ucdata.cc: printf parameter was wrong.

2008-07-22	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed old-style "response" conversations. They work identically to converse
	  case blocks now, but are slightly less versatile (e.g., there is no "remove"
	  keyword). "response" dialogs can also specify multiple strings now through
	  the "in" keyword; see test1.uc for examples.
	  Also, added a possible "default" case for converse-case blocks, and a
	  "user_choice" expression which pushes the last-selected answer in the stack.
	* Fixed SI turtle (bug #2020101).
	* Hostile creatures now attack the avatar once more -- and the avatar will
	  also target them when in combat mode (bug #2024437).
	* Fixed polymorph and Petra bugs #1963551 and 1978514.
	* Fixed menu bugs #2024853 and #2024813.

2008-07-21	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Modified animation recycles to fix bug #2020103; recycle (if nonzero) is now
	the number of frames at the end of the animation to repeat.

2008-07-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixing PNG detection when importing PNGs. Also, added some checks when
	importing shp files.

2008-07-14  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* configure.ac: remove AC_PATH_XTRA. Its output is apparently unused
	  and it breaks configure on non-linux platforms

2008-07-12  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* configure.ac: fix underquoted help strings
	* various: warnings
	* shapes/weaponinf.cc: fix missing return value
	* usecode/compiler/basic_block.h: fix missing return value

2008-07-09	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* README.win32: Updated links to more recent versions of MinGW. The file
	  'exult_dev_win32.zip' (that contains several files needed for a MinGW
	  compile), has been updated with a new version of Bison and Flex (both
	  from GNUWin32) in the project shell space. Using the newer versions
	  pointed to in the readme fixes a few problems in recent Win32 snapshots.
	* mapedit/shapeedit.cc: Fixed crash on loading of creatures with bodies
	  in ES.

2008-07-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gameclk.cc, cheat_screen.cc: Reverted previous fix and submited the correct
	  one: forcing palette to apply when it is directly set.
	* actors.cc: Fixed recent invisibility palette bug for avatar. Fixed mixing
	  of rings and gloves in BG due to faulty condition check, and did a
	  preventive fix for a similar case with two-handed weapons.
	* combat.cc: Fixed monsters attacking each other (bug #2013092).
	* objs/objs.cc: Reverted previous commit. Better positioning of missiles.
	* shapes/*: Fixed fixed-head paperdolls: patching skin shape info would
	  overwrite paperdoll data from paperdol_info.txt.
	* mapedit/studio.cc: Check to see if map needs to be saved on 'save all'.

2008-07-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/objs.cc: Fixed bug that could cause large creatures to attack
	  themselves with projectiles. This should also prevent other creatures from
	  attacking allies.
	* actors.cc: Avatar should render correctly when invisible again.
	* cheat_screen.cc: Fixing palette mix-up with cheat screen (thanks to
	  Malignant Manor).
	* gumps/Sign_gump.cc: Fixed font for tombstones Also, moved combat toggle
	  button up 3 pixels to prevent overlap with halo button (both thanks to
	  Malignant Manor).

2008-07-07    <jeff@mini.nerble.net>

	* objs/objs.cc: Fixed delta_wrap_check, so dragons attack better.

	* combat.cc (Combat): Fixed problem with invisible monsters not
	attacking.

2008-07-05	Marzo Sette Torres Junior <marzojr@yahoo.com>
	actors.*, actions.*: Put some deleted actor actions into queue to prevent
	bug #1980431.

2008-07-04	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* monsters.cc: Fixing incorrect initial monster stat generation.
	* schedule.cc: No longer refer to class variables after possible schedule
	  change. Also, remove possible double-deletion on scripted schedule.
	* gamewin.cc, gumps/Notebook_gump.h: Read in notebook when loading a saved
	  game (prevents data loss if notebook is not manually opened before saving
	  since last reload).
	* actors.*: Fixed cache-out crash in areas with dead bodies (bug #1998960).

2008-06-16  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* shapes/monstinf.cc: fixed undefined experience value

2008-06-15  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* actors.cc: removed some using std::'s to improve gcc 4.3 support

2008-06-14	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* fnames.h, mapedit/studio.cc, server/*: Consolidating name of socket file
	  in Exult/ES communication to be "<GAMEDAT>/exultserver" on all OSes.
	* server/servewin32.cc: FILE_SHARE_DELETE flag prevent CreateFile from
	  working in Win9x, preventing ES from working there.
	* actors.cc: Making NPCs quit combat/attacking a target after dying.

2008-06-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixing handling of dead bodies, including flags.

2008-06-10	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamewin.cc: Fixing segfaults on exit.
	* actors.cc: Fixed checks that were failing due to operator precedence.
	* effects.cc: Fixed crash on using Death Vortex/Energy Mist. Fixed Death
	  Vortex and Energy Mist.
	* monsters.cc: Fixed carpet-filled monster inventory bug.
	* shapes/shapeinf.cc: Correctly initializing monster food value.
	* Fixing reagents mismatches between Exult and original games.
	* Fixed ammo counting bug causing some ranged weapons to not be found.
	  Improved attacking when switching dead weapon.

2008-06-03	Marzo Sette Torres Junior <marzojr@yahoo.com>
	BIG Commit (TM). Quite likely, there are a lot of bugs.
	* Version bump to 1.04.05cvs due to massive internal changes and also due to
	  the fact that pre-1.04.05cvs animation data is INCOMPATIBLE with CVS head
	  and WILL NOT WORK. Also, pre-1.04.05cvs versions of Exult WILL CHOKE and
	  most likely die with this new data.
	* Warning: previous versions of Exult Studio lost information when it saved
	  weapons.dat, monsters.dat and ammo.dat data files. There is a command to
	  fix this by reloading the static data; this will only affect shapes that
	  had this data in the original: the Death Scythe would be reset, but if you
	  gave weapon data to a door, it would not be reset.
	* msvcstuff/*: Added new files to projects.
	* Makefile.mingw: 'turbo', configurable makefile. Command-line parameters
	  or environment variables can now be used to specify the workings of a
	  MinGW compilation.
	* De-hard-coded data:
	  - What items are lightweight (i.e., weight 1/10 normal) such as coins;
	  - What items have quantity-dependent frames (e.g., arrows);
	  - What items constitute 'locked' containers (such as locked chests);
	  - What items are volatile explosives (such as the powder keg);
	  - The frame of food items (shape 377) dropped by monsters;
	  - Creatures which don't eat;
	  - Creatures immune to freezing;
	  - Content rules for containers (such as the Jawbone, which accepts only
	    teeth, and urns, which reject everything);
	  - Frame- and quality-dependent hit points for otherwise indestructible
	    objects (such as powder keg being destroyed if quality == 0, but not
	    otherwise, or wooden doors being destructible but metal doors not);
	  - Frame- and quality-dependent names (for example, SI urns and bodies
	    showing the NPC name, reagents, several SI quest items, etc);
	  - How much warmth is given by worn items. Such data is also included for
	    BG items by default, and is based on SI data.
	* Changed formats:
	  - Creatures that can teleport, summon or turn invisible no longer have
	    their data saved to monsters.dat; this is because non-monsters can also
	    have these capabilities. Instead, it is saved to shape_info.txt. For
	    backward compatibility, the monster.dat data is still read.
	  - As mentioned above, animation data has changed dramaticaly and is not
	    backwards-compatible. Exult will ignore old data, and previous versions
	    of Exult will most likely crash if given the new data.
	  - Due to a New Thing (tm) being tried for dead bodies, the first frame of
	    any body shape should be empty (as it is for all bodies in the original
		games).
	* Changed/modified intrinsics:
	  - get_npc_prop/set_npc_prop: You can now get/set an object's health. This
	    is done, for example, by the serpent statue at the end of SI, but it can
	    be done in BG or SI for any objects that have hit points.
	    Additionally, experience changes are divided by 2 -- this happens in the
	    original games, and reduces overall XP inflation.
	  - set_to_attack: Can be used to attack tiles, not just objects. The originals
	    can do this, but never did so.
	  - attack_object: Finally fully implemented, it now just forwards the call
	    to Combat_schedule::attack_target.
	  - apply_damage: Forwards to Actor::apply_damage or Game_object::apply_damage.
	  - fire_projectile: Last unknown parameter is attack value to use when the
	    missile reaches its target.
	  - get_item_flag: Flags 13 (power safe) and 14 (immune to death magic) have
	    been implemented. no_spell_casting is actually flag 31 in SI.
	  - play_sound_effect2: Sound volume is now adjusted for distance, even if
	    relative changes.
	  - remove_item: Will no longer delete NPCs, just remove them from map.
	* New things allowed in BG:
	  - You can now get/set temperature. If the gump shape has enough frames,
	    it will also change like in SI. The following intrinsics can be called
	    from BG now: get_temperature, set_temperature, get_temperature_zone,
		get_npc_warmth.
	* General changes: Most shape data previously available in shapes/miscinf.cc
	  has been moved out. Likewise, the shape information classes from the file
	  shapes/shapeinf.* have been moved out, so that this file contains only the
	  Shape_info class. The shapes/*inf.* files (except for miscinf.*) have
	  single classes that each handle a set of correlated data (basically,
	  sections in text data files or U7/SI dat files). These classes were
	  structured for editing and allowing the use of differential patches.
	  The ready.dat data has been conceptually split into a spot and flag.
	* The attack/damage system has been overhauled based on statistical data
	  gathered from the originals, as well as a series of carefully crafted
	  tests to determine sequencing as much as possible. There is also a lot of
	  new data implemented. This affects combat as well as several intrinsics.
	  NPCs with tournament flag will be extremely tough now.
	* Dead NPCs will kneel and die, while NPCs put to sleep will kneel and lie
	  down. NPCs can also become unconscious from damage. Also, flying NPCs will
	  fall to the ground and take damage in these cases.
	* Dead bodies have been extended to store 16-bit NPC numbers.
	* Non-actors are no longer able to use set_to_attack/attack usecode.
	* The experience formula is now a near-exact match to the original games'.
	* Improved readying new weapons. Works very close to the original games,
	  including the fact that readying a 1-handed weapon also readies a shield
	  if the off-hand is free.
	* Monster stats are randomized; the randomization is based on statistical
	  tests in the original games. The same applies to initial monster attack
	  modes.
	* Prevented the use of objects (including keys) is they are contained in a
	  locked container. You also can't put objects inside locked containers
	  anymore, nor can you take them out, nor can they be found by most usecode
	  intrinsics. This is likely to cause problems...
	* Item names in SI and SS are remapped the other way around now: SI messages
	  are remapped to SS message IDs instead of having some message IDs in SS be
	  remapped from SI values. This is done when the messages are read.
	* Changed SFX distance formula to give a more realistic fall-off.
	* Exult Studio can now recognize and edit all of the data from the original
	  *.dat files as well as all de-hard-coded data present in the following
	  files: bodies.txt, paperdol_info.txt, shape_info.txt; this includes the
	  data de-hard-coded mentioned above.
	* First steps towards the ability to browse for games: consolidated the way
	  games are handled, by using the identity of a game to detect the flexes it
	  uses. Also allowed concurrent use of BG and FoV, Si and SS; Exult will now
	  recognize "forgeofvirtue" and "silverseed" as well as "blackgate" and
	  "serpentisle", and the parameters "--fov" and "--ss" in addition to "--bg"
	  and "--si". The older parameters will still load FoV and SS if the unmodded
	  games are not installed.

2008-06-01	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* conf/Configuration.cc: Recognize paths starting with "../" as relative
	  paths. This should fix bug #1738138.
	* mapedit/shapedraw.cc: Extra safety when drawing centered shapes.
	* gameclk.h, shapes/vgafile.cc: Change initialization order in constructors
	  to reduce number of GCC 4.x warnings. Also, added code to recover memory
	  used by shape_sources when reseting Vga_file.
	* cheat.cc, shapeid.h, usecode/ucdebugging.h, usecode/conversation.h,
	  pathfinder/PathFinder.h, gumps/*.h: Added virtual destructors to virtual
	  base classes and their derived classes.
	* objs/mappatch.cc: Replacing iterator++ with faster ++iterator.
	* cheat_screen.cc, objs/flags.h: Correcting flags based on original games.
	* actorio.cc: Removed double-check on monster death before write.
	* usecode/ucdisasm.cc: Added some more special cases.
	* files/databuf.h: Added clear_error virtual method to DataBuffer classes.
	* docs/u7tech.txt: Full documentation of upcoming changes to *.dat files,
	  based on the original games. Some changes for u7iregXX documentation.
	* tools/ucdump.c, tools/mklink.c: Eliminating a few warnings.

2008-05-31  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* various: initialize variables, minor clean-up 

2008-05-30  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* various: initialize variables
	* schedule.cc: don't access member variable after being deleted

2008-05-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/objs.cc: Removed fire-vs-ice effect previously introduced.
	* usecode/intrinsics.cc: Fixed powder-keg-as-weapon case of attack_object
	  intrinsic to behave as the original does; incidentaly, this fixes the
	  gwani horn. This is a temporary workaround, until attacks and intrinsics
	  are "properly" fixed to behave like the originals.

2008-05-27  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* various: some 64-bit and/or gcc 4.1 compilation fixes
	* objs/chunks.cc: delete[] vs delete
	* various: initialize some variables

2008-05-26    <jeff@mini.nerble.net>

	* objs/objs.cc: In SI, fire-damage destroys ice wall and blocks,
	so you can free Gwenno.

2008-05-23    <jeff@mini.nerble.net>

	* shapes/miscinf.cc: Don't infinite loop if animated object has
	been rotated.

	* objs/barge.cc (Barge_object): Changed criteria for gathering
	'barge' objects so flags aren't caught (but the ice-raft still works).

2008-05-03    <jeff@mini.nerble.net>

	* effects.cc (Projectile_effect): Fixed crash involving trap.

2008-04-14    <jeff@mini.nerble.net>

	* objs/chunks.cc (Chunk_cache): The 'blocking' detection now
	handles lifts >= 15, and should save a bit of memory for chunks
	with lifts < 8.

	* objs/citerate.h (public): Fixed bug when size is 1x1.

2008-03-30    <jeff@mini.nerble.net>

	* cheat.cc, etc: Support higher lifts, up to 255.  Note that the
	file formats still need to change for this to fully work.

2008-03-21	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exultmenu.cc: Was missing in previous commit; updated mod manager to use
	  vectors and classes instead of pointer to vectors and classes.
	* All: Fixed default game directory to be the Exult.cfg-defined game name.

2008-03-20	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* studio.cc: Fixed long-standing mod-manager crash.
	* all: Updated/reformatted mod manager files to use vectors and classes
	  instead of pointer to vectors and classes. Improved default game directory
	  to be the Exult.cfg-defined game name (e.g., BG and SI have default dirs
	  './blackgate' and './serpentisle'). Some readmes were updated accordingly.

2008-03-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixing bug that caused reserved NPC #356 to be available when creating
	a new NPC.

2008-02-26	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* UCC: Added integer casting: '(byte)', '(char)', '(int)' and '(long)' will
	  force, respectfully, 8-bit, 8-bit, 16-bit and 32-bit integers. Default is
	  16-bit integer, and warnings will be issued in some cases. UCC does *not*
	  try to guess integer sizes anymore, except for function IDs and jump
	  offsets, to prevent past problems.
	* Keyring/SI Fixes: Eliminated compilation warnings due to the UCC changes.
	  Fixed 10-fold error in (unused) DAY constant. Added new diagonal moongates
	  to keyring.

2008-02-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	UCC: Fixed actor frame keyword bug.

2008-02-23	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed palette rotation bug on portraits by making them all translucent.
	* Fixed crash on SI when BG Paperdolls are turned off and a character's gump
	  is opened. Switched shape data to load after game flx is laded.

2008-02-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	UCC: Improved handling of structs. Added a manner of specifying the integer
	size of enums with the (optional) constructs
		enum IDENTIFIER : int { const list };
		enum IDENTIFIER : byte { const list };
		enum IDENTIFIER : char { const list };

2008-02-18	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Audio.cc: Fixed occasional segfault when doing garbage collection
	  on SFX cache.
	* pathfinder/Zombie.cc: End path if new z coordinate is less than zero.
	* Others: Switched iterator postfix increment to faster prefix increment.

2008-02-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	UCC: Fixed usecode structs generating wrong indices into array. Fixed aliases
	to structs and classes so they can be of differing base types. Static structs
	can now be dlaclared.

2008-02-16	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/ucsched.*, usecode/ucscriptop.h: Implemented two new opcodes from
	  the originals: wait_while_near and wait_while_far, which cause the script
	  to halt depending on the avatar's distance from the script object. Step
	  opcode 0x53 has been revised with a (verified) delta-z parameter. Due to
	  SI's buggy usecode, which neglects to add this extra parameter on any of
	  the uses of this opcode, most of the steps taken with this opcode will
	  fail to happen -- which incidentally also happens in the original games.
	* usecode/ucinternal.cc: Added opcodes to perform the following operations
	  with usecode class member variables: array loop, aidx, set array elem.
	  Also slightly modified aidx so that it exactly matches the originals.
	  Allowing array size changes in BG too, as it is possible, even if it is
	  not used, in the original.
	* usecode/compiler/*: Added usecode structs; they are defined like classes,
	  except that they cannot have member functions and do not have inheritance.
	  They also have minimal type-checking, unlike classes, being thin wrappers
	  around normal usecode arrays. Example definition and use:
		struct Tile { var x; var y; var z; }	// Definition
		struct<Tile> pos = get_object_position();
		pos.x += 1;
	  Structs with struct members simply merge the variables of the inner struct.
	  For example, using the Tile struct above,
		struct Obj { var object; struct<Tile> pos; }
	  is completely equivalent to
		struct Obj { var object; var x; var y; var z; }
	  In fact, the 'pos' member struct can be defined without a name:
		struct Obj { var object; struct<Tile>; }
	  Also added reference or alias variables, which are a relabelling of the
	  variable. This can be used to 'cast' a var to a struct or from a struct
	  to another. Syntax:
	    var alias varname = declared_var;
	    struct<defined_struct> alias varname = declared_var;
	    class<defined_class> alias varname = declared_class;
	  In all cases, an ampersand ('&') can replace the word 'alias'. These are
	  compile-time references only, not dynamical ones.
	  Improved localization of errors/warnings for a few statements.
	  Added ability to specify initial counter for inner repeat script command.
	  Also added 'wait while near' and 'wait while far' script commands which
	  take a parameter (distance); they are the UCC version of the new script
	  opcodes wait_while_near and wait_while_far, mentioned above.
	  Defined built-in constants for 'actor frame' script command.
	  Added ability to specify delta-z for 'step' script command.
	  'music' script command now allows the use of a 'repeat' flag, based on
	  previously implemented behavior.
	  Script command 'face' can now use the same built-in constants as 'step'.
	  Usecode 'true' and 'false' can be used as (very limited) int literals.
	  Made a general replacement of postfix increments of STL iterators in favor
	  of the faster prefix increment.
	  Fixed recently-introduced bug in handling of array loops which would end
	  without any of their operators.
	* content/*/src/*: General switch to 'step', 'face' and 'actor frame'
	  built-in constants, which in some cases mean using a different flavor of
	  'step' than was being used. General reformat of dialogs for readability.
	  In SI Fixes, you can now ask Shamino to set your watch to 24-hour format
	  if you prefer. In Keyring, Laurianna now uses UI_change_npc_faceX instead
	  of the old method.

2008-02-14	Marzo Sette Torres Junior <marzojr@yahoo.com>
	UCC: Labels now start their own single-statement block. This allows code
	like 'if (expression) label: statement' to work as in C/C++. Fixed bug in
	swith statements where last case was not correctly linked to the switch end
	block. Added a few more block optimizations (double jumps, double rets of
	the same type, double aborts). Fixed crash on empty functions. End-function
	return is only added if there isn't one already.
	*** UCC: Fixed bug when a block is empty but is target of conditional jumps.
	*** UCC: Fixed bug that caused removal of last block. Uc_fun_name_expression
	and Uc_bool_expression are constants, so they should evaluate to true.
	Uc_binary_expression and Uc_unary_expression failed to set return if their
	inner expressions were not constants.

2008-02-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	UCC: Removing old way of handling labels. Improved dead-block detection.
	Fixed bug in IF statements without a corresponding ELSE statement. Fixed
	a few leaks. Eliminated premature while(0) and if (0) optimizations since
	a GOTO statement may point to somewhere inside these otherwise unreachable
	blocks.

2008-02-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Exult: Removing 32-bit match check for init_loop opcode.
	* UCC: Fixed the use of declared constants for function IDs/shapes.
	  Added several contant-expression optimizations, particularly for while
	  and do...while loops. Added 32-bit-detectino routine which works correctly
	  considering signed 16-bit bounds. Also, allowing 'continue' statements on
	  'for' and 'converse' loops as well as disallowing 'break' statements
	  except for loops and switches. Finally, modified code generation to use
	  basic blocks instead; this allows for some small code optimizations to be
	  performed (e.g., 'if (cond) break; else statements' having only one jump
	  instead of 3) as well as finally being able to use 32-bit jumps with UCC.

2008-02-03    <jeff@mini.nerble.net>

	* actors.cc: Fixed bug where companions would walk on water.

2008-01-27    <jeff@mini.nerble.net>

	* schedule.cc, actions.cc, actions.h: Made the 'talk' schedule
	more aggressive, so it's harder for the Avatar to get away.

2008-01-27	Marzo Sette Torres Junior <marzojr@yahoo.com>
	"Fixed" operator precedence rules for UCC to be more like those of C/C++.
	Making UCC emit bytes for script opcodes as the originals do; UCC is
	now able to declare byte constants with 'const char' and 'const byte'.
	For the same reasons, functions called with CALLE are also linked in the
	same way as functions called with CALL; functions with 32-bit function ids,
	as well as class methods, are not linked. Finally, function IDs/shapes can
	now be specified through defined constants.

2008-01-25	Marzo Sette Torres Junior <marzojr@yahoo.com>
	MinGW specific: Removed Makefile.studio.mingw file; compilation in MinGW now
	uses only Makefile.mingw. Compilation/distribution os ES and the GIMP plug-in
	is done with the (self-explanatory) commands 'studioinstall', 'studiodist',
	'maptools', 'maptoolsinstall', 'maptoolsdist' and 'studioclean'.
	Makefile.mingw commands 'allclean' and 'allinstall' also clean and install
	(respectivelly) Exult Studio (but not the GIMP plug-in).
	Also updated Readme.win32 accordingly.

2008-01-19	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Added overloaded methods for Fast_pathfinder_client::is_grabable to make
	  use of the new distance function.
	* Exult Studio/Exult can now search for a shape of a given frame as well.
	* Fixed can_avatar_reach_pos intrinsic.
	* Switched from DELTA_WRAP_CHECK and DELTA_CHECK macros to static inline
	  functions to prevent possible undetected problems.
	* Update of MSVC projects, including a new project for ES (though I doubt
	  it compiles).

2008-01-11    <jeff@mini.nerble.net>

	* actions.cc (Path_walking_actor_action): 'speed' wasn't being
	initialized, sometimes causing SI to hang at start.

2008-01-09    <jeff@mini.nerble.net>

	* objs/objs.cc: Fixed macro bug in DELTA_WRAP_CHECK that affected
	the 'distance' computation.

2008-01-08  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* exult.cc: fix --buildmap

2007-12-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc, actions.h: Fixed crash when avatar finishes a usecode path.
	  Double-stepping problem is completelly fixed, resulting in perfectly
	  smooth scrolling if it is enabled. Also, added slight delay at the end
	  of all acions, whether they are done by the avatar or by other NPCs.
	* paths.cc, tiles.h, objs/objs.cc: Fixed distance function so it actualy
	  does what it should. Added back a 2d distance function for pathfinders.

2007-12-05    <jeff@mini.nerble.net>

	* mapedit/eggedit.cc, mapedit/exult_studio.glade: Support z-coord
	in intermap teleport eggs.

2007-11-07  Ryan Nunn <colourles@users.sourceforge.net>
	* exult.cc, gamewin.*, gumps/GameplayOptions_gump.cc : Made lerping a 
	  percentage value. Default now to 75% that makes things not quite as 
	  smooth as they were before and seems to be a reasonable tradeoff. 
	  GameplayObjects now has options for disabled, 25%, 50%, 75% and 100%
    * actors.cc : Fixing avatar combat problems, but this really needs a 
      proper solution to my double step problem. The code i've written seems to
      have a few unintended consequences causing extra long pauses when moving
	
2007-11-06  Ryan Nunn <colourles@users.sourceforge.net>
	* effects.cc, exult.cc, gamerend.cc, gamewin.cc, gamewin.h : Two words:
	  "Smooth Scrolling". Some more words: It's a bit of a hack but it works
	  really well. The screen position is interpolated based on the camera 
	  actor's animation rate or get_std_delay() if it's not set. The camera 
	  actor's position is also interpolated (though in a really hacky manner)
	  so the avatar's movement isn't jerky. All other objects do NOT have their
	  movement interpolated, but just smooth avatar movement is a HUGE 
	  improvement. Added config key "config/gameplay/smooth_scrolling"
	  to control this. This is enabled by default for now. Code diffs should 
	  highlight how things have changed.
	* actors.cc : Added a slight hack to Main_actor::handle_event to stop
	  some 'double stepping' that was looking really bad with smooth 
	  scrolling. See the comment in the code for details
	* gumps/GameplayOptions_gump.* : Added toggle for smooth scrolling.

2007-11-04    <jeff@mini.nerble.net>

	* server/server.cc: Support 'locate' with 'quality' in ES.

	* exult.cc: Show FPS.  Also, made an experimental change to the
	event'loop's rendering condition.

2007-10-31	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixed a few opcode bugs. Also, swapped the purpose of cnt1 and cnt2 in the
	repeat2 script opcode and removed the initial "reset" of the counter. Both
	changes are verified in the originals.

2007-10-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixed crash whan attacking objects bare-handed.

2007-10-29	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* monsters.cc: Setting quality for monster equipment only if it is a weapon
	  that uses charges.
	* actors.cc: Preventing actors from taking a step if it would change their
	  z coordinate by more than 1. NPCs now look for combat more often. Lastly,
	  paralyze flag completely prevents movement.
	* gamewin.cc: Paralyze flag completely prevents avatar from moving.
	* combat.cc: Entering combat mode with a readied spellbook no longer makes
	  it disappear with SI paperdolls.
	* schedule.cc: Scripts in patrol schedule are no longer dont_halt.
	* egg.cc: Increased duration of continuous weather eggs to 100 hours.
	  This has been confirmed in the originals.

2007-10-26	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixing recently introduced distance calculation bug.

2007-10-23	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* effects.*, shapes/miscinf.*, data/*: Added ability to specify explosion
	  SFX based on shape. This seems to better match the originals' behavior.
	* usecode/*: Added a few usecode script opcodes and modified the behavior
	  of another, all based on the originals:
	  - music opcode causes it to loop indefinitely if the high-byte is nonzero.
	  - reset opcode (0xa) which causes a script to go back to the start.
	  - delay_minutes (0x28) which works like its name suggests.
	  - weather opcode (0x5A) which allows scripts to change weather.
	  delay_hours has also been fixed so now it works.
	* actors.*: Removed a few redundant cases from Actor::figure_weapon_pos.
	  Changed maximum value of food stat and added new behavior for set/get_prop
	  based on original games: prop 10 gets/sets sex flag, prop 11 gets if the
	  NPC is using a weapon with uses >= 2.
	* actorio.cc: Sex type flag seems to be reversed in initial SI savegame,
	  absent for BG; this has been verified with get_prop intrinsic, as above.
	* mapedit/*: Added hex display of shapes and shape ranges in shape browser.
	* content/sifixes/*: General reformatting (particularly the comments were
	  word-wrapped at about 80 chars width) and code update. Also, added tons of
	  global flags compiled by Malignant Manor; dozens more still to come.

2007-10-21 Dominik Reichardt <dominus@users.sourceforge.net>
	* docs/xml/docs.xml,faq.xml: updated documentation and FAQ
	* docs/ReadMe.html,FAQ.html: updated documentation and FAQ
	* Readme, FAQ: updated
	
2007-10-14	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Changed the way that distance is calculated. It now includes object size
	  and z-coordinate into consideration, and results are U7 & SI verified.
	* Implemented intelligence/shape type check to prevent animals from opening
	  doors when pathfinding.

2007-10-13	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* effects.*: Projectiles and explosions now require a Game_object attacker
	  instead of an actor. Also, a projectile sprite can now be different from
	  the ammo info to be used when it hits, and the speed of the projectile can
	  be adjusted separately. Renamed 'Special_projectile' to be the (better,
	  but still not ideal) 'Homing_projectile'.
	* actor.cc, objs/*: Allow use of hand weapons in usecode_attack. Allowing
	  all ireg objects to make usecode attacks. Added reduce_health virtual
	  method to Game_objects.
	* All others: more intrinsics uncovered/improved with rip/wud/wuc combo:
	  - Intrinsics 'apply_damage' and 'reduce_health', as well as UCC script 'hit'
	    opcode now cause damage to objects too.
	  - 'fire_cannon' intrinsic renamed to 'fire_projectile'; unknown parameters
	    have been decoded and implemented. Also, this intrinsic is confirmed to
		be present in SI as intrinsic 0x8C.
	  - 'explode' intrinsic renamed to 'attack_object'; unknown parameters have
	    been decoded and implemented.
	  - SI Intrinsics 0xA and 0xB are, respectively, 'change_npc_face0' and
	    'change_npc_face1'. They take a frame as a parameter and change the face
	    in the corresponding slot to this frame. Exult also makes them available
	    for BG.
	  - 'set_to_attack' intrinsic and script 'attack' opcode can also be used
	    with non-actor objects.
	  The intrinsic documentation has been updated accordingly. These changes
	  also affect UCC.
	  Finally, changed translucency in faces to affect only large faces.

2007-10-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug in UCC do-while loops.
	* Modified the way apply_damage intrinsic works. This seems to better match
	  the way it worked in the original games. Docs changed accordingly.
	* Fixed avatar skins on new games with new maps.

2007-10-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fast_pathfinder_client::is_grabable now allows you to pick up objects if
	  you can path-find to up to 3 tiles away from the object; this seem to be a
	  better match to the original games.

2007-10-06	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed a couple bugs in the Keyring mod.
	* Eliminated the (virtually unused) SIFlags variable, enum and associated
	  functions from Exult. Its sole use (the naked flag from the cheat screen)
	  has been moved to flag 38 (which was unused in the originals) so that it
	  can be used from usecode also (to make things easier for skin packs).
	* Exult Studio now edits more NPC flags, including the SI flags.
	* Added an SI version of the BG's 'dont_move' flag. Now, flag 16 is named as
	  'bg_dont_render' (BG) or 'dont_move' (otherwise), while flag 22 is called
	  'bg_dont_move' (BG) or 'dont_render' (otherwise). Renamed 'si_tournament'
	  flag to simply 'tournament'.
	* Ignore "don't move mode" and "don't render" when map-editing.
	* Corrected and updated intrinsic documentation.
	* Making the new naked flag works more like nakedness did in SI.

2007-10-04	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed a few bugs in the Keyring mod.
	* Fixed bugs #1727116 and #1770090

2007-10-02    <jeff@mini.nerble.net>

	* npctime.cc (Npc_hunger_timer): Fixed hunger.

2007-09-21	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Midi.cc: Fixed crash when playing midi music on title screen of mods
	  with a custom mainshp.flx.

2007-09-02	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Audio.*, objs/animate.*: Fixed memory leak. Improved sfx cache.
	  Removed 'repeat' variable from Object_sfx as it was redundant.
	* usecode/ucxt/data/u7opcodes.data: A few output fixes.
	* usecode/compiler/uclex.ll: Fixed bug in line numeration of commented lines.
	* content/*: Compatibiility update for changes in UCC.
	* usecode/*, usecode/compiler/*, mapedit/*: The original games seem to make
	  a distinction between 'object' functions (fun id < 0x800) and 'utility'
	  functions (fun id > 0x800); the former are called in usecode with CALLE
	  opcode exclusivelly, while the latter use only CALL opcode and inherit the
	  itemref from the caller function. All 'object' functions have a 'phantom'
	  parameter in their function headers which is never used and always zero in
	  the originals. This behavior has been implemented in Exult now.
	  UCC has been updated to take this behavior in consideration, and you can
	  now declare object functions by using 'object#' or 'shape#'; the difference
	  being that the latter is bound to a given shape, whereas the former is not.
	  'object#' is used like 'shape#', but can have nothing in the parenthesis;
	  additionally, functions with ids < 0x400 are considered to be 'shape#' and
	  functions with ids < 0x800 are considered to be 'object#'. UCC will display
	  tons of warnings and errors related to this to ensure 'proper' coding.
	  Also, Exult Studio has been updated to accept only 'object#' or 'shape#'
	  functions for eggs, NPCs, etc.
	* cheat_screen.cc: Making setting/clearing in_party flag work correctly in
	  both, the normal and advanced NPC flag editors.

2007-08-14    <jeff@mini.nerble.net>

	* objs/animate.cc (Frame_animator): Re-initialize animator if
	frame got set outside valid range.  Fixed problem with water of
	ethicality in SI.  (Not sure if this is the best fix...)

2007-07-12	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* audio/Midi.cc: Don't use exceptions for patch music flexes.
	* audio/midi_drivers/LowLevelMidiDriver.cpp: Destroy cond also when the
	  driver is destroyed.
	* usecode/compiler/ucfun.cc: Only add terminating return opcode to functions
	  that don't already have one.

2007-07-12  Ryan Nunn <colourles@users.sourceforge.net>
	* audio/midi_drivers/* : Changes to the MidiDriver code as per Exult 
	  bug report 1750743, with additional changes to ensure that it actually
	  works properly in all cases. Also fixed possible problems with sequence
	  speed being set to 0, notes being cut off early at the end of a song and 
	  renamed some variables so they properly relfect what they actually are.
	* msvcstuff/wud.vcproj : Changes so this project compiles

2007-07-11	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamemap.cc, files/databuf.h: Removed OVectorDataSource in favor of
	  StreamDataSource + stringstream. Added 'write' virtual method to
	  DataSource which writes a string to the source.
	* mapedit/*: Removed unused definitions.
	* gamedat.cc, gamewin.h: Fixed flex multimap savegames to save an inner
	  flex (containing the IREG files) for each map after the first.

2007-07-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug which would cause a purple outline to be displayed around NPCs
	  during some animations in recent snapshots of Exult.

2007-07-07	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* PocketPC: Set audio system to just USE_FMOPL_MIDI
			The theory is, this may reduce crashes, as Timidity doesn't
				appear to work, and MT32 could be having problems.

2007-07-02	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* PocketPC: Fixed bug with "Normal" option w/ D-PAD
			Normal option couldn't be selected
			
2007-07-01	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* content/*: Making usecode of the SI Fixes and LB joining mods compile.
	* usecode/compiler/ucsym.cc: UCC now issues a warning for every function
	  that gets autonumbered unless '#autonumber' directive is used.
	* usecode/compiler/uclex.yy: Optimizing lexical scanner a bit.
	* palette.cc, gameclk.cc: Fixing problems with infravision and (possibly)
	  invisibility palettes.
	* effects.cc: Tweaking duration of rain and snow a bit.
	* gamewin.cc, cheat_screen.cc, mapedit/npclst.cc, usecode/ucinternal.cc,
	  content/islefaq/initgame.dat: NPCs with numbers in the [356, 359] range
	  are hidden by Exult and ES, not being available for new NPCs. Also, these
	  'reserved' NPC numbers will not be converted to NPCs by intrinsics.
	  Other than that, negative usecode numbers will be converted to NPCs
	  whenever possible, like positive numbers; this effectivelly removes the
	  NPC # limit from Exult.
	  Finally, the SF Island patch has been remade to avoid using NPCs in the
	  range mentioned above.
	* usecode/compiler/ucsym.cc: Fixed Uc_function_symbol constructor not
	  initializing all class variables.

2007-06-30	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* (general): Adding missing newlines to end of files. Making numeric keypad
	  work for number input and return in gumps/menus.
	* usecode/ucsym.cc: Making shape# work again if using old auto-numbering.
	* mapedit/*: Allow separate viewing of shape functions in usecode browser.
	* content/bgkeyring/src/spells/npc_spells.uc: Reagents were being incorrectly
	  counted and used.
	* content/*: Updated old usecode to a more modern form. Fixed dialog bugs in
	  SF island and fixed initial scene.

2007-06-29	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* ChangeLog: Corrected date for yesterday's entry
	* PocketPC;touchscreen: Added toggleRight and toggleDouble functions to
			touchscreen class
	* PocketPC;Keyboard_gump: Cleaned up ActivateOtherButton function
				Added per-state ActivateOtherButton functions
	* PocketPC;Keyboard_gump: Enabled saving & loading of on-screen keyboard
			position and state
	* PocketPC;Keyboard_gump: Added getState and getCorner accessor functions
	* PocketPC: Added "KEYBOARD_POSITION" action	
	* PocketPC: Added "KEYBOARD_MODE" action
	* Added README.PocketPC
	* PocketPC: Added "Normal" option to d-pad options (in case someone has
			custom keybindings)

2007-06-28	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* PocketPC: Added touchscreen class
			Allows users to set mouse to double click mode
			Allows users to set mouse to right click mode
			Users can do both double click and right click modes
			Added TOUCHSCREEN_MODE action, so it can be mapped to a key
	* PocketPC: Added double click and right click functions (as noted above)
		to the keypad and hotpad keyboards
			
2007-06-27	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* PocketPC: Fixed scaling problem
	* PocketPC;Keyboard_gump: Cleaned up Keyboard_gump.h a bit
			Set private & public appropriately

2007-06-26	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* PocketPC: Added keypad and hotpad keyboards
		Keypad is basically the numpad on a normal keypad
		Hotpad enables running and a few other nifty functions

2007-06-24	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamewin.cc, gameclk.*: Fixed a few bugs in palette problems, particularly
	  when teleporting around.
	* content/bgkeyring/*/*: Fixed a few bugs in Zauriel's functions, improved
	  one of the cutscenes.
	* A few aligning spaces were converted to tabs.

2007-06-24	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* PocketPC: Updated on-screen keyboard colors
	* PocketPC: Fixed alt & ctrl on-screen keyboard malfunction
	* PocketPC: Fixed minimize bug (had to tell SDL to minimize twice to be sure
				would erase the whole window, in certain PocketPC setups).
	* MSVC9: Updated Makefile.data so it wouldn't rebuild the flx files every time
				
2007-06-24	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* PocketPC: Added on-screen keyboard feature

2007-06-24	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* palette.cc, gameclk.cc: Fixed a few problems with palette transitions and
	  faded-out palettes.
	* gumps/Paperdoll_gump.cc: Also allow showing of usecode container in BG
	  if Exult is compiled with -DSHOW_USECODE_CONTAINER

2007-06-23	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bugs where avatar faces would not be removed from the screen by
	  calls to remove_npc_face intrinsic.

2007-06-21	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
    * PocketPC: Added "exult.cfg.txt" as a config file option
		Exult will look for exult.cfg.txt first (using U7exists)
		If it is not found, then Exult will use exult.cfg
		This is so PocketPC users can easily edit the config file by default
		Most PocketPC devices natively do NOT have the ability to rename extensions
			or to easily edit anything that is not already a registered type
		This feature can be made easily available to other OSes by defining
			EASY_USER_CONFIGURATION_FILE (with the value of 'exult.cfg.txt')
	* PocketPC: Possibly fixed semi-random 'minimize' bug (when minimizing, some
			of the main PocketPC GUI would be covered by graphics from Exult).
			Needs more testing.
						
2007-06-20	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
    * Fixed PocketPC 'minimize' function querks
    * Fixed PocketPC dpad keymap loading bug

2007-06-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* New intrinsic from SI discovered with rip/wud/wuc: intrinsic 0x96 is
	  'can_avatar_reach_pos'. Since Exult already offers a more powerful variant
	  ('is_dest_reachable', which works for any NPC not just the avatar), this
	  intrinsic has *not* been made available to BG.

2007-06-19	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	* Started PocketPC 'minimize' function
		Needs good placement
		Minimize feature can be ran by attempting to quit the game, choosing no, then choosing yes to minimize
		There are a few querks when reactivating Exult that need to be fixed
	* Fixed type-o in ChangeLog (from Lanaca to Lanica on 2007-06-16)
	* Removed PocketPC hardcoded configuration file location (was set to load from "\Exult\exult.cfg")
	* Fixed PocketPC relative pathing error (PocketPC does not have a "current directory")
	* Created easy way for dpad keymaps to be changed (Gameplay options, "D-PAD") for PocketPC users

2007-06-18	Lanica Dragon (Phillip T. George <me@PhillipGeorge.com>)
	(Checked into CVS on 2007-06-19)
	* Fixed Makefile.common bug where EXPACK_CHECK would not get properly updated with Windows platforms
	* Updated MSVC9 project files to include "release" mode and also the PocketPC 2003 target

2007-06-17	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed special lights to work again.
	* Fixed UCC bug where a function's symbol type in the symbol table be
	  "extern" if the function was externed before being defined.
	* Added three new intrinsics from SI discovered with rip/wud/wuc:
		intrinsic 0x64 is resurrect_npc
		intrinsic 0xB9 is get_temperature_zone
		intrinsic 0xBB is get_npc_warmth
	  This affects UCC, WUD and WUC as well.
	* actors.cc: Fixed warmth given by several items.
	* gumps/Stats_gump.cc: Fixed slightly innacurate frame <> temperature map.


2007-06-16    <jeff@mini.nerble.net>

	* exult.cc,etc.: Applied Lanica's PocketPC patches.

2007-06-16	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Makefile.common: Ensure that changes to "bgintrinsics.h" and "siintrinsics.h"
	will affect builds of Exult, UCC, WUD and WUC.

2007-06-15	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* effects.*, gameclk.*, palette.*, objs/egg.cc: Implemented missing weather:
	  snow, fog and overcast weather. Also changed rain to better match the
	  originals. Implemented smooth dawn/sunrise/sundown/dusk and smoother
	  transition to/from overcast/rain/snow/fog weather. Also, fixed bug
	  which prevented correct palette from being displayed after entering and
	  then leaving the cheat screen.
	* cheat_screen.cc, gamewin.cc: Reset weather to default before setting time.
	* objs/animate.cc, shapes/miscinf.*, data/*/shape_info.txt: Implemented
	  grandfather clock's horly "bongs". Implemented reading of animation data
	  from the original games, which is converted to the Exult format.
	  As a result, most of the animation data in data/*/shape_info.txt has been
	  rendered reduntant and is commented out, being left as examples of the
	  Exult format.
	  Changed the way extra delay between frames of an animation work to better
	  update object SFX, and likewise for pure SFX animators with random delays.
	* gumps/misc_buttons.cc: Fixed dumb error.
	* effects.cc, actors.cc, shapes/shapewrite.cc, shapes/shapeinf.*,
	  mapedit/shapeedit.cc: Changed missiles' "special behaviour" to "homing".
	* actors.cc, usecode/ucinternal.cc: Fixed bug which caused Dupre not to
	  appear in the conversation with Lord Marsten. Unfortunatelly, this means
	  that the animation bug fixed 2007-06-07 is now back.
	* monsters.cc: Monsters can also be pure SFX animators now (fixes bees).
	* actorio.cc: The original games did not store NPC's face shapes in npc.dat
	* usecode/ucinternal.cc: Unless passed an NPC object, show face equal to the
	  absolute value of the number passed from within usecode.
	* mapedit/exult_studio.glade: Fixed display of weather egg data.

2007-06-08	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Disabled fire sfx as it sounds awful.
	* Modified distance function to calculate distance between the center
	  tiles of the two objects.

2007-06-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug where nearby animations could temporarily stop if an "abort"
	  took place during a conversation.
	* More intrinsics uncovered with rip/wud/wuc:
	  BG: intrinsic 0x92 is *set_camera*, not center_view.
	      intrinsic 0x94 centers the screen around a (x, y) coordinate;
	          it has been renamed view_tile.
	  SI: intrinsic 0x19 is *get_item_weight*, not get_item_usability.
	      intrinsic 0x67 is definitelly remove_all_spells.
	      intrinsic 0x6b is stop_time.
	      intrinsic 0x70 is armageddon (yes, it is there).
	      intrinsic 0x72 is lightning.
	      intrinsic 0xb0 is view_tile.
	  Old center_view intrinsic is still available for both BG and SI.
	  Also, set_camera intrinsic also centers on objects, not just actors
	  SI intrinsics remove_all_spells, get_item_weight and get_skin_colour
	  were made available for BG too.
	* Updated/fixed a couple errors in intrinsic documentation.

2007-06-06    <jeff@mini.nerble.net>

	* schedule.cc (Loiter_schedule): Rewrote miner-schedule to be more
	like the original.

2007-06-07	Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixed bug when importing shp files into a VGA file over an existing shape.

2007-06-05	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed coastline desynch bug.
	* Fixed bug #1731542 by forcing the current frame to be passed for the
	  get_3d_xtiles get_3d_ytiles (thus, ensuring proper bounding boxes).
	* Fixed bug #1731543.
	* Fixed bug in ES method of saving differential VGA patches and improved
	  recognition of files from patch dir.

2007-06-03	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs/virtstone.h: Changed 'default' value for virtue stone map to be map 0.
	* objs/egg.cc: Fixed bug where sfx eggs would translate the SFX number to
	  the BG SFX, causing problems in SI.
	  De-hard-coded field data. Poison and sleep fields no longer activate if
	  the target is already poisoned/sleeping.
	* objs/objs.cc: Added some missing sfx when the avatar attacks an object.
	* shapes/miscinf.*, objs/*: Major work in object sfx; multiple objects can
	  now play the same sfx (as seen in the originals). Objects can now have
	  ranges (random or sequential) of sound effects, as well as sport a random
	  delay between each time the sfx is played.
	  New animation data and cycles unifies the way fields are handled with
	  every other animated object, including allowing them to have sfx. Also,
	  objects can have sfx synchronized with specific frames of the animation
	  (e.g., grandfather clocks) and can sport delays between each animation
	  cycle (e.g., bubbles).
	* shapes/miscinf.*: Modified to read new animation and SFX data.
	* gumps/misc_buttons.cc: Added missing button SFX.
	* data/*/shape_info.txt: Added tons of new sfx and animation data.
	* usecode/compiler/*:
	* actors.cc: Modified roll_to_win to better match statistical tests.
	  Added 'graze' and default 'hit' SFX. Modified NPCs to *really* be dormant
	  when in a different map from main actor.
	* effects.cc: SFX from weapon data should not be translated in SI.
	* exult.cc: Wizard_eye only blacks out area outside the original resolution;
	  this makes it work with SI even without the BG sprite 10 (as it in fact
	  happens in the original SI -- see the usecode changes below).
	* gamewin.cc: Fixed a bug(?) where clicking at the rock at [915, 2434, 0]
	  in BG would display 'key'. Might have unforeseen side effects.
	* audio/conv.cc: Fixed the BG-to-SI SFX table. The new data is based on the
	  MT-32 timbres from BG and SI SFX and on the assumption (apparently
	  correct) that BG SFX uses timbres equal to their SFX number, then matching
	  (by name) the timbres used by SI SFX.
	* usecode/*: New intrinsics discovered from original games with rip/wud/wuc:
	  BG: 0x2d: get_music_track
	      0x34: error_message
	  SI: 0x38: get_music_track
	      0x58: roll_to_win
	      0x5f: clone
	      0x61: display_area
	      0x62: wizard_eye
	      0xaf: get_dead_party
	  Note that several of these intrinsics were used in the originals.
	  Like wizard_eye intrinsic, display_area intrinsic also blacks out only
	  the area outside original resolution to work as the original SI did.
	  get_dead_party now searches around the object passed as the parameter
	  (which was ignored by Exult so far) instead of the avatar.
	  Added support for usecode functions with 32-bit IDs.
	* usecode/compiler/*: Added do-while support for UCC. Renamed return opcodes
	  to make them more intuitive. Added support for 32-bit function IDs, string
	  offsets and integers. 32-bit jump offsets are NOT implemented yet.
	  UCC directives are now more tolerant of white-space and (1) issue a
	  warning if the directive is unknown or (2) raise an error if there is no
	  new-line after a directive.
	* docs/exult_intrinsics.txt: Updated with new intrinsic information.
	* content/sifixes/*: Better 'make.bat'. Updated some files to make SI Fixes
	  actually compile with non-ancient versions of UCC.

2007-05-15    <jeff@mini.nerble.net>

	* objs/egg.cc (public): Allow setting z-coord in teleport eggs.

2007-05-14	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* miscinf.cc: Fixed problem reading textmsg files with crlf's.
	* monsters.cc: Monsters with high shapes used wrong usecode function.

2007-04-28	Marzo Sette Torres Junior <marzojr@yahoo.com>
	* New sprite for male bucket-heade avatar, made by Skutarth. Also, removed
	  the silly fully-armored paperdoll for the bucket-headed avatars.

2007-04-15    <jeff@mini.nerble.net>

	* imagewin/imagewin.cc (Image_window): Added Hq3x scaler.

2007-04-13    <jeff@mini.nerble.net>

	* imagewin/hq2x.cc (srcx): Added Hq2x scaler.

2007-04-08  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed screwed-up palettes in SI mods with custom mainshp.flx files.
	* You can now add/change midi music by placing custom ADLIBMUS.DAT and/or
	  MT32MUS.DAT files in the patch dir.

2007-04-06  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Improved large-avatar handling, fixing a few bugs it introduced for
	  normal-sized avatars.
	* Improved Actor::Find_Blocking, and modified Actor::move_aside to check
	  the orthogonal directions first.
	* Improved slightly pace schedule.
	* Jukebox eggs now ignore delta-z when determining if they should hatch.

2007-04-04  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Improved skin scrolling functions.
	* ES now saves differential patches for VGA files. This will NOT affect
	  "patch" VGA files that already exist.
	* ES now exports to/imports from shp files into VGA files.

2007-04-02  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Avatar skins can now optionally specify whether or not the shape data
	  from the avatar's default skins will overwrite the shape data from the
	  skin's actual shape.
	* Versioning of text data files actually work now.
	* Better handling for movement of larger avatars.

2007-03-31  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Added new title screens for Keyring mod and SI Fixes.
	* Added build scripts/instructions for SI Fixes. Also, improved the Keyring
	  make scripts.
	* Added new avatars from Avatar Pack to Keyring mod.
	* You can now patch the keybindings on a per-mod basis. The Keyring mod has
	  been updated to reflect that.
	* Added partial support for patch music files. Ogg files in <PATCH>/music
	  will now be loaded (if they exist) instead of the corresponding ogg from
	  <MUSIC>. Still need to do the same for the midi/xmidi/etc.

2007-03-29  Marzo Sette Torres Junior <marzojr@yahoo.com>
	Allow mainshp.flx patches. Also, slightly synched BG and SI new game code,
	and removed a few unnecessary palette changes in BG title screen.

2007-03-27  Marzo Sette Torres Junior <marzojr@yahoo.com>
	New vga/usecode generation scripts for Keyring mod.

2007-03-21    <jeff@mini.nerble.net>

	* exult.cc: Fixed a couple bugs involving dragging NPC's onto the map.

2007-03-18  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* minsinf.cc: Made multiracial table patches actually be able to change
	  the built-in skins.
	* content/bgkeyring: changed storage method of graphics to shp files instead
	  of pngs and switched scripts to use expack instead of ipack. Added some
	  instructions on how to build the Keyring mod by yourself. Added several
	  new avatars to choose from, and improved existing ones. Removed generated
	  files (most vga files, the usecode file).

2007-01-15  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Don't print errors when looking for mods and the mods dir doesn't exist.

2007-01-10  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* A few bug fixes/improvements to the Keyring mod.

2007-01-06  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixing bug #1628256.

2007-01-02    <jeff@mini.nerble.net>

	* mapedit/ucbrowse.cc (Usecode_browser): Sort columns in usecode
	browser.

2006-12-25  Marzo Sette Torres Junior <marzojr@yahoo.com>
	A few fixes/updates to the Keyring mod.

2006-12-24  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* miscinf.cc: Removing unneeded debug message.
	* ucbrowse: Lack of std::ios::binary in opening file caused wrong usecode
	  symbol table. Changed to use U7open instead of constructor.

2006-12-23    <jeff@mini.nerble.net>

	* mapedit/shapeedit.cc: Added "Browse" buttons for usecode selection.

2006-12-20  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Increased version to 1.4.03CVS due to the enormous number of changes.
	* Added versioning information to the files loaded through Shapeinfo_lookup.
	* Added two new intrinsics: set_npc_name and set_usecode_fun, as well as
	  documentation for them.
	* shapes/miscinf.*: Added some new data files, with dynamic importing of
	  shapes allowed. See the data files themselves for more information.
	    ++++ Important ++++
	  These data files allow the specification of previously hard-coded data.
	  This hard-coded data will NO LONGER BE PRESENT for new games, which must
	  supply their own versions of the data files instead.
	* gamamgr/bggame.cc, sigame.cc: Updated to use new data files for skins.
	  In BG, also made the character creation screen use a new palette by using
	  palette remapping of the shapes to draw. Consequently, said screen uses
	  shapes from faces.vga (patched with Exult_bg.flx/mr_faces.vga) to draw
	  the multiracial faces.
	* expack.cc: You can now specify a shape number for a file in a script by
	  prefixing the file name with a ':shapenum:'. Shapes following a declared
	  shape will have their numbers assigned starting from the specified shape.
	* shapes/vgafile.*: VGA files now support multiple (more than 2) patches
	  from different sources. Also added support for loading VGA files from
	  within a flx file (such as Exult_bg.flx). Also, VGA files can now import
	  specific shapes from another VGA file and remap the shape number to a
	  different value. Finally, Shape frames can also be painted by remapping
	  their colors using a palette translation table.
	* shapeid.*: Renamed a few vars and functions to have more generic names.
	  Modified the handling of VGA file loading, allowing for independent use
	  of paperdolls and of multiracial avatars, as well as allowing multiple
	  patches for paperdol.vga in BG. BG shapes.vga now imports the multiracial
	  shapes from SI. Likewise, multiracial faces are patched into faces.vga.
	  Added support for drawing shapes by remapping them into another palette
	  using a translation table. Finally, BG gumps.vga imports the blue shapes
	  from the SI gumps.vga file.
	* shapes/shapevga.*: Modified info table to use a map instead.
	* gumps/Paperdoll_gump.cc: Use data-file-defined data for the blue shapes.
	* usecode/ucinternal.cc, conversation.cc: Use new data files and functions
	  to 'de-hack' multiracial support in BG. Also, the Petra and tattooed flags
	  also work in BG now, with effects configurable in data files.
	  Also, added function to retrieve a usecode function's name from its id.
	* usecode/ucserial.cc: Fixed bug #1616911.
	* cheat.cc, cheat_screen.cc: Use new functions for changing skin colors.
	  Allow use of naked, petra and tattooed flags in BG too.
	* palette.*: Added function to create a translation table between two palettes.
	  Improved find_color function to allow searching up to a specified index.
	* imagewin/ibuff8.*, shapes/font.*: Added support for painting shapes by
	  remapping their colors to another palette using a translation table.
	* actors.cc: Use new skin data and functions.
	* actorio.cc: Save/load skin color using its own char (but retain backward
	  compatibility).
	* all others: Changed for compatibility with the above changes.

2006-12-12  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed a bug in the get_class method of the symbol table.
	* Added a 'OVectorDataSource' vector data source for output of unknown
	  length to prevent problems with small buffers.
	* Made Usecode_value and Usecode_script classes use data sources for input
	  and output to eliminate possible buffer problems.
	* Removed the limit on usecode timers allowed.
	* Made usecode static vars refer to its parent function (if any) by name
	  when possible.

2006-12-11  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Added support for turning translucency on/off for paperdolls. New data for
	  BG and SI paperdolls has been added.
	* Fixed a couple goofs with new paperdoll art, and added some more art by
	  Crysta the Elf.
	* Loading a mod directly from the command line will no longer default to
	  the original game if the specified mod is not found or is not compatible
	  with the present Exult version.
	* Gave a much-needed version increase to Exult, particularly since the
	  paperdoll data it now expects is not backwards-compatible.

2006-12-11  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Added support for static usecode classes;
	* Compatibility update for Keyring mod with new BG paperdoll data.

2006-12-10  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Scripted steps now force the step to take place regardless of obstacles or
	  terrain (FoV & SS verified);
	* Changed handling of barges to allow movement type of barges above ground
	  level to 'MOVE_LEVITATE' (FoV & SS verified).
	* Adding more BG paperdoll art by Crysta the Elf.

2006-12-09  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Adding tons of new paperdoll graphics for BG by Crysta. Also removed
	  unneeded file.
	* Improved UCXT data files and intrinsic table.
	* Improved WUD/WUC opcode table and fixed a few errors.

2006-12-08  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixing a few stack corruption bugs in UCC.
	* Changing wud/wuc name of opcode 0x5C.

2006-12-07  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Changing the way Exult handles the game clock. Now, the game clock 'ticks'
	  25 times per game minute, regardless of FPS, which seems to be the way it
	  worked in the original.
	* Sime improvements to the 'pace' schedule.
	* NPC schedules now update every hour, and look back until it finds a
	  schedule for the NPC.
	* Added a 'continue' statement in UCC for 'while' and 'for' statements.
	* Fixed a few bugs and updated a few things in the Keyring mod. Added new
	  Mariah gump by Crysta.

2006-12-06  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.*, intrinsics.cc, ucsched.cc, ucparse.yy, exult_intrinsics.txt:
	  Implemented damage type parameter of 'apply_damage' and 'reduce_health'
	  intrinsics and of the 'hit' script opcode. Also implemented the red flash
	  for lighting damage for even a single hit, as it happened in the original,
	  as well as flashign red for high amounts of damage.
	  Also implemented 'repeat2' support in UCC.
	* everything else: Fixing bugs in the mods and updating them to use the
	  changes above.

2006-12-05  Marzo Sette Torres Junior <marzojr@yahoo.com>
	Adding new 'is_dest_reachable' intrinsic and documentation for it.

2006-12-04  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Updating documentation of [get|set|clear]_item_flag intrinsics.
	* Fixed bug #1608149.

2006-12-02  Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixing Keyring bugs in forging code/Menion's training.

2006-11-30  Marzo Sette Torres Junior <marzojr@yahoo.com>
	When editing shape info, have origin be updated when the frame is changed.

2006-11-29  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Updating Keyring mod to incorporate some additions to UCC, as well as a new
	  sprite and gump for Mariah and several bugfixes.

2006-11-28  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapeid.*, actors.cc: 'paralyze' flag now displays a purple outline. For
	  the sake of visibility, the SI color was used instead of the BG one.
	* exult.*, usecode/conversation.cc, usecode/ucinternal.cc: Rotate palette
	  colors during conversations and during book mode (U7 verified -- e.g., the
	  SI phoenix).
	* usecode/bgintrinsics.h: Imported five intrinsics from SI to BG:
	  show_npc_face0, show_npc_face1, remove_npc_face0, remove_npc_face1 and
	  set_conversation_slot.
	* usecode/siintrinsics.h: Imported three intrinsics from BG to SI:
	  center_view, lightning and stop_time.
	* docs/exult_intrinsics.txt: Included above modifications.

2006-11-26  Marzo Sette Torres Junior <marzojr@yahoo.com>
	Fixed Karnax freeze-up bug.

2006-11-24  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* UCC: Adding assignment operators ('+=', '-=', '*=', '/=', '%='); improved
	  the functionality of '<<'; allowing getting/setting global flags with
	  non-constant expressions; allowing non-constant values in 'actor frame'
	  script command; fixed crash on code like 'var test = fun();' with 'fun'
	  undeclared; some misc improvements.
	* Exult: Added two new opcodes that allow getting/setting flags using a
	  value on the stack.

2006-11-23  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* ufcun.h: Fixing UCC bug that caused first obj.say or obj.hide calls to do
	  fail do perform their intrinsic calls if they were the first intrinsic-
	  related calls in a usecode file.
	* All others: Adding C++-style switch statement to UCC.
	* Minor optimization for integer constants in UCC.

2006-11-21  Marzo Sette Torres Junior <marzojr@yahoo.com>
	Adding extra capabilities to UI_book_mode_ex intrinsic, as well as improved
	documentation for it.

2006-11-21  Marzo Sette Torres Junior <marzojr@yahoo.com>
	Adding two new intrinsics: UI_book_mode_ex and UI_display_map_ex, as
	well as documentation for both.

2006-11-17  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* docs/exult_intrinsics.txt: Reformatting file, some other minor fixes.

2006-11-05  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* ucinternal.cc: Fixed possible stack corruption on usecode machine when
	  getting/setting global flags. Also, for testing, make opcode 0x2d (setr)
	  display pending text.
	* exult.cc: Made --buildmap option work once again, now with support for
	  all games and mods.
	* usecode/compiler/ucfun.cc: Usecode functions which specify a return value
	  use the UC_RTS return instead of UC_RET at the end of the function.
	* usecode/compiler/*.*: Added support for comparison of multiple strings in
	  a converse case block. Syntax is:
			case "test1", "test2":
	  and adding the '(remove)' option causes all the options to be removed.
	  The UCC script command 'call' now accepts variables for the eventid to use.
	  Also added new scripting options with the intent to completelly phase out
	  the execute_usecode_array and delayed_execute_usecode_array intrinsics.
	  Scripts can now be created like this:
		var varname1 = new script { // script commands };
	  and can be added to like this:
		varname1 << varname2;
		varname1 << { // script commands };
	  The '<<' operator will append the right-hand side to the var on the left-
	  hand side, and can be chained; e.g.,
		varname1 << varname2 << { // script commands };
	  results in the same script as the above two lines. Finally, the calls to
	  execute_usecode_array and delayed_execute_usecode_array intrinsics can be
	  done respectivelly with
		'actor.run_script(script);'
	  and
		'actor.run_script(script, delay);'
	  The previous UCC script blocks still work as they used to.

2006-09-25  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* schedule.cc: Fixed pace schedule for large creatures (such as the cyclops
	  northeast of Cove).
	* actors.cc: Map-edit mode now delays handle_events for actors, preventing
	  almost all actions. Also, fixed the bg_dont_move condition in
	  in_usecode_control function.
	* egg.*: Fixed field/caltrop bugs on editing/updating from ES, as well as
	  bug #1564529.

2006-09-24  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Implemented monster attack SFX; verified in the originals.

2006-09-22  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* ucsched.cc, actors.*, gamewin.cc: Looking at 'no_halt' script opcode in
	  a slightly different way. In particular, this prevents silver serpent
	  venom from freezing the user for 1 game hour.
	* ucsym.h: Fixed a GCC 4 compile problem.
	* keys.cc: Changed a few identing spaces to tabs.

2006-09-22  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Reduced avatar's speed to prevent outrunning of the teleport storm at the
	  start of SI. The reulting speed also seems to match the original games
	  better, as it is now very hard to outrun enemies. The avatar's speed is
	  also reduced if it is in a (delayed) usecode script, which helps to
	  prevent outrunning the teleport storm without making the avatar too slow
	  while in combat mode. Also, switched a few identing spaces to tabs.
	* Preventing player from moving avatar during the execution of scripts; this
	  is verified in BG and SI (for example, loom or bellows); delayed scripts do
	  not seem to hinder movement until they are activated.
	* Prevent ES from displaying the 'font0000.vga' file in SI's static dir as it
	  is apparently from an old origin screensaver and is not a true vga file.
	* Fixed bug causing avatar's 'rest_time' to build up too fast. Incidentally,
	  this helps to fix a jerkiness in scripts introduced in previous commits.
	  Also, script opcode 'delay' and any scripted frame changes or steps now will
	  clear the rest time for actors.
	* Fixed problem in Windows builds with USE_EXULTSTUDIO option which caused
	  excessive processor usage, as well as being indirectly responsible for the
	  rapid build-up of the avatar's 'rest_time'.
	* The files 'paperdoll_info.txt', 'bodies.txt' and 'shape_info.txt' (and
	  similar files in the future -- and with the exception of the files bundled
	  the Exult_XX.flx files) no longer require declaration of all sections to be
	  properly parsed.

2006-09-21  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Decoupled usecode functions for shapes > 1023 from the shape #. Removed
	  ucfunids.h since it is no longer needed. In UCC, you now must specify
	  the function to be used for a given shape by declaring the function
	  with the 'shape#(n)' construct in its header; for shapes < 1024, you can
	  still get away by declaring it with a normal function # instead. If *no*
	  functions are declared with 'shape#(n)' or if the usecode was compiled with
	  an earlier version of UCC, the old behaviour will be in effect in Exult.
	* New NPCs can now specify a function name as their usecode function. New
	  save games will not work in older versions of Exult, but old saves will
	  still work.
	* Fixed a couple differences in conversation behaviour between Exult and
	  the original games.
2006-09-20  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Working on UCC classes. Added inheritance support, class instantiation in
	  UCC, type checking for class casts, changed method of class creation and
	  deletion and added support for method calls with and without scope
	  resolution operator (to allow calling of overriden inherited functions).
	  Classes can be passed as parameters to functions and be returned by
	  functions, with full type checking; a '0' can be returned as a class
	  return. Methods can also return values now (including classes) but class
	  data members cannot be classes themselves yet.
	  Added static and global static classes and fixed bug preventing the
	  following code from working correctly unless item == npc:
			npc->set_item_frame(1+get_item_frame());
	  Got static arrays working correctly in loops and in setting/retrieving
	  their elements.
	  Possible future enhancements: add a way to set/retrieve class variables
	  from outside a class; maybe allow class data members to be classes.
	* Modified handling of '#' directives in UCC so they don't disrupt the line
	  numbering.
	* In Keyring mod: Fixed a few missing vars in function headers and a few
	  missing parameters in function calls. Also, updated Paperdoll_info.txt and
	  bodies.txt to include only the new paperdoll/body information.
	* In SI Fixes mod: Removed wrong parameter from function definition.

2006-09-17  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapes/bodies.*, gumps/Paperdoll_gump_info.cc: Removed files, code
	  moved to miscinf.*.
	* gumps/Paperdoll_gump.cc: For ammo, use 'frame2' instead of 'frame'
	  when a compatible weapon is in hand. Also, see below.
	* actors.cc: 'step' should do nothing for non-party members when in
	  map-edit mode. Also, see below.
	* gumps/Face_button.cc, gumps/Face_stats.cc, gumps/Paperdoll_gump.*,
	  objs/animate.cc, actors.cc, effects.cc, gamewin.cc, gamemap.cc,
	  shapes/miscinf.*, usecode/ucinternal.cc, msvc_kludges.h, shapes/Makefile.am,
	  gumps/Makefile.am, Makefile.common: Clean up and centralization of code from
	  miscinf.* and old shapes/bodies.* and gumps/Paperdoll_gump_info.cc. Also,
	  the paperdol_info.txt, bodies.txt and shape_info.txt data files no longer
	  completelly override those from Exult_XX.flx (for BG and SI) or from static
	  dir (for new games).

2006-09-07  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/ucinternal.cc: Increased the maximum number of intrinsics to 1024.
	* usecode/ucinternal.h: A identing spaces to tabs, some align tabs to spaces.

2006-09-07  Marzo Sette Torres Junior <marzojr@yahoo.com>
	content/sifixes/*/*.uc: CRLF->LF.

2006-09-06  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* In General: Changed a spaces in identation to tabs.
	* gamewin.cc: When starting a game using '--edit', have time be stopped
	  right from the start.
	* exult_constants.h: Defined c_max_shapes and c_occsize for better support
	  of shapes >1023; defined c_last_gflag for better support of global usecode
	  flags >1023.
	* cheat_screen.cc, usecode/ucmachine.h: Use c_last_gflag instead of '2047'
	  for last global usecode flag.
	* All others: Added support for shapes>1023 to 'occludes.dat'. Shapes are
	  now limited by c_max_shapes instead of 2048, making it easier to increase
	  the limit if it is needed.
	* content/bgkeyring/src/misc/food_stuff/functions.uc: Fixed bug while eating
	  garlic introduced after Q&I was merged in.

2006-09-04  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* game.cc: Starting a game with a mod resulted in wrong mod identification
	  in stdout.
	* mapedit/studio.cc, server/server.cc, server/servewin32.cc: In Windows, use
	  gamedat dir instead of static dir to allow simultaneous editing of two mods
	  that share the same static path (non-Windows already do that).

2006-09-01  Ryan Nunn <colourles@users.sourceforge.net>
	* audio/midi_drivers/LowLevelMidiDriver.cpp : Improving termination code 
	  for threaded midi drivers
	* server/servemsg.cc, server/server.cc, server/servewin32.cc : Rewrote 
	  Exult<->ExultStudio communications to use a socket in Windows. Should be
	  much more stable
	* Other cc files fixing up some 'const' (or lack there of) problems

2006-08-31  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapelst.cc, shapelst.h: The Gimp would fail to load a frame if the
	  game's path in exult.cfg was a relative path. Also, added the ability
	  to export and import all frames of a given shape to/from pngs.

2006-08-29  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* chunks.cc, objs.o: Fixed map corruption bug when dragging chunks from ES.
	  Also, prevent map changes when removing terrain objects if nodel is true,
	  and correctly check for map cache out when moving terrain objects.

2006-08-27  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Makefile.common: Fixed UCC compile problem in MinGW.
	* content/bgkeyring/*/*: Merged in the 'Iteractions' part of Alun Bestor's
	  Quests & Iteractions mod into the Keyring mod. Added generic healing
	  services (used by all healers), Lord British's Crown Jewels and updated
	  the code to use newer features of UCC. Also added casting frames for all
	  caster NPCs and changed some crlfs to lfs.
	* objs/objs.*: Fixed map corruption bug when moving chunk non-flat objects.

2006-08-24    <jeff@mini.nerble.net>

	* schedule.cc,readnpcs.cc,actors.cc:  Working on support for
	usecode-scripted schedules.  Also did some cleanup on schedule
	reading/writing.
	(Eat_at_inn_schedule): No more annoying delay before inn customers
	take their seats.

2006-08-22  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actions.cc: Testing adding a limit to the number of steps between each
	  check in Approach_actor_action (makes for smarter archers and monsters).
	* effects.cc: Removed some duplicate increments in height for projectiles
	  and slightly tweaked the start and end positions for them.

2006-08-21  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Makefile.common: Force recreation of ucparse.{cc,h} or uclex.cc if,
	  respectively, ucparse.yy or uclex.yy are changed. Need to know if
	  it causes compilation problems in MorphOS or BeOS. Also removed some
	  trailing spaces.

2006-08-20  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed compilation problems caused by modmgr by moving files bggame.*,
	  sigame.*, devgame.* and modmgr.* into new 'gamemgr' directory.

2006-08-14  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* modmgr.cc: Added two path macros to mod cfg files: '__MODS__' and
	  '__MOD_PATH__'. They are expanded, respectivelly, to the game's '<MODS>'
	  dir and to the mod's '<MODS>/<mod_title>' (where '<mod_title>' is the
	  mod's cfg option, defaulting to the filename -- sans extension -- of
	  said cfg).
	* schedule.cc: Slightly tweaked the 'talk' schedule. NPCs will no longer
	  try to talk through mountains.
	* ucsym.*, ucparse.yy, ucfun.h: Fixed bug #1540599. Now, declaring functions
	  through externs and directly will always assign the same function number
	  in both cases (and regardless of order) as long as both have the same
	  number of parameters (and whether or not autonumbering -- either style --
	  is being used). Duplicate declarations (but not duplicate externs, unless
	  the parameter count differs) will raise errors now.

2006-08-14  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Setting bg_dont_move and dont_move flags prevent actors from doing any
	  schedule actions while the flag is set.

2006-08-13  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* objs.cc: Fixed cache-out bug of terrain objects when the whole map is cached
	  out (mostly when teleporting to another map).
	* exult.cc, exultmenu.cc: Fixed a palette problem when loading a game with
	  command-line parameters with 'skip_splash' disabled. Also, fixed the initial
	  Exult logo in the menu.
	* modmgr.cc: Remove trailing slashes before adding "<MODS>" system path for
	  each game.

2006-08-08  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* exult.cc, exultmenu.cc: Added a Zaurus version of the menu -- single
	  column, only 3 games/mods per page and no Exult logo in the back (as it
	  interferes with menu) -- due to resolution constraints. Also fixed dumb
	  mistake when loading a game with --bg or --si.

2006-08-07  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Adding mod manager to Exult and Exult Studio. New Exult menu now displays
	  all games in exult.cfg and has a sub-menu for each game's mods. Likewise,
	  Exult Studio can load games and mods. In some of the files, converted some
	  identation spaces into tabs, and some trailing spaces were removed.
	Detailed information:
	* modmgr.*: New classes that (1) manage the game list, (2) manage each
	  game's mods and (3) store information for each game/mod and correctly
	  sets path information when needed. Games have their own entries in
	  exult.cfg (with the additional "title" tag containing the string to
	  display in the Exult menu), while mods have their own drop-in cfg files
	  located in "<MODS>/*.cfg". The "<MODS>" directory is configurable for
	  each game in exult.cfg (with the new "<mods>" tag), but defaults to
	  "<path>/mods".
	* menulist.*: New text-based menu entry classes replacing the shape-based
	  ones (except for the MenuEntry, also referenced in game.cc, due to palette
	  concerns) and added menu IDs to entries.
	* exult.*: Command-line loading of mods with "--mod <mod>", modified loading
	  of games to use classes from modmgr; moved some functions to modmgr.*;
	  added "<MODS>" system path configurable in exult.cfg; Exult will now be
	  centered in Windows when not in full-screen mode to prevent window
	  being partially offscreen.
	* game.*, bggame.*, sigame.*, devgame.*: Moved is_installed to modmgr.*,
	  modified game creation to use modmgr.*, mod used is reported in stdout,
	  initial game uses new menu IDs.
	* exultmenu.*: The new menus mentioned above.
	* exult0.pal, *.shp, flx.in: Removed old menu shapes and added fonts for them.
	* cheat.cc: Map-editing loads Exult Studio using the current game and mod.
	* studio.*, exult_studio.glade: Loading of games and mods via dialogs,
	  loading of mods via command line with "-m <mod>" and creation of new
	  mods via dialog. Uses the classes from modmgr.*
	* makefile.*: Added modmgr.*, modified list of *.shp's used.


2006-08-05 Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* configure.ac, desktop/Makefile.am: adapted version of patch #1532621:
	  support alternative dirs for .desktop and icon files
	* docs/exult_studio.1, docs/ucc.1: manpages from patch #1532624

2006-07-30    <jeff@mini.nerble.net>

	* bggame.cc (BG_Game): Added lip-syncing enhancements contributed
	by Eric Wasylishen.

2006-07-20    <jeff@mini.nerble.net>

	* actorio.cc: (Experimentally) Allow chars. >= 127 in NPC names.

2006-06-27  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixing Skara Brae Ferry problem (bug #1521291).

2006-07-16    <jeff@mini.nerble.net>

	* shapes/shapeinf.h (public): Don't divide striking range by 2; I
	think that was a mistake.

2006-07-14    <jeff@mini.nerble.net>

	* rect.h, paths.cc, objs.cc, combat.cc: Avoid attacks through
	walls by checking LOF for striking weapons.

2006-06-27    <jeff@mini.nerble.net>

	* gamemap.cc: Shift-F3 writes out "patch/minimaps.vga", with a
	frame for each game map (192x192 pixels).

2006-06-27  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixing crash (due to terrains not being loaded) and pointer mix-up (causing
	  wrong colors in the generated minimap) in the new minimap generator.

2006-06-26  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed bug where 'stray' items on the ground would be picked up
	  by the carpet even though they shouldn't.

2006-06-14  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* intrinsics.cc: Fixed multimap issue when casting 'mark' on a virtue stone
	  when the stone is not directly on the map.
	* actors.cc, ready.h, objs/contain.cc, mapedit/shapeedit.cc and
	  mapedit/exult_studio.glade: Added an 'usecode container' item type to BG.
	  Also, in 'objs/contain.cc', changed the usecode container detection code
	  to use the item type instead of shape number.

2006-06-11 Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* midi/audio_drivers/mt32emu/i386.cpp: sync with scummvm to make it
	  compile with gcc 4

2006-04-29  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* various: fix delete/delete[] mixups

2006-04-18    <jeff@mini.nerble.net>

	* pathfinder/Zombie.cc: Straight-line pathfinder now works in
	3-dimensions, and combat projectile code allows shooting things at
	any height.

2006-04-07    <jeff@mini.nerble.net>

	* combat.cc: Support 'summon' by certain monsters (mages,
	liches).  Also added teleport, summon, and can-be-invisible flag
	support to ExultStudio and to savegames.

2006-04-08 Dominik Reichardt <dominus@users.sourceforge.net>
	* docs/xml/docs.xml,faq.xml: updated documentation and FAQ
	* docs/ReadMe.html,FAQ.html: updated documentation and FAQ
	* Readme, FAQ: updated

2006-04-05    <jeff@mini.nerble.net>

	* objs/objs.cc: Handle changes to IFIX and terrain objects
	correctly so the changes get saved by EStudio.

2006-03-19  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamemap.cc: Fixed incorrect return value of data size for written strings.

2006-03-05  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* schedule.cc, schedule.h: Tweaked the 'Pace' schedules. Also, greatly
	  modified the 'Patrol' schedule so that it works more like the original.
	* combat.cc: Slightly midified the way opponents are found in combat.
	  Hostile actors will now target friendly actors, which include party
	  members.
	* actors.cc: Oppressors are now set when an NPC's target is set. Also,
	  they are set when an NPC is attacked instead of when it is hurt.
	  Additionally, the avatar will now set the 'blocked' vector if it is
	  moving due to a schedule.
	* actors.cc, usecode/bgintrinsics.h: Allowed several more SI intrinsics
	  for BG; specifically, the intrinsics add_cont_items, clear_item_say,
	  save_pos, teleport_to_saved_pos, set_camera, set_polymorph and
	  infravision can now be used in BG games.
	* usecode/intrinsics.cc: Added reminder to look into 'approach_avatar'
	  intrinsic (seems to actually be 'create_offscreen', but I need to do
	  some further tests to be sure).
	* docs/exult_intrinsics.txt: Full intrinsic documentation describing
	  them as they are implemented in Exult. ALL intrinsics are documented.

2006-03-05    <jeff@mini.nerble.net>

	* objs/egg.cc,etc.: Usecode eggs may be given a function name
	instead of a number.

2006-02-28  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Tweaked speed of 'Talk' schedule a bit. Also, modified 'Pace horizontal'
	  and 'Pace vertical' schedules to better match original games.

2006-02-27  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* BG Keyring Mod and SI Fixes are now licensed under the GNU GPL.
	* For the BG Keyring Mod, I also modified a bit the NPC spellcasting
	  items and routines, and started work in a spellcasting pseudo-AI.

2006-02-26  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed a crash when using 'actor frame' script opcodes.

2006-02-26  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* files/databuf.h: Ryan's cleanup of Pentagram's IFileDataSource::eof()

2006-02-26  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed potential crash introduced by the previous fix.
	* Fixed animated flag for Exult Studio edited/created eggs.

2006-02-25  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed brand-new bug preventing many egg types from correctly hatching.

2006-02-25    <jeff@mini.nerble.net>

	* objs/egg.cc (public): Rewrote so that each egg type has its own
	class. 

2006-02-13  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamemap.cc: Removing some old, unused code.
	* Makefile.common: Fixed wud compile problem under MinGW.

2006-02-20    <jeff@mini.nerble.net>

	* objs/egg.cc,etc:  Support shapes >= 1024 in monster eggs.

2006-02-19    <jeff@mini.nerble.net>

	* tools/wud.cc: Rewrote in C++.  Uses symbol table.
	* usecode/ucsymtbl.cc (Usecode_symbol_table): Support symbol-table
	in compiled usecode.
	* usecode/ucinternal.cc:  Print function names from symbol table.
	* usecode/compiler/ucmain.cc:  Write out symbol table.

2006-02-13  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* combat.cc, ready.h: Make missile weapons really use actual ammo.
	  Triple crossbows now fire magic bolts as they should. They also
	  spend the correct amount of ammo (3) per shot.
	* chunks.cc: Fixed a few dumb mistakes from previous commit.
	* objs/animate.cc: Fixed sound effects in SI, which I had broken
	  previously.

2006-02-12  Marzo Sette Torres Junior <marzojr@yahoo.com>
	Round 1 of de-hard-coding data from Exult.
	* actors.cc: Added support for custom BG-style gumps. Eliminated
	  the hard-coded data about which items get usecode ready/unready
	  events.
	* bggame.cc, sigame.cc: Two new resources in the respective flx
	  files.
	* cheat.cc, cheat_screen.cc: NPCs with mana should recover/be able
	* data/*/*: New de-hard-coded data, and mpdified flx.in files to
	  add them to the correct game flx file.
	* effects.cc: The association shape <> explosion sprite has been
	  moved out.
	* files/msgfile.cc: Lines starting with a ':' will be sequentially
	  auto-indexed.
	* gumps/Face_button.cc, Face_stats.cc: Removed restrictions on
	  which NPCs display faces in the status bar. Also, NPCs with
	  non-zero magic will display a mana bar.
	* gumps/Gump_manager.cc, Gump_manager.h, Paperdoll_gump.h: Added
	  support for BG-style gumps.
	* gumps/Paperdoll_gump.cc: Removed references to old paperdoll
	  data from the file.
	* gumps/Paperdoll_gump_info.cc: Externalized all paperdoll data.
	* keyactions.cc: Support for custom BG-style gumps.
	* server/server.cc, mapedit/exult_studio.glade, npcedit.cc: Added
	  the ability to display an actor's gump from the edit window.
	  Also modified a few things in shape edit window in preparation
	  for adding editing capabilities for newly exported data.
	* objs/chunks.cc: Removed hard-coded data about 'mountain tops'.
	  Seems to work OK.
	* objs/animate.cc, animate.h: Shape <> sfx and shape <> animation
	  info have been moved out.
	* shapes/miscinf.h, miscinf.cc, makefile.am: New file for
	  loading/retrieving the newly de-hard-coded data.
	  to edit it with cheats.
	* shapes/bodies.cc, bodies.h: Deleted the old bodies table,
	  externalized the data in the Is_Body function.
	* usecode/intrinsics.cc: Fixed wrong comment.

2006-02-08    <jeff@mini.nerble.net>

	* schedule.cc (Waiter_schedule): Improvements to this schedule.

2006-02-07  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* usecode/ucinternal.cc: fixed global statics
	* usecode/ucdisasm.cc: fixed global static disassembly

2006-02-06  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* various: don't make get_map/get_map_num segfault when undefined
	* objs/virstone.*: renamed map/pos functions to get/set_target_pos/map

2006-02-05  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* actors.cc: fix crash when actor approaches from off-screen

2006-02-04  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* effects.cc: fix crash for missile without weapon info
	* actors.cc: uninitialized variable

2006-02-04  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Corrected the workings of UI_is_readied and UI_get_readied based
	  on the original games.

2006-02-04  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* objs/objs.*: removed strange ifdefs around certain functions

2006-02-03  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Reorganized BG Keyring Mod with use of new autonumbering system.
	* Modified SI Fixes to use new autonumbering system.

2006-02-03  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* files/databuf.h: StreamDataSource::eof() returns eof before actually
	  having read past the end of file, to make this behave consistently
	  with the other DataSources
	* files/msgfile.*: allow reading text file from DataSource
	* shapes/bodies.cc: read bodies_bg/si from .flx files
	* data/*: moved bodies_bg/si to exult_bg/si.flx

2006-02-03  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* ucparse.yy: Added a way to retrieve the assigned number of a
	  given function. Used like this:
		//If function_name is a defined function, fun will
		//have the correct function number:
		var fun = &function_name;
		//Call function_name indirectly:
		(*fun)();
	* uclex.ll, ucsym.*: Added new '#autonumber' directive to UCC.
	  It turns on 'smart' autonumbering of functions from a given
	  initial value and *ignores* functions with preset function
	  numbers. For example:
		#autonumber 0xC00
		fun1 0xD00 () {/* Code here */}
		fun2 () {/* Code here */}
		fun3 0xA00 () {/* Code here */}
		fun4 () {/* Code here */}
	  This results in fun2 and fun4 having numbers 0xC00 and 0xC01,
	  respectivelly. If the directive is not used, the default
	  ("old-style") autonumbering will be in effect.

2006-02-02  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Added a custom body for Laurianna in the 'BG Keyring Mod'.
	* bodies.cc: Removed checks against old tables.
	* bgintrinsics.h: Added one more SI Intrinsic to BG:
	  create_new_object2.

2006-02-01  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Updating 'SI Fixes' and 'BG Keyring Mod' to use the new #game
	  UCC compiler directive.

2006-02-01    <jeff@mini.nerble.net>

	* usecode/compiler/uclex.ll,etc.:  Added '#game "blackgate"' and
	'#game "serpentisle"' directives to set intrinsics at top of ucc
	source file.  

2006-01-28  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed but with teleport (not intermap) eggs in multimap
	  games.

2006-01-29    <jeff@mini.nerble.net>

	* actors.cc,npcnear.cc,objs.h:  Stop schedules of NPC's who are
	off the current map.

2006-01-28  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed a few bugs for objects with shape # >1023.

2006-01-28  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* cheat_screen.cc: The 'Teleport to NPC' function now moves you
	  to the correct map.
	* objs.h: Added a 'shortcut' get_map_num() member function for
	  easier retrieval of an object's current map.
	* intrinsics.cc, ucinternal.h, bgintrinsics.h, siintrinsics.h:
	  Added intrinsic get_map_num.
	* All files but the header files: Modified to use get_map_num().

2006-01-23  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamedat.cc, gamedat.h: Fixed saving and loading multimap saves
	  with level 2 zip compression. The fix uses internal mapXX files
	  (similar in structure to the GAMEDAT file used for the default
	  map) to store the files in <GAMEDAT>/mapXX dirs. Still need to
	  fix the flex saves for multimap capabilities (tagged with a
	  'TODO:').
	* gamewin.cc: Fixing a rare crash when changing maps followed by
	  F3 teleport.

2006-01-22    <jeff@mini.nerble.net>

	* schedule.cc: Improved 'talk' schedule so that NPC won't talk
	until close, and will call to you like in the original.

2006-01-22  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamedat.cc: Improved the previous fix to make it safer. Note
	  that level 2 compression is still incompatible with multimaps
	  (or, for that matter, so are the flex saves). I am still trying
	  to work out a way to fix that *and* keep compatibility with older
	  saves; relevant sections are tagged with a 'TODO:'. Any takers?
	* gamewin.cc: Fixed bug in loading of multimap games. Basically,
	  only map #0 would be loaded, causing data loss when saving maps
	  or games unless the player visited the other maps.
	* actors.cc: approach_another now moves NPCs to the correct
	  destination map before trying to pathfind.
	
2006-01-21  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed resurrection bug -- using (e.g.) Death Bolt
	  resulted in a body which would not be resurrected, unlike what
	  happened in the original.
	* gamedat.cc: Fixed errors on restoring from multimap savegame
	  or initgame.
	
2006-01-20  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* usecode/intrinsics.cc: Virtue stones should use the map number
	  they are in, not of the map being displayed.

2006-01-14    <jeff@mini.nerble.net>

	* exult.cc: "Combo" selection is now done with single-clicking or
	dragging.  Shapes added are selected, and one can toggle by
	holding down the Control key.  Flat tiles are no longer added.

2006-01-07  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Fixed cache-out bug which prevented eggs from reseting when
	  teleporting between maps.
	* usecode/intrinsics.cc: Multimap support for display_area
	  intrinsic.

2006-01-06  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamedat.cc: Checking for the existance of ireg files before saving
	  them to zip files prevents crashes when saving new maps for existing
	  games.
	* gamemap.cc, objs/virtstone.*, usecode/intrinsics.cc, ucinternal.*:
	  Added multimap support to the following intrinsics:
		update_last_created & move_object (if the location is a 4-element
		array, the 4th element is the map #);
		mark_virtue_stone & recall_virtue_stone (now save/restore the map #);
		save_pos & teleport_to_saved_pos (now save/restore the map #).
	  Virtue stones from older save games still work, and so will (I hope)
	  the saved positions from older SI saves.

2006-01-03  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.h: get_usecode now returns correct value for NPCs with no
	  assigned usecode *and* with a shape# >1023.
	* objs.h: added a virtual get_usecode function which returns correct
	  usecode function for a given shape.
	* usecode/intrinsics.cc, etc.: added new intrinsic to get an object's
	  usecode function number via usecode (mostly to allow the calling of
	  an item's usecode given an item reference to that item).
	  
2005-12-29  Max Horn  <max@quendi.de>

	* configure.ac, debian/, Makefile.am: Removing the debian directory,
	as requested by the debian package maintainer

2005-12-15  Max Horn  <max@quendi.de>

	* alloc.cc, Makefile.am, msvcstuff/Exult.vcproj: Removed alloc.cc.

2005-12-14  Max Horn  <max@quendi.de>

	* configure.ac: Removed several outdated / obsolete configure options.

2005-12-13  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* egg.cc: Set facing for egg-created monsters.

2005-12-12  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* configure.ac, version.cc: netbsd (partial patch #1111951)

2005-12-10  Max Horn  <max@quendi.de>

	* configure.ac: Remove some obsolete warnings.

2005-12-04  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* objs/contain.cc: fix compile error when exult studio disabled

2005-11-19  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* flic/playfli.cc: use sint8/uint8 types instead of char/unsigned char

2005-11-19  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* useval.cc: Fixing a bug I introduced when I fixed the Blacksword's
	  'Fire' power.

2005-11-13    <jeff@mini.nerble.net>

	* shapes/shapevga.cc,etc: Moving defs. around so ExultStudio can
	pass the correct game info. when loading shape data.

2005-10-26  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* useval.cc, ucsched.cc: fixing the Blacksword's 'Fire' power
	  in FoV.

2005-10-25    <jeff@mini.nerble.net>

	* actors.cc: Ready/unready weapon depending on schecule.

2005-10-14    <jeff@mini.nerble.net>

	* readnpcs.cc: New schedules.dat supports z-coord. in pos.

2005-10-09    <jeff@mini.nerble.net>

	* objs/barge.cc (Barge_object): Fixed cart-and-horse animation.

2005-10-04    <jeff@mini.nerble.net>

	* actorio.cc: Save mana/magic for all NPC's.

2005-10-02    <jeff@mini.nerble.net>

	* actorio.cc: Save/restore 2-byte face#.

2005-10-01    <jeff@mini.nerble.net>

	* exult.cc: Watch for game names "blackgate" and "serpentisle".

	* objs/egg.cc (Egg_object): Fixed crash when dropping an egg on
	something else.

2005-08-21    <jeff@mini.nerble.net>

	* gumps/Stats_gump.cc (Stats_gump): Display 'extra' attributes
	defined in usecode.

	* mapedit/shapelst.cc: Fixed bug when importing from Gimp where
	transparency would go away.

2005-08-10    <jeff@mini.nerble.net>

	* actors.h (public): get_attributes() returns list of all
	attribute/value pairs.

	* usecode/intrinsics.cc: get_npc_prop/set_npc_prop can get/set
	generic attributes if you pass a name as the property.

2005-08-06  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Changed the way BG paperdolling is handled to use a 'paperdol.vga' file.
	  Paperdoll patches are now possible in BG too.

2005-08-02    <jeff@mini.nerble.net>

	* shapes/bodies.cc: Use text files for getting body shapes.

2005-07-24    <jeff@mini.nerble.net>

	* usecode/ucinternal.cc: In SI, 'path_run_usecode' should have the
	companions follow (fixes ice-raft).

	* actions.cc (std): At end of path-walking, gather up followers.

	* actors.cc,drag.cc:  Call readied/unreadied usecode in more
	places so that SI special items (belt-of-strength, etc.) work properly.

2005-07-18  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed bug which prevented frame from being correctly set when
	  creating new NPCs.
	* objs/objs.cc: Fixed bug while editing objects contained by other objects.
	* mapedit/objedit.cc, npcedit.cc: Added support for dragging shapes >1024.
	* All other files: Added support for extended editing of container objects
	  (i.e., editing resistance, 'invisible' and 'okay_to_take' flags).

2005-07-17    <jeff@mini.nerble.net>

	* combat.cc: Improvements to weapon-readying so that monsters are
	better-equipped. 

2005-07-17  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* gamewin.cc: Fixed small bug with dont_move flag in BG.
	* intrinsics.cc: Allowed bg_dont_move flag to work like SI's dont_move flag
	  when it is toggled (i.e., take Avatar out of combat mode). Also allowed
	  invisible flag to be set for all objects.
	* objs.cc: Fixed small bug which prevented detection of invisible objects
	  with find_nearby using mask 0x20.

2005-07-16  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed crash when there was no attacker.
	* intrinsics.cc: Fixed real cause of the super-cannon bug -- LOOP opcode
	  should not loop if the variable hasn't been initialized (verified in the
	  original, but with the add-ons only).
	* objs.cc, effects.cc: Undid one change in each which became unnecessary now
	  that the real cause of the super-cannon bug has been found. Also, slightly
	  tweaked Projectile_effect for the benefit of traps.

2005-07-15    <jeff@mini.nerble.net>

	* usecode/ucinternal.cc: Added support for indirect calls.
	Example:
	var fun = fun1;
	(*fun)(3);
	fun = fun + 1;
	(*fun)(17);

2005-07-15  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed bug I introduced in which dueling NPCs would slaughter
	  each other and then attack the avatar.
	* objs.cc, objs.h: Fixed bug I introduced about container hit points.
	* effects.cc: Changed to use the new get_effective_obj_hp function.
	* animate.cc: Added a few new shape sound effects.

2005-07-13  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* game.cc: fix crashing german BG (its IDENTITY is "ULTIMA7")

2005-07-11  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/studio.h, etc: Implemented game detection code and ready spots.
	  I am trusting exult.cfg to be accurate, which I am not sure is wise :-)
	* objs.cc, etc: In fixing the cannon, I broke the Test of Virtue. Both work
	  now. Powderkegs are now dangerous to attack, as in the original.

2005-07-10  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapes/shapeinf.h, mapedit/exult_studio.glade, shapeedit.cc: Corrected
	  damage type (from 'poison' to 'lightning') and added two other damage
	  types ('ethereal' and 'sonic') and immunities -- both of which are used
	  in BG, but not in SI. Also, left shapeedit.cc pratically ready to get
	  'ready spots' working (it does for BG already).
	* actors.cc: Implemented immunities/vulnerabilities. Also allowed actors
	  with cant_die flag to appear to be wounded (flash with red outline), as
	  in the original. Last, prevented party members from calling the guards if
	  they die because of the Avatar.

2005-07-09    <jeff@mini.nerble.net>

	* mapedit/npclst.cc (Npc_chooser): Added NPC browser.

2005-07-10  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* mapedit/exult_studio.glade, shapeedit.cc: New info from weapons.dat and
	  ammo.dat can now be edited in Exult Studio. Also, modified the 'ready spot'
	  menu from 'Shape Info' window in preparation to getting it to work.
	* content/sifixes/resurrect.uc: Fixed resurrection bug when target NPC was
	  alive but in the House of the Dead.

2005-07-08  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Implemented missile rotation and speed, using data from weapons.dat; this
	  data is now saved and loaded correctly.
	* Modified the animation speed of attacks; it now uses get_std_delay to
	  determine speed.
	* Modified very slightly the way attack frames are handled.
	* Fixed initialization bug of casting frames.

2005-07-05  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Allow si_tournament to be used in BG. Also, introduced bg_dont_move
	  flag for BG, which works like dont_move does in SI. Finally, updated
	  the cheat screen's flag names to reflect the flag names as they are
	  defined in "flags.h".
	* Implemented the use of casting frames when casting spells. Also added
	  a new intrinsic called 'begin_casting_mode' which activates the use of
	  casting frames for a given NPC (added mostly for scripting purposes).

2005-07-05  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Modified the SI Fixes source files to use the new intrinsic calling
	  method ('->'). Also, removed duplicate (unused) files.
	* actors.cc: NPCs should only react if the weapon actually does something
	  to them.

2005-07-05    <jeff@mini.nerble.net>
	* usecode/compiler/*.{cc,h}: Allow intrinsics to be called as
	'methods', so that the following are equivalent:
		c = UI_get_item_flag(item, 10);
		c = item->get_item_flag(10);
		c = get_item_flag(10);

2005-07-03  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* Modified detection of 'delayed blast' projectile, as it was too inclusive
	  before. I also am interpreting its lack of projectile data to mean it
	  should not be rendered. This matches the original.
	* Modified the way SI sleep arrows work to better match the original.

2005-07-04  Ryan Nunn  <colourles@users.sourceforge.net>
	* exult.cc : Ensure Audio is deinitialized on exit
	* audio/midi_drivers/LowLevelMidiDriver.cpp, 
	  audio/midi_drivers/XMidiFile.cpp : Small changes to MT32 display handling

2005-07-03    <jeff@mini.nerble.net>

	* When equipping monsters, give them ammo for their weapons.
	* When an NPC can't pathfind to an enemy in combat, just let him
	wander a short way towards the enemy before retrying.

2005-07-03  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc, shapes/shapeinf.h: Modified constant names and used them for attack
	  frames. Also changed the default attack sequence for when there is no weapon.
2005-07-03  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc, shapes/shapeinf.h: Implemented weapon-dependent frame sequences
	  for attacks
	* effects.cc, effects.h: Slightly modified the way burst arrows are handled,
	  eliminated some hard-coded data about explosion sizes and moved the definition
	  of Get_explosion_shape out of Explosion_effect class.
2005-07-02  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* shapes/shapeinf.cc, etc: Added capabilities to read/save some previously
	  unknown data from ammo.dat and fixed minor bug on saving weapons.dat
	* effects.cc: Modified to use newly decoded ammo.dat info, modified Death
	  Vortex to more closely resemble original and implemented Energy Mist (the
	  latter two share the same code)
	* actors.cc: Modified how explosives work on hit; includes modifications for
	  Death Vortex and Energy Mist; now uses new ammo.dat info to determine if
	  missiles should be dropped on hit/miss.
	* content/sifixes (several): Prevent Serpent Bond from smuggling companions
	  to Dream World in SI

2005-07-01  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* data/bg/fellowshipstaff.shp: new version by Crysta
	* data/bg/lightning_whip.shp: new art by Crysta

2005-07-01  Marzo Sette Torres Junior <marzojr@yahoo.com>
	* actors.cc: Fixed weapon frames, modified behaviour of explosives
	* effects.cc, effects.h: fixed explosives, and modified their
	  behaviour a bit
	* usecode/ucsched.cc: Fixed next_frame_max and npc_frame opcodes
	* content/sifixes/src/spells.uc: Fixed dumb bug in modified Vibrate
	  spell

2005-06-30  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* usecode/useval.cc: fix truncated strings when concatenating

2005-06-26    <jeff@mini.nerble.net>

	* mapedit/shapelst.cc,etc:  Rewrote shape-browser renderer so
	scrolling works correctly.

2005-06-21  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* data/bg/spiked_shield.shp: fixed transparency, added back by Crysta

2005-06-16  Tristan Tarrant <nadir@users.sourceforge.net>
	* files/rwregress.cc: removed use of deprecated strstream and
	  used sstream instead

2005-06-15  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* audio/Midi.cc: fix crash on exit when midi is disabled
	* data/bg/faces.shp: new Julia face by Berty Zhang
	* data/bg/gorget.shp: updated gorgets/collars by Crysta

2005-06-15  Ryan Nunn  <colourles@users.sourceforge.net>
	* game.cc : Set 'game_type' to NONE when in the Exult Menu
	* audio/midi_drivers/XMidiSequence.cpp, audio/midi_drivers/XMidiFile.*,
	  audio/midi_drivers/LowLevelMidiDriver.* : Improvements and fixes for 
	  when using Exult with a Real MT32 (avoiding Buffer Overflows and 
	  pauses)

2005-06-14  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* sigame.cc, bggame.cc: more constants from flex headers

2005-06-13  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* data/bg/various: new art by 'Crysta the Elf'
	* sigame.cc, bggame.cc: use constants from headers instead of fixed numbers

2005-06-13  Ryan Nunn  <colourles@users.sourceforge.net>
	* audio/midi/TimidityMidiDriver.cpp : Report Timidity Error messages
	  if initiliaztion fails
	* audio/midi_drivers/FluidSynthMidiDriver.*, 
	  audio/midi_drivers/Makefile.am, audio/midi_drivers/MidiDriver.cpp : 
	  New FluidSynthMidiDriver borrowed from ScummVM. Needs FluidSynth to 
	  work (obviously). Define USE_FLUIDSYNTH_MIDI to compile it in.
	  
2005-06-13  Tristan Tarrant <nadir@users.sourceforge.net>
	* mouse.h: include gamewin.h
	* audio/midi_drivers/Makefile.am: add include path so it can find flags.h
	* audio/midi_drivers/XMidiFile.cpp: make it compile on 64bit

2005-06-12  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* data/bg/faces2.shp: new Sentri face by Berty Zhang

2005-06-12  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* audio/midi_drivers/various: compilation fixes, sync with pentagram

2005-06-07  Ryan Nunn  <colourles@users.sourceforge.net>
	* headers/pent_include.h : Header for 'seemlessly' integrating
	  Pentagram code into Exult
	* istring.* : Pentagram::istring class
	* autoconf.in : Added ALSA midi option (from Pentagram) and updated 
	  Timidty code to be the same as Pentagram.
	* Makefiles : Hopefully updated to a working state for all platforms
	
	* New Midi System using the Pentagram code. 
	* Big changes to the way music is handled internally
	* OGG Vorbis support no longer replaces Midi support
	* MT32 Sysex is now supported
	* Added All Pentagram Midi Drivers
	* Added 'mt32emu' Midi Driver. Needs USE_MT32EMU_MIDI defined, and 
	  needs files "MT32_CONTROL.ROM" and "MT32_PCM.ROM" to be placed
	  in the Exult data directory to work (where the files are needed
	  might be changed). This is not compiled by default.
	* Removed some midi drivers.
	* Attempted to update midi drivers so they will compile
	* The "none" Midi Conversion option is now "mt32" and is used to 
	  specify that the device should be treated as a real mt32 device.
	  Effect: No patch conversion and will send sysex
	* New Midi Conversion option "fakemt32" to specify the device as a 
	  device is not a real mt32, but uses mt32 patches.
	  Effect: No patch conversion and will NOT send sysex
	* New config key "config/audio/midi/use_oggs" to specify if to use
	  ogg vorbis digital music
	* Audio options gump modified. 'Midi Conversion' option changed to
	  'Device Type'
	* And probably countless other things too that i can't remember at 
	  this time
	  
2005-06-05    <jeff@mini.nerble.net>

	* usecode/intrinsics.cc: Show Guardian, Serpent faces when speech
	occurs. 

2005-05-05    <jeff@mini.nerble.net>

	* usecode/intrinsics.cc: Implemented set_orrery using information
	discovered by Marzo Torres.

2005-05-04    <jeff@mini.nerble.net>

	* usecode/bgintrinsics.h: Added several SI usecode intrinsics for
	use in BG mods.

2005-05-03    <jeff@mini.nerble.net>

	* usecode/intrinsics.cc: Added 'close_gump()' intrinsic.

2005-05-02    <jeff@mini.nerble.net>

	* usecode/ucfunids.h,etc: Added Usecode support for shape #'s >=
	0x400.  In the usecode compiler use "shape#(n)" for the function #.

2005-04-30  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* drag.cc: check if gump's owner exists before using it

2005-04-28  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* files/msgfile.cc, shapes/items.cc: strip CR's from end of line

2005-04-26  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* usecode/ucinternal.*: reset all statics when loading

2005-04-20    <jeff@mini.nerble.net>

	* usecode/ucinternal.cc: Increase max. # of global flags to 2048.
	* usecode/compiler/ucmain.cc: Look up include dir from UCC_INCLUDE
	env. var.

2005-03-27    <jeff@mini.nerble.net>

	* cheat.cc (Cheat): Ctrl-arrow keys will move entire chunks when
	in "Select chunks" mode.

2005-03-12    <jeff@mini.nerble.net>

	* data/exultmsg.txt: Applied "international support" patch from
	dk@pollodigomma.net.

2005-02-18    <jeff@mini.nerble.net>

	* gumps/Notebook_gump.cc: Add text automatically from
	"autonotes.txt" when a global flag is set.

2005-02-14	Darke <darkepaw@users.sf.net>
	* hash_utils.h: Hugely complex gcc4.0pre fixes.

2005-01-23    <jeff@mini.nerble.net>

	* game.cc (Game): Command-line option --write-xml causes game
	config. to be written to 'patch/exultgame.xml'.
	(Game): If 'patch/exultgame.xml' exists, Exult uses that instead
	of manually adding resources.

2005-01-16    <jeff@mini.nerble.net>

	* shapes/font.cc: Don't skip linefeeds when handling spaces.
	(Needed for notebook, and I hope this doesn't mess up conversations.)

	* gumps/Notebook_gump.cc (Notebook_gump): Working on auto-paging.

2005-01-15  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* forked_player.cc: fixed execlp call (patch #1101126)

2005-01-13    <jeff@mini.nerble.net>

	* gumps/Notebook_gump.cc (Notebook_gump): Online journal support
	(hit 'n' for 'notebook').

2004-12-29  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* exult.cc: don't let avatar move if right clicking on gump to close it
	  (based on patch #1088000)
	* exult.cc: wait for possible dblclick before showing item info when
	  not in map-edit mode (based on patch #1088157)
	* exult.cc: don't accept click/dblclick when mouse moved too far
	  (based on patches #1088144 and #1088230)

2004-12-01    <jeff@mini.nerble.net>

	* mapedit/objedit.cc,etc.:  Added 'rotate' button to obj-edit dialog.

2004-10-16    <jeff@mini.nerble.net>

	* mapedit/bargeedit.cc: EStudio dialog for adding a barge.

2004-10-07    <jeff@mini.nerble.net>

	* objs/contain.cc: Use gump # from 'containers.dat' for given
	container.  (Not really tested yet.)  Support has also been added
	to ExultStudio for setting a shape's associated gump shape.

2004-09-19    <jeff@mini.nerble.net>

	* mapedit/shapeedit.cc, shapes/items.cc, files/msgfile.cc: Support
	more than 1024 shapes in item names by storing messages in
	"textmsg.txt".

2004-09-18    <jeff@mini.nerble.net>

	* shapes/items.h,etc: Reorganized lists of text to prepare for
	supporting >1024 shapes.

2004-09-13    <jeff@mini.nerble.net>

	* schedule.cc:  Support thief schedule.

2004-09-06    <jeff@mini.nerble.net>

	* gamemap.cc,Flex.cc,Flex.h: Write Vers2 u7ifix files, so that
	shapes >1023 are supported.

2004-09-05    <jeff@mini.nerble.net>

	* gamemap.cc: Added code to read Vers.2 entries (although we don't
	write them yet).

2004-08-29    <jeff@mini.nerble.net>

	* shapes/shapevga.cc (Shapes_vga_file): Resize 'info' list when a
	new shape is added.

2004-08-28    <jeff@mini.nerble.net>

	* shapeid.cc (Shape_manager): Set up shape info. entries for the
	SI Avatar shapes here.
	* shapes/shapevga.h:  No longer have to check for the SI Avatar shapes.

2004-08-27    <jeff@mini.nerble.net>

	* gamemap.cc, objs/*:  Save/restore ireg. objs. with shape # >= 1024.

2004-08-14 Dominik Reichardt <dominus@users.sourceforge.net>
	* docs/xml/docs.xml,faq.xml: updated documentation and FAQ
	* docs/xml/html.xsl: got rid of another pointer to our ML
	* docs/ReadMe.html,FAQ.html: updated documentation and FAQ
	* Readme, FAQ: updated
	* ReadMe.1st: got rid of another pointer to our ML
	
2004-08-06    <jeff@mini.nerble.net>

	* drag.cc (Dragging_info): Avoid dropping an object where it is no
	longer accessible.

2004-08-05  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* Spellbook_gump.cc: use real infinity symbol in SI
	* Spellbook_gump.cc: show infinity (in SI) or 99 (in BG) in wizard mode

2004-08-03  Max Horn  <max@quendi.de>

	* exult.cc: Don't set icon on OS X; the external icon is *much* nicer.

2004-07-11    <jeff@mini.nerble.net>

	* actors.cc,combat.cc,etc.:  Support for 'charmed' flag.

2004-07-04    <jeff@mini.nerble.net>

	* gamemap.cc,iregobjs.cc, etc.:  Save/restore pos. of items within
	their containers.

2004-07-03    <jeff@mini.nerble.net>

	* cheat.cc (public): When creating an object with <insert>, place
	it on the ground instead of in inventory.

2004-06-29    <jeff@mini.nerble.net>

	* actors.cc: Teleport NPC to schedule if not on current map.
	* Lots:  move() methods take a 'newmap' parameter.

2004-06-29  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* shapes/vgafile.*: removed limit of 255 frames in a shape.
	  (Note that this does not remove the limit in ShapeID)

2004-06-27    <jeff@mini.nerble.net>

	* actorio.cc: NPC's get saved/restored on proper map.

2004-06-26    <jeff@mini.nerble.net>

	* Merged in multiple-map support.
	* Merged in use of dexterity and wand charges.
	* Merged in builtin groups in ExultStudio.

2004-06-17  Willem Jan Palenstijn <wjpalenstijn@users.sourceforge.net>
	* mapedit/Makefile.am, ucxt/data/Makefile.am: fixed makefile problems

2004-06-07  Ryan Nunn  <colourles@users.sourceforge.net>
